#include "stdafx.h"

#include "elem.h"
//#include "../Para/Paraelem.h"

CMapStringToPtr s_TheDefaultSymbols;
CMapStringToOb s_MathSymbMapTable;

int nSpace1 = 1;
int nDotStp = 1;
int nEqtWd = 600;

BOOL CMSUnknown::SendMsg(int sig, CObject* obj)
{
	switch(sig) {
		case MSG_ADD_MENU:
			if(obj->IsKindOf(RUNTIME_CLASS(CMenu))) {
				CMenu *pmn = (CMenu*) obj;
				CMenu *pSmn = GetPopupMenu(FALSE);
				pmn->AppendMenu(MF_POPUP, (UINT)pSmn->m_hMenu, "&operator");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_PLUS, "plus \'&+\'");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_NEG, "negative \'&-\'");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_MULT, "multiply \'&*\'");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_DIV, "divide \'&/\'");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_DERIV, "&deriv");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_INT, "&integer");

				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_EQUAL, "&=");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_GT, "&>");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_LT, "&<");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_GE, "&>=");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_LE, "&<=");

				pSmn = GetPopupMenu(FALSE);
				pmn->AppendMenu(MF_POPUP, (UINT)pSmn->m_hMenu, "&default var");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_IND_X, "ind var (space 1) &x");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_IND_Y, "ind var (space 2) &y");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_IND_Z, "ind var (space 3) &z");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_IND_T, "ind var (time) &t");

				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_IND_I, "index (space 1) &i");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_IND_J, "index (space 2) &j");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_IND_K, "index (space 3) &k");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_IND_N, "index (time) &n");
				
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_IND_DX, "ind var (space 1) dx");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_IND_DY, "ind var (space 2) dy");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_IND_DZ, "ind var (space 3) dz");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_IND_DT, "ind var (time) dt");

				CViecFC *anc = GetAncestor();
				if(anc) {
					CSuitCase sc;
					CStringArray varAry;
					CViecFCList list;
					sc.m_case = &varAry;
					sc.m_runtimeClass = RUNTIME_CLASS(CMSIndep);
					sc.m_oblist = &list;
					anc->SendMsg(MSG_COLLECT_OBJECT, &sc);

					pSmn = GetPopupMenu(FALSE);
					pmn->AppendMenu(MF_POPUP, (UINT)pSmn->m_hMenu, "&dep var");
					pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_IND_X, "dep var u");
				}
			}
			return TRUE;
		case MSG_COMMAND:
			{
				CSuitCase *pSC = (CSuitCase*) obj;
				CSymbInst *pSI = (CSymbInst*) pSC->m_case;
				CSymbInst *pSI2;
				char *pc = NULL;
//				POSITION pos;

				if(!pSC->IsKindOf(RUNTIME_CLASS(CSuitCase)) ||
				  !pSI || !pSI->IsKindOf(RUNTIME_CLASS(CSymbInst)))
					return 0;
				switch(pSC->m_int) {
					case CMD_AN_UNKNOWN_TO_NEG:	if(!pc) pc = "-?";
						pSI->ChangeInst(pc);
						pSI2 = new CSymbInst("?");
						pSI->AddTail(pSI2);
						pSI->OnCreated();
						pSI->CalcExt(dirDown);
						pSI->GetParent()->SetExtent(CRect(0,0,0,0));
						pSI->GetParent()->CalcExt();
						pSI->InvalidateRect(CPoint(0,0));
						return 1;
					case CMD_AN_UNKNOWN_TO_PLUS:	pc = "+";
					case CMD_AN_UNKNOWN_TO_MULT:	if(!pc) pc = "*";
					case CMD_AN_UNKNOWN_TO_DIV:		if(!pc) pc = "/";
					case CMD_AN_UNKNOWN_TO_DERIV:	if(!pc) pc = "deriv";
					case CMD_AN_UNKNOWN_TO_EQUAL:	if(!pc) pc = "==";
					case CMD_AN_UNKNOWN_TO_GT:	if(!pc) pc = ">";
					case CMD_AN_UNKNOWN_TO_LT:	if(!pc) pc = "<";
					case CMD_AN_UNKNOWN_TO_GE:	if(!pc) pc = ">=";
					case CMD_AN_UNKNOWN_TO_LE:	if(!pc) pc = "<=";
						pSI->ChangeInst(pc);
						pSI2 = new CSymbInst("?");
						pSI->AddTail(pSI2);
						pSI2 = new CSymbInst("?");
						pSI->AddTail(pSI2);
						pSI->OnCreated();
						pSI->CalcExt(dirDown);
						pSI->GetParent()->CalcExt();
						pSI->InvalidateRect(CPoint(0,0));
						return 1;
					case CMD_AN_UNKNOWN_TO_IND_X:	pc = "x";
					case CMD_AN_UNKNOWN_TO_IND_Y:	if(!pc) pc = "y";
					case CMD_AN_UNKNOWN_TO_IND_Z:	if(!pc) pc = "z";
					case CMD_AN_UNKNOWN_TO_IND_T:	if(!pc) pc = "t";
					case CMD_AN_UNKNOWN_TO_IND_DX:	if(!pc) pc = "dx";
					case CMD_AN_UNKNOWN_TO_IND_DY:	if(!pc) pc = "dy";
					case CMD_AN_UNKNOWN_TO_IND_DZ:	if(!pc) pc = "dz";
					case CMD_AN_UNKNOWN_TO_IND_DT:	if(!pc) pc = "dt";
					case CMD_AN_UNKNOWN_TO_IND_I:	if(!pc) pc = "i";
					case CMD_AN_UNKNOWN_TO_IND_J:	if(!pc) pc = "j";
					case CMD_AN_UNKNOWN_TO_IND_K:	if(!pc) pc = "k";
					case CMD_AN_UNKNOWN_TO_IND_N:	if(!pc) pc = "n";
						pSI->ChangeInst(pc);
						pSI->OnCreated();
						pSI->CalcExt();
						pSI->InvalidateRect(CPoint(0,0));
						return 1;
					case CMD_AN_UNKNOWN_TO_INT:
						{
							CMSInteger *pint = new CMSInteger;
							GetAncestor()->SubstChild(pSI, pint, dirDown);
							pint->SetFocus(TRUE);
//							GetAncestor()->OnDelete(pSI);
							delete pSI;
							pint->CalcExt();
							pint->InvalidateRect(CPoint(0,0));
						}
						return 1;
				}
			}
			return FALSE;
	}
	return CMathSymb::SendMsg(sig, obj);
}

CRect CMSMatrix::ToCalcExt(CSymbInst *ps, dirMode dir)
{
	CRect r(0,0,0,0), r0;
	CDC *pdc = GetDC();
	long right=0,bottom=0,top=0, right2=0;

	CSize s(0,0);
	if(pdc) {
		SetFont(pdc, GetnDot(ps->GetLevel(), m_nDot), GetFont(), m_nCharSet, m_nItalic);
		s = pdc->GetTextExtent(GetName(), GetNameLen());
		r.top = -s.cy/2;
		r.right = s.cx;
		r.bottom = s.cy-s.cy/2;
		s = pdc->GetTextExtent(",", 1);
		ReleaseDC(pdc);
	}

	CViecFC *peq;
	POSITION pos;
	pos = ps->FindIndex(0);
	if(pos) {
		peq = (CViecFC *) ps->GetAt(pos);
		if((peq->GetExtent().top) > r.top)
			peq->SetOrg(CPoint(r.right+right2, peq->GetExtent().bottom));
		else
			peq->SetOrg(CPoint(r.right+right2, r.bottom));
		if(dir==dirDown) peq->CalcExt(dir);
		r0 = peq->GetExtent();
		bottom = r0.bottom>bottom? r0.bottom : bottom;
		right2 += r0.right;
	}
	pos = ps->FindIndex(1);
	if(pos) {
		right2 += s.cx + 1;
		peq = (CViecFC *) ps->GetAt(pos);
		if((peq->GetExtent().top) > r.top)
			peq->SetOrg(CPoint(r.right+right2, peq->GetExtent().bottom));
		else
			peq->SetOrg(CPoint(r.right+right2, r.bottom));
		if(dir==dirDown) peq->CalcExt(dir);
		r0 = peq->GetExtent();
		bottom = r0.bottom>bottom? r0.bottom : bottom;
		right2 += r0.right;
	}
	///////////////////////////
	//Class CMatrix3ڂIndeẍ̗ŌvZB
	//A.Fujita 990302
	pos = ps->FindIndex(2);
	if(pos) {
		right2 += s.cx + 1;
		peq = (CViecFC *) ps->GetAt(pos);
		if((peq->GetExtent().top) > r.top)
			peq->SetOrg(CPoint(r.right+right2, peq->GetExtent().bottom));
		else
			peq->SetOrg(CPoint(r.right+right2, r.bottom));
		if(dir==dirDown) peq->CalcExt(dir);
		r0 = peq->GetExtent();
		bottom = r0.bottom>bottom? r0.bottom : bottom;
		right2 += r0.right;
	}
	///////////////////////////
/*
	pos = ps->FindIndex(0);
	if(pos) {
		peq = (CViecFC *) ps->GetAt(pos);
		if(peq->GetExtent().bottom > (-r.top))
			peq->SetOrg(CPoint(r.right, -peq->GetExtent().bottom));
		else
			peq->SetOrg(CPoint(r.right, r.top));
		if(dir==dirDown) peq->CalcExt(dir);
		r0 = peq->GetExtent();
		top = r0.top;
		right = r0.right;
	}
*/
/*
	pos = ps->FindIndex(3);
	if(pos) {
		right2 += s.cx + 1;
		peq = (CViecFC *) ps->GetAt(pos);
		if((peq->GetExtent().top) > r.top)
			peq->SetOrg(CPoint(r.right+right2, peq->GetExtent().bottom));
		else
			peq->SetOrg(CPoint(r.right+right2, r.bottom));
		if(dir==dirDown) peq->CalcExt(dir);
		r0 = peq->GetExtent();
		bottom = r0.bottom>bottom? r0.bottom : bottom;
		right2 += r0.right;
	}
*/

	r.top += top;
	r.right += (right>right2)? right : right2;
	r.bottom += bottom;
	ps->SetExtent(r);
	return r;
}

void CMSMatrix::ToDraw(CSymbInst *pInst, CDC *pdc, const CPoint& shift)
{
	CPoint p0 = shift;

	pInst->SetFont(pdc, GetnDot(pInst->GetLevel(), m_nDot), GetFont(), m_nCharSet, m_nItalic);
	CSize s = pdc->GetTextExtent(GetName(), GetNameLen());
	pInst->SetPen(pdc, PS_SOLID, 1, RGB(0,255,0));
	if(pInst->m_bFocus) pdc->SetTextColor(RGB(0,0,255));
	else pdc->SetTextColor(RGB(0,0,0));
	CRect r=pInst->GetExtent();
	pdc->TextOut(shift.x, shift.y-s.cy/2, GetName());
	pdc->SetTextColor(RGB(0,0,0));

	p0.Offset(-pInst->GetOrg());
	pInst->SetOldGdiObject(pdc);

	POSITION pos;
	pInst->OnDrawChild(pdc, p0);

	CViecFC *pelem;
	if(pInst->GetCount()==2) {
		pos = pInst->FindIndex(0);
		pelem = pInst->GetAt(pos);
		p0 = shift;
		p0.Offset(pelem->GetOrg());
		r = pelem->GetExtent();
		p0.x += r.right+1;
		s = pdc->GetTextExtent(",", 1);
		p0.y -= s.cy/2;
		pdc->TextOut(p0.x, p0.y, ",", 1);
	}
}

CMathSymb::SetDimension(BYTE dim0, BYTE dim1, BYTE dim2, BYTE dim3)
{
	m_dimension[0] = dim0;
	m_dimension[1] = dim1;
	m_dimension[2] = dim2;
	m_dimension[3] = dim3;
	return TRUE;
}

void CMathSymb::OnDraw(CDC *pdc, const CPoint& p)
{
	COLORREF rgb;
	CPoint p0=p;
	p0.Offset(m_org);
	CRect r0=m_extent;
	r0.OffsetRect(p0);

	rgb = m_bFocus? RGB(0,0,255) : RGB(0,0,0);

	SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
	CString str = GetName();
	CSize sz = pdc->GetTextExtent(str, lstrlen(str));
	pdc->SetTextColor(rgb);
	pdc->TextOut(p0.x, p0.y+m_extent.top, str);
	if(m_bDrag) {
		pdc->SetTextColor(RGB(0,0,0));
		p0.Offset(TheDrag.LastOffset());
		pdc->TextOut(p0.x, p0.y+m_extent.top, GetName());
	}
	OnDrawChild(pdc, p);
}

int CMathSymb::CalcExt(dirMode dir)
{
	CRect extent = m_extent;
	CViecFC::CalcExt(dir);
	CDC *pdc = GetDC();
	if(pdc) {
		SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
		CString str = GetName();
		CSize sz = pdc->GetTextExtent(str, lstrlen(str));
		ReleaseDC(pdc);
		CRect ext;
		ext.left = 0;
		ext.top = -sz.cy/2;
		ext.right = sz.cx;
		ext.bottom = sz.cy-sz.cy/2;
		if(m_extent.left>ext.left) m_extent.left = ext.left;
		if(m_extent.top>ext.top) m_extent.top = ext.top;
		if(m_extent.right<ext.right) m_extent.right = ext.right;
		if(m_extent.bottom<ext.bottom) m_extent.bottom = ext.bottom;
	}
	
	if(dir==dirUp && m_parent) m_parent->CalcExt(dir);
	if(extent!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = extent;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return 0;
}

CSymbInst::CSymbInst(PETCHAR ss)
{
//	m_symbName = CString(ss);
	m_petSymbName = GetNewTChar(ss, NULL);
	m_pSymb = NULL;
	m_level = 0;
	m_int = 1;
	m_bEncap = FALSE;
	SetMode(modeOpen);
}

CSymbInst::~CSymbInst()
{
}


BOOL CSymbInst::ChangeInst(PETCHAR ss)
{
//	m_symbName = CString(ss);
	m_petSymbName = GetNewTChar(ss, m_petSymbName);
	m_pSymb = NULL;
	return TRUE;
}

int CSymbInst::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	switch(nChar) {
	case VK_UP:
		m_int += 1;
		m_extent.right++;
		CalcExt();
		return TRUE;
	case VK_DOWN:
		m_int -= 1;
		if(m_int<0) m_int = 0;
		m_extent.right++;
		CalcExt();
		return TRUE;
	}
	return CPElem::OnKeyDown(nChar, nRepCnt, nFlags);
}

CIElem * CSymbInst::GetNewInst()
{
	CIElem *newInst = new CEquInst;
	newInst->SetDragAllow(TRUE);
	return newInst;
}

CSymbInst::CSymbInst(CViecFC* pms)
{
	m_petSymbName = NULL;
	if(pms) {
		m_petSymbName = GetNewTChar(pms->GetName(), m_petSymbName);
	}
	m_pSymb = pms;
	m_int = 1;
	m_double = 0;
	m_level = 0;
	m_bEncap = FALSE;
}

BOOL CSymbInst::OnDelete(CViecFC *el)
{
	BOOL rt = CPElem::OnDelete(el);
	if(m_pSymb == el) {
		m_pSymb = GetElemByName("?");
		return rt;
	}
	CViecFC *sym = (CViecFC *) GetSymbBody();
	if(sym && sym->IsKindOf(RUNTIME_CLASS(CViecFC))) {
		CSuitCase SC;
		SC.m_case = this;
		SC.m_case2 = el;
		return sym->SendMsg(MSG_ON_DELETE, &SC);
	}
	return rt;
}

int CSymbInst::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	if(m_pSymb==NULL) {
		CDC *pdc = GetDC();
		m_extent = GetTextExtent(pdc, GetSymbName(), GetSymbNmLen());
		ReleaseDC(pdc);
		return 0;
	}
	CViecFC *sym = m_pSymb;
	CRect r = sym->ToCalcExt(this, dir);
	if(r==CRect(-1,-1,-1,-1))
		return 0;
	if(dir==dirUp && m_parent) m_parent->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return 1;
}

void CSymbInst::CopyBody(CViecFC *pelm)
{
	CPElem::CopyBody(pelm);
	CSymbInst *pCp = (CSymbInst *) pelm;
	pCp->m_petSymbName = GetNewTChar(GetSymbName(), pCp->m_petSymbName);
	pCp->m_pSymb = NULL;
	pCp->m_level = m_level;
	pCp->m_int = m_int;
}

void CSymbInst::SerializeBody(CArchive& ar)
{
	WORD nLen;
	CPElem::SerializeBody(ar);
	if(ar.IsStoring()) {
		nLen = GetSymbNmLen();
		ar << nLen;
		ar.Write(*m_petSymbName, nLen);
		ar << (WORD) m_level;
		ar << (WORD) m_int;
	} else {
		CString str;
		WORD w;
		ar >> nLen;
		ar.Read(str.GetBufferSetLength(nLen), nLen);
		m_petSymbName = GetNewTChar(str, m_petSymbName);
		ar >> w; m_level = w;
		ar >> w; m_int = w;
	}
}

BOOL CSymbInst::OnCreated(EnumOnCreated bSkp)
{
	BOOL bFirst = TRUE;
	CPElem *pbx;
	COperatorFolder *pOp;
	CViecFC *psm, *sym;
	CMathSymb *pmo;
	CRuntimeClass *rtc;
	void *pvd;
	CString key;
	CObject *pObj;
	POSITION pos;

	CString nm = GetSymbName();

	sym = NULL;
	pbx = NULL;
	pOp = NULL;
	if(bSkp==SKIP_IF_CREATED 
		&& m_pSymb && m_bCreated 
		&& m_pSymb->IsKindOf(RUNTIME_CLASS(CViecFC))
		&& ((CViecFC*)m_pSymb)->GetName()==nm 
		&& bSkp==SKIP_IF_CREATED) {
	} else if(s_MathSymbMapTable.Lookup(nm, pObj)) {
		m_pSymb = (CViecFC *) pObj;
	} else {
		psm = (CViecFC*) GetAncestor();
		if(s_TheDefaultSymbols.Lookup(nm, pvd))
			pbx = (CPElem*) psm->GetElemByName("Operator");
		if(sym==NULL)
			sym = GetElemByName(nm);
		if(sym && sym->IsKindOf(RUNTIME_CLASS(CViecFC))) {
//			delete obstr;
//			m_pMathInst = sym;
			m_pSymb = sym;
		} else {
			if(pbx==NULL) {
				pOp = new COperatorFolder;
				pOp->SetName("Operator", s_nDot, ANSI_CHARSET);
				pOp->SetDragAllow(TRUE);
				pOp->SetOrg(CPoint(40,0));
				pOp->SetMode(CPElem::modeOpen);
				pOp->SetFindFirst(TRUE);
				psm->AddTail(pOp);
			} else {
				pOp = (COperatorFolder *) pbx;
			}
		
			if(s_TheDefaultSymbols.Lookup(nm, pvd)) {
				rtc = (CRuntimeClass *) pvd;
				pmo = (CMathSymb *) rtc->CreateObject();
				pmo->SetName(nm, s_nDot, ANSI_CHARSET);
//			} else if(bFirst) {
//				m_petSymbName = GetNewTChar("?", m_petSymbName);
//				nm = *m_petSymbName;
//				bFirst = FALSE;
//				goto unknown_loop;
			} else {
				m_pSymb = NULL;
				MessageBox(NULL, "It seems wrong", "ERR", MB_OK);
				return FALSE;
			}
			int cno = pOp->GetCount();
			pOp->AddTail(pmo);
			pmo->SetDragAllow(TRUE);
			pmo->SetOrg(CPoint(20, cno*20));
			sym = pmo;
			m_pSymb = pmo;
		}
		CSuitCase SC;
		SC.m_case = sym;
		SC.m_int = FALSE;
		if(pOp || (   sym->IsKindOf(RUNTIME_CLASS(CViecFC))
	    	       && sym->GetParent()->SendMsg(MSG_INCLUDE_CHILD_IN_MATH_TABLE, &SC) && SC.m_int)) {
			//--- add to the table
			pos = s_MathSymbMapTable.GetStartPosition();
			while(pos) {
				s_MathSymbMapTable.GetNextAssoc(pos, key, pObj);
				if(pObj==sym)
					s_MathSymbMapTable.RemoveKey(key);
			}
			s_MathSymbMapTable[sym->GetName()] = sym;
		}
	}

	CMSPhys *pms = (CMSPhys*) GetSymbBody();
	pos = GetHeadPosition();
	while(pos) {
		CViecFC *pel = GetNext(pos);
		if(pel->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
			if(pms && pms->IsKindOf(RUNTIME_CLASS(CMSPhys)))
				((CSymbInst *)pel)->SetLevel(m_level-4);
			else if(pms->IsKindOf(RUNTIME_CLASS(CMSMatrix)))
				((CSymbInst *)pel)->SetLevel(m_level-4);
	//		else if(pms->IsKindOf(RUNTIME_CLASS(CMSOEqual)))
	//			((CSymbInst *)pel)->SetLevel(m_level-1);
	//		else if(pms->IsKindOf(RUNTIME_CLASS(CMSOMinus)))
	//			((CSymbInst *)pel)->SetLevel(m_level-1);
			else
				((CSymbInst *)pel)->SetLevel(m_level);
		}
	}
	CGElem::OnCreated(bSkp);
	return TRUE;
}

void CSymbInst::OnDraw(CDC *pdc, const CPoint& p0)
{
	if(!m_pSymb) return;
	CPoint p = p0;
	p.Offset(m_org);
	if(m_pSymb==NULL) {
		SetTextColor(pdc, RGB(80,80,80));
		TextOut(pdc, p0.x, p0.y, GetSymbName(), GetSymbNmLen());
		return;
	}
	m_pSymb->ToDraw(this, pdc, p);
	if(m_bDrag) CViecFC::OnDrawDrag(pdc,p0);
}

int CSymbInst::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CViecFC *symb = GetSymbBody();
	if(symb && symb->IsKindOf(RUNTIME_CLASS(CViecFC))) {
		CMenu *psub = GetPopupMenu(FALSE);
		pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
		pMenu->AppendMenu(MF_SEPARATOR);
		AppendDefaultMenu(psub);
		str = symb->GetRuntimeClass()->m_lpszClassName;
		str = str + CString("=\"") + symb->GetName()+ CString("\"");
		pMenu->AppendMenu(MF_STRING, 0, str);
		pMenu->AppendMenu(MF_SEPARATOR);
		if(symb->IsKindOf(RUNTIME_CLASS(CMathSymb))) {
			CMenu *pM2 = GetPopupMenu(FALSE);
			pMenu->AppendMenu(MF_POPUP, (UINT) pM2->m_hMenu, "&covered by op.");
			pMenu->AppendMenu(MF_SEPARATOR);
			pM2->AppendMenu(MF_STRING, CMD_COVERED_BY_PLUS, "plus \'&+\'");
			pM2->AppendMenu(MF_STRING, CMD_COVERED_BY_NEG, "negative \'&-\'");
			pM2->AppendMenu(MF_STRING, CMD_COVERED_BY_MULT, "multiply \'&*\'");
			pM2->AppendMenu(MF_STRING, CMD_COVERED_BY_DIV, "divide \'&/\'");
			pM2->AppendMenu(MF_STRING, CMD_COVERED_BY_DERIV, "&deriv");

			pM2->AppendMenu(MF_STRING, CMD_COVERED_BY_EQUAL, "&=");
			pM2->AppendMenu(MF_STRING, CMD_COVERED_BY_GT, "&>");
			pM2->AppendMenu(MF_STRING, CMD_COVERED_BY_LT, "&<");
			pM2->AppendMenu(MF_STRING, CMD_COVERED_BY_GE, "&>=");
			pM2->AppendMenu(MF_STRING, CMD_COVERED_BY_LE, "&<=");

			pM2->AppendMenu(MF_STRING, CMD_COVERED_BY_ABS, "&|a|");
		}
		symb->SendMsg(MSG_ADD_MENU, pMenu);
		if(GetCount()==0)
			pMenu->AppendMenu(MF_STRING, CMD_CHANGE_TO_UNKNOWN, "return to &unknown");
	}
	CSuitCase SC;
	SC.m_case = this;
	SC.m_case2 = pMenu;
	SendMsg(MSG_ADD_MENU_FOR_CHILD, &SC);

	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CSymbInst::OnCommand(UINT id)
{
	int rt = FALSE;
	CViecFC *symb = GetSymbBody();
	char *pc = NULL;

	CSuitCase SC;
	SC.m_int = id;
	SC.m_case = this;
	if(symb->SendMsg(MSG_COMMAND, &SC)) return TRUE;

	switch(id) {
	case CMD_CHANGE_TO_UNKNOWN:
		ChangeInst("?");
		OnCreated();
		CalcExt(dirDown);
		GetParent()->CalcExt();
		InvalidateRect(CPoint(0,0));
		return TRUE;
	case CMD_COVERED_BY_NEG:
		{
			CSymbInst *pSI = (CSymbInst *) GetParent();
			if(!pSI->IsKindOf(RUNTIME_CLASS(CSymbInst))) return TRUE;
			CViecFC *pSB = pSI->GetSymbBody();
			if(!pSB->IsKindOf(RUNTIME_CLASS(CViecFC))) return TRUE;
			if(pSB->IsKindOf(RUNTIME_CLASS(CMSONeg))) {
				CSymbInst *pSI0 = (CSymbInst *) pSI->GetParent();
				if(!pSI0->IsKindOf(RUNTIME_CLASS(CSymbInst))) return TRUE;
				pSI0->SubstChild(pSI, this);
				pSI0->SetFocusChild(NULL);
				POSITION pos;
				pos = pSI->m_child.Find(this);
				pSI->m_child.RemoveAt(pos);
				delete pSI;
				CalcExt();
			} else {
				CSymbInst *pSI2 = new CSymbInst("-?");
//				GetAncestor()->SubstChild(this, pSI2);
				pSI->SubstChild(this, pSI2);
				pSI2->AddTail(this);
				pSI2->OnCreated();
				pSI2->SetFocus(TRUE);
				pSI2->SetFocusChild(this);
				pSI->SetExtent(CRect(0,0,0,0));
				pSI->CalcExt(dirDown);
				CalcExt();
			}
		}
		return TRUE;
	case CMD_COVERED_BY_ABS:
		{
			CSymbInst *pSI = (CSymbInst *) GetParent();
			if(!pSI->IsKindOf(RUNTIME_CLASS(CSymbInst))) return TRUE;
			CViecFC *pSB = pSI->GetSymbBody();
			if(!pSB->IsKindOf(RUNTIME_CLASS(CViecFC))) return TRUE;
			if(pSB->IsKindOf(RUNTIME_CLASS(CMSOAbs))) {
				CSymbInst *pSI0 = (CSymbInst *) pSI->GetParent();
				if(!pSI0->IsKindOf(RUNTIME_CLASS(CSymbInst))) return TRUE;
				pSI0->SubstChild(pSI, this);
				pSI0->SetFocusChild(NULL);
				POSITION pos;
				pos = pSI->m_child.Find(this);
				pSI->m_child.RemoveAt(pos);
				delete pSI;
				CalcExt();
			} else {
				CSymbInst *pSI2 = new CSymbInst("abs");
//				GetAncestor()->SubstChild(this, pSI2);
				pSI->SubstChild(this, pSI2);
				pSI2->AddTail(this);
				pSI2->OnCreated();
				pSI2->SetFocus(TRUE);
				pSI2->SetFocusChild(this);
				pSI->CalcExt(dirDown);
				CalcExt();
			}
		}
		return TRUE;
	case CMD_COVERED_BY_PLUS:	pc = "+";
	case CMD_COVERED_BY_MULT:	if(!pc) pc = "*";
	case CMD_COVERED_BY_DIV:	if(!pc) pc = "/";
	case CMD_COVERED_BY_DERIV:	if(!pc) pc = "deriv";
	case CMD_COVERED_BY_EQUAL:	if(!pc) pc = "==";
	case CMD_COVERED_BY_GT:	if(!pc) pc = ">";
	case CMD_COVERED_BY_LT:	if(!pc) pc = "<";
	case CMD_COVERED_BY_GE:	if(!pc) pc = ">=";
	case CMD_COVERED_BY_LE:	if(!pc) pc = "<=";
		{
			CSymbInst *pSI = (CSymbInst *) GetParent();
			if(!pSI->IsKindOf(RUNTIME_CLASS(CSymbInst))) return TRUE;
			CSymbInst *pSI2 = new CSymbInst(pc);
			CSymbInst *pSI3 = new CSymbInst("?");
			pSI->SubstChild(this, pSI2);
			pSI2->AddTail(this);
			pSI2->AddTail(pSI3);
			pSI2->SetFocus(TRUE);
			pSI2->SetFocusChild(this);
			pSI2->OnCreated();
			pSI2->CalcExt(dirDown);
			CalcExt();
		}
		return 1;
	}
	if(!rt)	rt = CPElem::OnCommand(id);
	return rt;
}

CRect CMathSymb::ToCalcExt(CSymbInst *ps, dirMode dir)
{
	CRect r(0,0,0,0), r0;
	CDC *pdc = GetDC();
	long right=0,bottom=0,top=0, right2=0;

	CSize s(0,0);
	if(pdc) {
		SetFont(pdc, GetnDot(ps->GetLevel(), m_nDot), GetFont(), m_nCharSet, m_nItalic);
		s = pdc->GetTextExtent(GetName(), GetNameLen());
		r.top = -s.cy/2;
		r.right = s.cx;
		r.bottom = s.cy-s.cy/2;
		s = pdc->GetTextExtent(", ", 1);
		ReleaseDC(pdc);
	}

	CViecFC *peq;
	POSITION pos;
	pos = ps->FindIndex(0);
	if(pos) {
		peq = (CViecFC *) ps->GetAt(pos);
		if(peq->GetExtent().bottom > (-r.top))
			peq->SetOrg(CPoint(r.right, -peq->GetExtent().bottom));
		else
			peq->SetOrg(CPoint(r.right, r.top));
		if(dir==dirDown) peq->CalcExt(dir);
		r0 = peq->GetExtent();
		top = r0.top;
		right = r0.right;
	}
	pos = ps->FindIndex(1);
	if(pos) {
		peq = (CViecFC *) ps->GetAt(pos);
		if((peq->GetExtent().top) > r.top)
			peq->SetOrg(CPoint(r.right+right2, peq->GetExtent().bottom));
		else
			peq->SetOrg(CPoint(r.right+right2, r.bottom));
		if(dir==dirDown) peq->CalcExt(dir);
		r0 = peq->GetExtent();
		bottom = r0.bottom>bottom? r0.bottom : bottom;
		right2 += r0.right;
	}
	pos = ps->FindIndex(2);
	if(pos) {
		right2 += s.cx + 1;
		peq = (CViecFC *) ps->GetAt(pos);
		if((peq->GetExtent().top) > r.top)
			peq->SetOrg(CPoint(r.right+right2, peq->GetExtent().bottom));
		else
			peq->SetOrg(CPoint(r.right+right2, r.bottom));
		if(dir==dirDown) peq->CalcExt(dir);
		r0 = peq->GetExtent();
		bottom = r0.bottom>bottom? r0.bottom : bottom;
		right2 += r0.right;
	}
	pos = ps->FindIndex(3);
	if(pos) {
		right2 += s.cx + 1;
		peq = (CViecFC *) ps->GetAt(pos);
		if((peq->GetExtent().top) > r.top)
			peq->SetOrg(CPoint(r.right+right2, peq->GetExtent().bottom));
		else
			peq->SetOrg(CPoint(r.right+right2, r.bottom));
		if(dir==dirDown) peq->CalcExt(dir);
		r0 = peq->GetExtent();
		bottom = r0.bottom>bottom? r0.bottom : bottom;
		right2 += r0.right;
	}

	r.top += top;
	r.right += (right>right2)? right : right2;
	r.bottom += bottom;
	ps->SetExtent(r);
	return r;
}

void CMathSymb::ToDraw(CSymbInst *pInst, CDC *pdc, const CPoint& shift)
{
	CPoint p0 = shift;

	pInst->SetPen(pdc, PS_SOLID, 1, RGB(0,255,0));
	if(pInst->m_bFocus) pdc->SetTextColor(RGB(0,0,255));
	else pdc->SetTextColor(RGB(0,0,0));

	pInst->SetFont(pdc, GetnDot(pInst->GetLevel(), m_nDot), GetFont(), m_nCharSet, m_nItalic);
	CSize s = pdc->GetTextExtent(GetName(), GetNameLen());
	pdc->TextOut(shift.x, shift.y-s.cy/2, GetName());

	CRect r=pInst->GetExtent();
	pdc->SetTextColor(RGB(0,0,0));
	p0.Offset(-pInst->GetOrg());
	pInst->SetOldGdiObject(pdc);

	POSITION pos;
	pInst->OnDrawChild(pdc, p0);

	CViecFC *pelem;
	if(pInst->GetCount()>=3) {
		pos = pInst->FindIndex(1);
		pelem = pInst->GetAt(pos);
		p0 = shift;
		p0.Offset(pelem->GetOrg());
		r = pelem->GetExtent();
		p0.x += r.right+1;
		s = pdc->GetTextExtent(", ", 1);
		p0.y -= s.cy/2;
		pdc->TextOut(p0.x, p0.y, ", ", 1);
	}
	if(pInst->GetCount()>=4) {
		pos = pInst->FindIndex(2);
		pelem = pInst->GetAt(pos);
		p0 = shift;
		p0.Offset(pelem->GetOrg());
		r = pelem->GetExtent();
		p0.x += r.right+1;
		s = pdc->GetTextExtent(", ", 1);
		p0.y -= s.cy/2;
		pdc->TextOut(p0.x, p0.y, ", ", 1);
	}
		
}

PETCHAR CViecFC::GetDrawName()
{
	return GetName();
}

PETCHAR CMSOMult::GetDrawName()
{
	return "";
}

int CMathSymb::GetnDot(int level, int dot)
{
	return dot+level*nDotStp;
}

int CMathSymb::GetSpc(int level)
{
	int spc = 2 + level;
	return spc>1? spc: 1;
}

void CMSOperator::DrawBrck(CDC* pdc, CSymbInst *ps, const CPoint& shift)
{
	int nHg = ps->GetExtent().Height();
	int nBrckWd = nHg / 10;
	if(nBrckWd<4)	nBrckWd = 4;
	if(nBrckWd>15) nBrckWd = 15;
//	SetFont(pdc, nHg, "Courier New", ANSI_CHARSET, FALSE, nBrckWd);
	SetFont(pdc, nHg, "Times New Roman", ANSI_CHARSET, FALSE, nBrckWd);
//	SetFont(pdc, nHg, "System", ANSI_CHARSET, FALSE, nBrckWd);
	CRect r0;
	r0 = ps->GetExtent();
	r0.OffsetRect(shift);
	pdc->TextOut(r0.left, r0.top, "{");
	pdc->TextOut(r0.right-nBrckWd, r0.top, "}");
//	pdc->SelectStockObject(NULL_BRUSH);
//	pdc->SelectStockObject(BLACK_PEN);
//	pdc->Rectangle(&r0);
/*
		int nWd = ps->GetExtent().Height();
		int nBrckWd = (int) ((float) nWd * 0.2 + 0.5);
		nWd = (int)(nWd*1.5);
		CRect r0,r1;
		CPoint p1,p2, pu,pd;

		SetPen(pdc, PS_SOLID, 1, RGB(0,0,0));
	
		r0 = ps->GetExtent();
		r0.OffsetRect(shift);
		pu = CPoint(r0.left + nBrckWd+2, r0.top+2);
		pd = CPoint(r0.left + nBrckWd+2, r0.bottom-3);
		p2 = CPoint(r0.left+nWd, (r0.top+r0.bottom)/2);
		r1 = CRect(-nWd,-nWd, nWd,nWd);
		r1.OffsetRect(p2);
		pdc->Arc(&r1, pu, pd);

		pu = CPoint(r0.right - nBrckWd-2, r0.top+2);
		pd = CPoint(r0.right - nBrckWd-2, r0.bottom-3);
		p2 = CPoint(r0.right-nWd, (r0.top+r0.bottom)/2);
		r1 = CRect(-nWd,-nWd, nWd,nWd);
		r1.OffsetRect(p2);
		pdc->Arc(&r1, pd, pu);
*/
}

CRect CMSOperator::ToCalcExt(CSymbInst *ps, dirMode dir)
{
	CRect r(0,0,0,0);
	CDC *pdc = GetDC();
	PETCHAR str = GetDrawName();

	CSize s;
	if(pdc) {
		SetFont(pdc, GetnDot(ps->GetLevel(), m_nDot), GetFont(), m_nCharSet, m_nItalic);
		s = pdc->GetTextExtent(str, lstrlen(str));
		ReleaseDC(pdc);
	}

	CPtrList lineL;
	CRect *pr = new CRect(0,0,0,0);
	lineL.AddTail(pr);

	int nLineNo = 1;
	CViecFC *peq, *peq0=NULL;
	if(IsKindOf(RUNTIME_CLASS(CMSONeg))) {
		CViecFC *pp = (CViecFC*) ps->GetParent();
		if(pp && pp->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
			CViecFC *psm = ((CSymbInst*)pp)->GetSymbBody();
			POSITION pos0 = pp->GetHeadPosition();
			if(pos0 && psm && psm->IsKindOf(RUNTIME_CLASS(CMSOPlus)) && pp->GetNext(pos0)!=ps )
				;
			else
				pr->right += s.cx + GetSpc(ps->GetLevel());
		} else
			pr->right += s.cx + GetSpc(ps->GetLevel());
	}
	CRect r00, r0;
	POSITION pos;
	BOOL fg = TRUE;
	pos = ps->GetHeadPosition();
	while(pos) {
		pr->right += GetSpc(ps->GetLevel());
		peq = (CViecFC*) ps->GetNext(pos);
		if(dir==dirDown) peq->CalcExt(dir);
		r0 = peq->GetExtent();
		
		if(!IsKindOf(RUNTIME_CLASS(CMSOEqual)) && !IsKindOf(RUNTIME_CLASS(CMSONeg)
			)
		   && !fg && r00.Width() * 10 > r0.Width()
		   && pr->right+r0.Width()+s.cx+GetSpc(ps->GetLevel()) > nEqtWd) {
			pr = new CRect(0,0,0,0);
			lineL.AddTail(pr);
			nLineNo++;
		}
		fg = FALSE;
		r00 = r0;
		if(peq0) pr->right += s.cx; // + GetSpc(ps->GetLevel());
		peq0 = peq;
		if(r0.top<pr->top) pr->top = r0.top;
		if(r0.bottom>pr->bottom) pr->bottom = r0.bottom;
		CPoint org(pr->right, nLineNo-1);
		peq->SetOrg(org);
		pr->right += r0.Width() + GetSpc(ps->GetLevel());
	}
	POSITION pos2 = ps->GetHeadPosition();
	peq = (CViecFC*) ps->GetAt(pos2);
	pr = (CRect*) lineL.GetHead();
	int line = pr->top;
	for(int i=0; lineL.GetCount()>0; i++) {
		pr = (CRect*) lineL.RemoveHead();
		line -= pr->top;
		while(peq->GetOrg().y==i) {
			CPoint org = peq->GetOrg();
			org.y = line;
			peq->SetOrg(org);
			ps->GetNext(pos2);
			if(!pos2) break;
			peq = (CViecFC*) ps->GetAt(pos2);
		}
		line += pr->bottom;
		delete pr;
	}

	CRect rt(0,0,0,0);
	pos = ps->GetHeadPosition();
	while(pos) {
		peq = (CViecFC*) ps->GetNext(pos);
		CRect r0 = peq->GetRect();
		if(r0.left<rt.left) rt.left = r0.left;
		if(r0.right>rt.right) rt.right = r0.right;
		if(r0.top<rt.top) rt.top = r0.top;
		if(r0.bottom>rt.bottom) rt.bottom = r0.bottom;
	}

	if(IsBrcRq(ps)) {
//		int nBrckWd = (int) ((float) rt.Height() * 0.2 + 0.5);
		int nBrckWd = rt.Height()/10;
		if(nBrckWd<4)	nBrckWd = 4;
		if(nBrckWd>15) nBrckWd = 15;
		pos = ps->GetHeadPosition();
		while(pos) {
			peq = (CViecFC*) ps->GetNext(pos);
			CPoint org = peq->GetOrg();
			org.x += nBrckWd;
			peq->SetOrg(org);
		}
		rt.right += 2*nBrckWd;
	}
	ps->SetExtent(rt);
	return rt;
}

void CMSOperator::ToDraw(CSymbInst *ps, CDC *pdc, const CPoint& shift)
{
	CPoint p0 = shift;
	p0.Offset(-ps->GetOrg());

	PETCHAR str = GetDrawName();
	ps->SetFont(pdc, GetnDot(ps->GetLevel(), m_nDot), GetFont(), m_nCharSet, m_nItalic);
	CSize s = pdc->GetTextExtent(str, lstrlen(str));

	int right0 = 0;

	if(IsBrcRq(ps)) {
		DrawBrck(pdc, ps, shift);
		int nWd = ps->GetExtent().Height();
//		int nBrckWd = (int) ((float) nWd * 0.2 + 0.5);
		int nBrckWd = nWd/10;
		if(nBrckWd<4)	nBrckWd = 4;
		if(nBrckWd>15) nBrckWd = 15;
		right0 += nBrckWd;
	}


	int Spc = GetSpc(ps->GetLevel());
	int right = right0;
	CViecFC *peq, *peq0=NULL;
	int line = 0;

	if(IsKindOf(RUNTIME_CLASS(CMSONeg))) {
		CViecFC *pp = (CViecFC*) ps->GetParent();
		if(ps->m_bFocus) pdc->SetTextColor(RGB(0,0,255));
		else pdc->SetTextColor(RGB(0,0,0));
		if(pp && pp->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
			CViecFC *psm = ((CSymbInst*)pp)->GetSymbBody();
			POSITION pos0 = pp->GetHeadPosition();
			if(pos0 && psm && psm->IsKindOf(RUNTIME_CLASS(CMSOPlus)) && pp->GetNext(pos0)!=ps )
				;
			else {
				pdc->TextOut(shift.x + right, shift.y-s.cy/2 + line, str);
				right += s.cx + Spc;
//				right += s.cx;
			}
		} else {
			right += s.cx + GetSpc(ps->GetLevel());
			pdc->TextOut(shift.x+right, shift.y-s.cy/2 + line, str);
			right += s.cx;
		}
		pdc->SetTextColor(RGB(0,0,0));
	}
	
	POSITION pos;
	pos = ps->GetHeadPosition();
	while(pos) {
		right += Spc/2;
		peq = (CViecFC*) ps->GetNext(pos);
		if(peq0) {
			CPoint oo = peq->GetOrg();
			if(oo.y>line) { line = oo.y; right = right0; }
			SetFont(pdc, GetnDot(ps->GetLevel(), m_nDot), GetFont(), m_nCharSet, m_nItalic);
			if(ps->m_bFocus) pdc->SetTextColor(RGB(0,0,255));
			else pdc->SetTextColor(RGB(0,0,0));
			if(IsKindOf(RUNTIME_CLASS(CMSOPlus)) && peq->IsKindOf(RUNTIME_CLASS(CSymbInst)) ) {
				CViecFC *pms = ((CSymbInst*) peq)->GetSymbBody();
				if(pms && pms->IsKindOf(RUNTIME_CLASS(CMSONeg)))
					pdc->TextOut(shift.x+right+Spc, shift.y-s.cy/2 + line, "-");
				else
					pdc->TextOut(shift.x+right, shift.y-s.cy/2 + line, str);
			} else
				pdc->TextOut(shift.x+right, shift.y-s.cy/2 + line, str);
			right += s.cx;
			pdc->SetTextColor(RGB(0,0,0));
		}
//		right += Spc;
		right += Spc - Spc/2;
		peq0 = peq;
		peq->OnDraw(pdc, shift);
		CRect r0 = peq->GetExtent();
		right += r0.Width() + GetSpc(ps->GetLevel());
	}
}

BOOL CMSOperator::IsBrcRq(CSymbInst* pq)
{
	return FALSE; //TRUE;
}

CMSOperator::CMSOperator()
{
	m_petFont = GetNewTChar("Symbol", m_petFont);
}

CRect CMSONeg::ToCalcExt(CSymbInst *ps, dirMode dir)
{
	CDC *pdc;
	POSITION pos;
	CRect rt(0,0,0,0);
	CSize s;
	CViecFC *peq;
	int nSpc;
	CSymbInst *pP;
	BOOL okFg;

	if(ps->GetCount()==0) {
		return CRect(-1,-1,-1,-1);
	}
	okFg = TRUE;
	pP = (CSymbInst *) ps->GetParent();
	if(pP->IsKindOf(RUNTIME_CLASS(CSymbInst)))
		if(pP->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus)))
			okFg = FALSE;
	nSpc = GetSpc(ps->GetLevel());
	pdc = GetDC();
	PETCHAR str = GetDrawName();
	SetFont(pdc, GetnDot(ps->GetLevel(), m_nDot), GetFont(), m_nCharSet, m_nItalic);
	s = pdc->GetTextExtent(str, lstrlen(str));
	ReleaseDC(pdc);
	pos = ps->GetHeadPosition();
	peq = (CViecFC*) ps->GetNext(pos);
	if(dir==dirDown) peq->CalcExt(dir);
	rt = peq->GetExtent();
	if(okFg) {
		rt.right += s.cx; // + GetSpc(ps->GetLevel());
		rt.right += nSpc;
		peq->SetOrg(CPoint(s.cx + nSpc, 0));
	} else {
		peq->SetOrg(CPoint(0, 0));
	}
	if(IsBrcRq(ps)) {
		int nBrckWd = rt.Height()/14;
		if(nBrckWd<4)	nBrckWd = 4;
		if(nBrckWd>15) nBrckWd = 15;
		CPoint org = peq->GetOrg();
		org.x += nBrckWd;
		peq->SetOrg(org);
		rt.right += 2*nBrckWd;
	}
	ps->SetExtent(rt);
	return rt;
}

void CMSONeg::ToDraw(CSymbInst *ps, CDC *pdc, const CPoint& shift)
{
	CPoint p0 = shift;
	p0.Offset(-ps->GetOrg());
	CSize s;
	CSymbInst *pP;
	BOOL okFg;

	okFg = TRUE;
	pP = (CSymbInst *) ps->GetParent();
	if(pP->IsKindOf(RUNTIME_CLASS(CSymbInst)))
		if(pP->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus)))
			okFg = FALSE;

	if(ps->GetCount()==0) {
		CRect r;
		pdc->SelectStockObject(BLACK_PEN);
		pdc->SelectStockObject(NULL_BRUSH);
		r = ps->GetExtent();
		r.OffsetRect(shift);
		pdc->Rectangle(&r);
		return;
	}
	int Spc = GetSpc(ps->GetLevel());
	CString str = GetDrawName();
	ps->SetFont(pdc, GetnDot(ps->GetLevel(), m_nDot), GetFont(), m_nCharSet, m_nItalic);
	s = pdc->GetTextExtent(str, lstrlen(str));
	int right0 = 0;
	if(IsBrcRq(ps)) {
		DrawBrck(pdc, ps, shift);
		int nWd = ps->GetExtent().Height();
		int nBrckWd = nWd/10;
		if(nBrckWd<4)	nBrckWd = 4;
		if(nBrckWd>15) nBrckWd = 15;
		right0 += nBrckWd;
	}
	if(okFg) {
		SetFont(pdc, GetnDot(ps->GetLevel(), m_nDot), GetFont(), m_nCharSet, m_nItalic);
		if(ps->m_bFocus) pdc->SetTextColor(RGB(0,0,255));
		else pdc->SetTextColor(RGB(0,0,0));
		pdc->TextOut(shift.x + right0, shift.y-s.cy/2, str);
	}
	POSITION pos;
	pos = ps->GetHeadPosition();
	ps->GetNext(pos)->OnDraw(pdc, shift);
}

int CSymbInst::OnFocus(CPoint &p)
{
	BOOL rt = CGElem::OnFocus(p);
	m_bZoneFg = -1;
	if(GetCount()<2 || !m_bFocus || m_focus)
		return rt;
	CViecFC *pelm;
	CPoint p0, p1, p2;
	CRect rect;
	BOOL fstFg = TRUE;
	int dis, dis0, i;
	int dx1, dx2, dy1, dy2;
	p0 = p;
	p0 -= (CSize) m_org;
	POSITION pos = GetHeadPosition();
	p1 = CPoint(0,0);
//	pelm = GetNext(pos);
//	rect = pelm->GetRect();
//	p1 = CPoint((rect.left+rect.right)/2, (rect.top+rect.bottom)/2);
	for(i=0;pos;i++) {
		pelm = GetNext(pos);
		p2 = pelm->GetOrg();
//		rect = pelm->GetRect();
//		p2 = CPoint((rect.left+rect.right)/2, (rect.top+rect.bottom)/2);
		dx1 = p1.x-p0.x; dy1 = p1.y-p0.y;
		dx2 = p2.x-p0.x; dy2 = p2.y-p0.y;
		dis = dx1*dx1 + dy1*dy1 + dx2*dx2 + dy2*dy2;
		if(fstFg || dis<dis0) {
			fstFg = FALSE;
			dis0 = dis;
			m_bZoneFg = i;
		}
		p1 = p2;
	}
	return rt;
}

BOOL CMSOperator::SendMsg(int sig, CObject* sc)
{
	switch(sig) {
	case MSG_ON_DELETE:
		{
			CSuitCase *pSC = (CSuitCase *) sc;
			CSymbInst *ps = (CSymbInst *) pSC->m_case;
			CViecFC *pe = (CViecFC *) pSC->m_case2;
			if(ps->GetCount()==1 && !IsKindOf(RUNTIME_CLASS(CMSONeg))) {
				CViecFC *pel = (CViecFC *) ps->m_child.RemoveTail();
				CViecFC *ppp = (CViecFC *) ps->GetParent();
				ppp->SetFocusChild(NULL);
				ppp->SubstChild(ps, pel, dirDown);
				ps->OnCommand(CMD_ADD_DELETE);
				pel->CalcExt();
			} else if(ps->GetCount()==0) {
				ps->OnCommand(CMD_ADD_DELETE);
			} else if(IsKindOf(RUNTIME_CLASS(CMSONeg))) {
				if(ps->m_child.Find(pe)) {
					if(strcmp(GetName(), "-?"))
						MessageBox(NULL, "CMSOMult is not", "ERR", MB_OK);
					ps->m_child.RemoveAll();
					ps->OnCommand(CMD_ADD_DELETE);
				}
			}
		}
		return TRUE;
	case MSG_ADD_MENU:
		{
			CMenu *pMN = (CMenu *) sc;
			CMenu *pSMN = GetPopupMenu(FALSE);
			pMN->AppendMenu(MF_POPUP, (UINT) pSMN->m_hMenu, "&edit");
			pSMN->AppendMenu(MF_STRING, CMD_ADD_TAIL_AN_UNKNOWN, "&Add Tail");
			pSMN->AppendMenu(MF_STRING, CMD_INSERT_AN_UNKNOWN, "&Insert");
			return 1;
		}
		break;
	case MSG_COMMAND:
		{
			CSuitCase *pSC = (CSuitCase*) sc;
			CSymbInst *pSI = (CSymbInst*) pSC->m_case;
			CSymbInst *pSI2;
			POSITION pos;
				if(!pSC->IsKindOf(RUNTIME_CLASS(CSuitCase)) ||
			  !pSI || !pSI->IsKindOf(RUNTIME_CLASS(CSymbInst)))
				return 0;
			switch(pSC->m_int) {
				case CMD_ADD_TAIL_AN_UNKNOWN:
					pSI2 = new CSymbInst("?");
					pSI->AddTail(pSI2);
					pSI->OnCreated();
					pSI2->CalcExt(dirDown);
					pSI->CalcExt();
					pSI->InvalidateRect(CPoint(0,0));
					return 1;
				case CMD_INSERT_AN_UNKNOWN:
					pos = pSI->m_child.FindIndex(pSI->GetZoneFg());
					if(!pos) break;
					pSI2 = new CSymbInst("?");
					pSI->m_child.InsertBefore(pos, pSI2);
					pSI2->SetParent(pSI);
					pSI->OnCreated();
					pSI2->CalcExt(dirDown);
					pSI->CalcExt();
					pSI->InvalidateRect(CPoint(0,0));
					return 1;
			}
		}
		break;
	case MSG_CAN_THIS_CHILD_DISAPPEAR:
		{
			CSuitCase *pSC = (CSuitCase*) sc;
			CSymbInst *pSI = (CSymbInst*) pSC->m_case;
			if(IsKindOf(RUNTIME_CLASS(CMSOEqual)) && pSI->GetCount()<=2)
			return FALSE;
		}
		return TRUE;
	}
	return CMathSymb::SendMsg(sig, sc);
}

BOOL CSymbInst::SendMsg(int sig, CObject* sc)
{
	switch(sig) {
	case MSG_CHANG_NAME:
		if(m_pSymb==sc) {
			m_petSymbName = GetNewTChar(m_pSymb->GetName(), m_petSymbName);
			CalcExt();
		}
		return FALSE;
	case MSG_COLLECT_ALL_GARBAGE:
		CElmResSrv::s_pElmResSrv->GarbageEText(m_petSymbName);
		break;
//	case MSG_CAN_SKIP_ONCREATED_PROC:
//		if(GetMode()==modeClose && !GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)))
//			((CSuitCase *) sc)->m_int = TRUE;
//		else
//			((CSuitCase *) sc)->m_int = FALSE;
//		return TRUE;
	case MSG_CAN_THIS_DISAPPEAR:
		{
			CSuitCase SC;
			SC.m_case = this;
			SC.m_case2 = sc;
			return m_pSymb->SendMsg(MSG_CAN_THIS_CHILD_DISAPPEAR, &SC);
//			CViecFC *sym = (CViecFC *) m_pMathInst;
//			return sym->SendMsg(MSG_CAN_THIS_CHILD_DISAPPEAR, &SC);
		}
	}
	return CPElem::SendMsg(sig, sc);
}

int CSymbInst::OnDrag(const CPoint& old, const CPoint& last)
{
	return CViecFC::OnDrag(old, last);
}

int CSymbInst::OnDrop(const CPoint& last)
{
	return CViecFC::OnDrop(last);
}

BOOL CMSOPlus::IsBrcRq(CSymbInst* pe)
{
	CSymbInst *pp = (CSymbInst*) pe->GetParent();
	if(!pp || !pp->IsKindOf(RUNTIME_CLASS(CSymbInst))) return FALSE;
	CViecFC *pss = pp->GetSymbBody();
	if(!pss) return FALSE;
	if(pss->IsKindOf(RUNTIME_CLASS(CMSOPlus)) ||
		pss->IsKindOf(RUNTIME_CLASS(CMSONeg)) ||
		pss->IsKindOf(RUNTIME_CLASS(CMSOMult)) ||
		pss->IsKindOf(RUNTIME_CLASS(CMSODiff)) ) return TRUE;
	return FALSE;
}

CRect CMSOPlus::ToCalcExt(CSymbInst *ps, dirMode dir)
{
	CRect r(0,0,0,0);
	CDC *pdc = GetDC();
	CString str;
	CSize s, s2;
	CRect r00, r0;
	POSITION pos;
	BOOL fg = TRUE;

	str = GetDrawName();
	if(pdc) {
		SetFont(pdc, GetnDot(ps->GetLevel(), m_nDot), GetFont(), m_nCharSet, m_nItalic);
		s = pdc->GetTextExtent(str, lstrlen(str));
		s2 = pdc->GetTextExtent("-", 1);
		ReleaseDC(pdc);
	}

	CPtrList lineL;
	CRect *pr = new CRect(0,0,0,0);
	lineL.AddTail(pr);

	int nLineNo = 1;
	CViecFC *peq, *peq0=NULL;
	BOOL okFg;

	okFg = FALSE;
	pos = ps->GetHeadPosition();
	peq = ps->GetNext(pos);
	if(peq->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
		CSymbInst *pI;
		pI = (CSymbInst *) peq;
		if(pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSONeg)))
			okFg = TRUE;
	} else if(peq->IsKindOf(RUNTIME_CLASS(CMSNumber))) {
		CMSNumber *pN;
		pN = (CMSNumber *) peq;
		if(pN->IsNeg())
			okFg = TRUE;
	}
	if(okFg) {
		pr->right += s2.cx + GetSpc(ps->GetLevel());
	}

	pos = ps->GetHeadPosition();
	while(pos) {
		pr->right += GetSpc(ps->GetLevel());
		peq = (CViecFC*) ps->GetNext(pos);
		if(dir==dirDown) peq->CalcExt(dir);
		r0 = peq->GetExtent();
		
		if(!fg && r00.Width() * 10 > r0.Width()
		   && pr->right+r0.Width()+s.cx+GetSpc(ps->GetLevel()) > nEqtWd) {
			pr = new CRect(0,0,0,0);
			lineL.AddTail(pr);
			nLineNo++;
		}
		fg = FALSE;
		r00 = r0;
		if(peq0) pr->right += s.cx; // + GetSpc(ps->GetLevel());
		peq0 = peq;
		if(r0.top<pr->top) pr->top = r0.top;
		if(r0.bottom>pr->bottom) pr->bottom = r0.bottom;
		CPoint org(pr->right, nLineNo-1);
		peq->SetOrg(org);
		pr->right += r0.Width() + GetSpc(ps->GetLevel());
	}

	POSITION pos2 = ps->GetHeadPosition();
	peq = (CViecFC*) ps->GetAt(pos2);
	pr = (CRect*) lineL.GetHead();
	int line = pr->top;
	for(int i=0; lineL.GetCount()>0; i++) {
		pr = (CRect*) lineL.RemoveHead();
		line -= pr->top;
		while(peq->GetOrg().y==i) {
			CPoint org = peq->GetOrg();
			org.y = line;
			peq->SetOrg(org);
			ps->GetNext(pos2);
			if(!pos2) break;
			peq = (CViecFC*) ps->GetAt(pos2);
		}
		line += pr->bottom;
		delete pr;
	}

	CRect rt(0,0,0,0);
	pos = ps->GetHeadPosition();
	while(pos) {
		peq = (CViecFC*) ps->GetNext(pos);
		CRect r0 = peq->GetRect();
		if(r0.left<rt.left) rt.left = r0.left;
		if(r0.right>rt.right) rt.right = r0.right;
		if(r0.top<rt.top) rt.top = r0.top;
		if(r0.bottom>rt.bottom) rt.bottom = r0.bottom;
	}

	if(IsBrcRq(ps)) {
		int nBrckWd = rt.Height()/10;
		if(nBrckWd<4)	nBrckWd = 4;
		if(nBrckWd>15) nBrckWd = 15;
		pos = ps->GetHeadPosition();
		while(pos) {
			peq = (CViecFC*) ps->GetNext(pos);
			CPoint org = peq->GetOrg();
			org.x += nBrckWd;
			peq->SetOrg(org);
		}
		rt.right += 2*nBrckWd;
	}
	ps->SetExtent(rt);
	return rt;
}

void CMSOPlus::ToDraw(CSymbInst *ps, CDC *pdc, const CPoint& shift)
{
	CPoint p0 = shift;
	CViecFC *peq, *peq0=NULL;
	BOOL okFg;
	POSITION pos;
	int line = 0;
	int right0 = 0;

	p0.Offset(-ps->GetOrg());

	CString str = GetDrawName();
	ps->SetFont(pdc, GetnDot(ps->GetLevel(), m_nDot), GetFont(), m_nCharSet, m_nItalic);

	CSize s = pdc->GetTextExtent(str, lstrlen(str));
	CSize s2 = pdc->GetTextExtent("-", 1);

	if(IsBrcRq(ps)) {
		DrawBrck(pdc, ps, shift);
		int nWd = ps->GetExtent().Height();
		int nBrckWd = nWd/10;
		if(nBrckWd<4)	nBrckWd = 4;
		if(nBrckWd>15) nBrckWd = 15;
//		int nBrckWd = (int) ((float) nWd * 0.2 + 0.5);
		right0 += nBrckWd;
	}

	okFg = FALSE;
	pos = ps->GetHeadPosition();
	peq = ps->GetNext(pos);
	if(peq->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
		CSymbInst *pI;
		pI = (CSymbInst *) peq;
		if(pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSONeg)))
			okFg = TRUE;
	} else if(peq->IsKindOf(RUNTIME_CLASS(CMSNumber))) {
		CMSNumber *pN;
		pN = (CMSNumber *) peq;
		if(pN->IsNeg())
			okFg = TRUE;
	}
	int Spc = GetSpc(ps->GetLevel());
	int right = right0;

	if(okFg) {
		SetFont(pdc, GetnDot(ps->GetLevel(), m_nDot), GetFont(), m_nCharSet, m_nItalic);
		if(ps->m_bFocus) pdc->SetTextColor(RGB(0,0,255));
		else pdc->SetTextColor(RGB(0,0,0));
		pdc->TextOut(shift.x+right+Spc, shift.y-s2.cy/2 + line, "-");
		right += s2.cx + Spc;
	}

	pos = ps->GetHeadPosition();
	while(pos) {
		right += Spc/2;
		peq = (CViecFC*) ps->GetNext(pos);
		if(peq0) {
			CPoint oo = peq->GetOrg();
			if(oo.y>line) { line = oo.y; right = right0; }
			SetFont(pdc, GetnDot(ps->GetLevel(), m_nDot), GetFont(), m_nCharSet, m_nItalic);
			if(ps->m_bFocus) pdc->SetTextColor(RGB(0,0,255));
			else pdc->SetTextColor(RGB(0,0,0));
			if(peq->IsKindOf(RUNTIME_CLASS(CSymbInst)) ) {
				CViecFC *pms = ((CSymbInst*) peq)->GetSymbBody();
				if(pms && pms->IsKindOf(RUNTIME_CLASS(CMSONeg)))
					pdc->TextOut(shift.x+right+Spc, shift.y-s.cy/2 + line, "-");
				else
					pdc->TextOut(shift.x+right, shift.y-s.cy/2 + line, str);
			} else if(peq->IsKindOf(RUNTIME_CLASS(CMSNumber))) {
				CMSNumber *pnum;
				pnum = (CMSNumber *) peq;
				if(pnum->IsNeg())
					pdc->TextOut(shift.x+right+Spc, shift.y-s.cy/2 + line, "-");
				else
					pdc->TextOut(shift.x+right, shift.y-s.cy/2 + line, str);
			} else
				pdc->TextOut(shift.x+right, shift.y-s.cy/2 + line, str);
			right += s.cx;
			pdc->SetTextColor(RGB(0,0,0));
		}
//		right += Spc;
		right += Spc - Spc/2;
		peq0 = peq;
		peq->OnDraw(pdc, shift);
		CRect r0 = peq->GetExtent();
		right += r0.Width() + GetSpc(ps->GetLevel());
	}
}

BOOL CMSOMinus::IsBrcRq(CSymbInst* pe)
{
	CSymbInst *pp = (CSymbInst*) pe->GetParent();
	if(!pp || !pp->IsKindOf(RUNTIME_CLASS(CSymbInst))) return TRUE;
	CViecFC *pss = pp->GetSymbBody();
	if(!pss) return TRUE;
	if(pss->IsKindOf(RUNTIME_CLASS(CMathSymb)) ||
		pss->IsKindOf(RUNTIME_CLASS(CMSONeg)) ||
		pss->IsKindOf(RUNTIME_CLASS(CMSODiv)) ||
		pss->IsKindOf(RUNTIME_CLASS(CMSODiff)) ) return FALSE;
	return TRUE;
}

BOOL CMSONeg::IsBrcRq(CSymbInst* pe)
{
	CSymbInst *pp = (CSymbInst*) pe->GetParent();
	if(!pp || !pp->IsKindOf(RUNTIME_CLASS(CSymbInst))) return TRUE;
	CViecFC *pss = pp->GetSymbBody();
	if(!pss || !pss->IsKindOf(RUNTIME_CLASS(CMSOPlus)) ) return TRUE;
	POSITION pos = pss->GetHeadPosition();
	if(!pos) return FALSE;
	if(pss->GetNext(pos)==this) return FALSE;
	return TRUE;
}

CViecFC *CSymbInst::GetSymbBody()
{
	return m_pSymb;
}

BOOL CMSOMult::IsBrcRq(CSymbInst* pe)
{
	return FALSE;
}

CRect CMSODiv::ToCalcExt(CSymbInst* ps, dirMode dir)
{
	if(ps->GetCount()!=2) return CRect(0,0,0,0);
	POSITION pos = ps->GetHeadPosition();
	CViecFC * nume = ps->GetNext(pos);
	CViecFC * deno = ps->GetNext(pos);
	if(dir==dirDown) {
		nume->CalcExt(dir);
		deno->CalcExt(dir);
	}
	CRect r(0,0,0,0);
	CRect nuRct = nume->GetExtent();
	CRect deRct = deno->GetExtent();
	int dd = GetSpc(ps->GetLevel());
	r.top = - nuRct.Height() - dd;
	r.bottom = deRct.Height() + dd;
	int wd = (nuRct.Width() > deRct.Width())? nuRct.Width() : deRct.Width();
	r.right = wd + dd*2;
	nume->SetOrg( CPoint( (r.right-nuRct.Width())/2, -nuRct.bottom -dd) );
	deno->SetOrg( CPoint( (r.right-deRct.Width())/2, -deRct.top +dd) );
	ps->SetExtent(r);
	return r;
}

void CMSODiv::ToDraw(CSymbInst *ps, CDC *pdc, const CPoint& shift)
{
	int ww = int((float)m_extent.Height() * 0.1);
	if(!ww) ww = 1;
	CPoint p = shift;
	POSITION pos = ps->GetHeadPosition();
	while(pos) {
		CViecFC * pe = (CViecFC*) ps->GetNext(pos);
		pe->OnDraw(pdc, p);
	}
	if(ps->GetFocus())
		ps->SetPen(pdc, PS_SOLID, ww, RGB(0,0,255));
	else
		ps->SetPen(pdc, PS_SOLID, ww, RGB(0,0,0));
	pdc->MoveTo(p);
	pdc->LineTo(p.x+ps->GetExtent().right-1, p.y);
}

CRect CMSODiff::ToCalcExt(CSymbInst* ps, dirMode dir)
{
	if(ps->GetCount()!=2) return CRect(0,0,0,0);

	CSize s1(0,0), s2(0,0);
	char buf[10]="";

	CDC *pdc = GetDC();
	if(pdc) {
		CString str = GetDrawName();
		SetFont(pdc, GetnDot(ps->GetLevel(), m_nDot), GetFont(), SYMBOL_CHARSET, m_nItalic);
		s1 = pdc->GetTextExtent(str, lstrlen(str));
		if(ps->GetInt()>1) sprintf(buf,"%d", ps->GetInt());
		CString str2(buf);
		s2 = pdc->GetTextExtent(str2, lstrlen(str2));
		ReleaseDC(pdc);
	}

	POSITION pos = ps->GetHeadPosition();
	CViecFC * nume = ps->GetNext(pos);
	CViecFC * deno = ps->GetNext(pos);
	if(dir==dirDown) {
		nume->CalcExt(dir);
		deno->CalcExt(dir);
	}
	CRect r(0,0,0,0);
	CRect nuRct = nume->GetExtent();
	CRect deRct = deno->GetExtent();
	if(nuRct.Height() < s1.cy*3/2) {
		r.top = - nuRct.Height() - 1 - s2.cy/2;
		r.bottom = deRct.Height() + 3 + 1;// + s2.cy;
		int wd = (nuRct.Width() > deRct.Width())? nuRct.Width() : deRct.Width();
		r.right = wd + 3 + s1.cx + s2.cx;
		nume->SetOrg( CPoint( s1.cx+s2.cx, -nuRct.bottom -3) );
		deno->SetOrg( CPoint( 2+s1.cx, -deRct.top +3) );
	} else {
		r.top = nuRct.top - 4 - s2.cy/2;
		r.bottom = deRct.Height() + 3;// + s2.cy;
		r.right = nuRct.Width() + 3 + s1.cx + s2.cx + deRct.Width();
		int wd = (nuRct.Width() < nuRct.Height())? nuRct.Width() : nuRct.Height();
		wd = (int) ((float) wd * 0.2 + 0.5);
		r.right += 2*wd;
		nume->SetOrg( CPoint( 4+s1.cx + deRct.Width() + wd*2, 0) );
		deno->SetOrg( CPoint( 2+s1.cx, -deRct.top +3) );
	}
	ps->SetExtent(r);
	return r;
}

void CMSODiff::ToDraw(CSymbInst *ps, CDC *pdc, const CPoint& shift)
{
	if(ps->GetCount()!=2) return;

	int ww = int((float)m_extent.Height() * 0.1);
	if(!ww) ww = 1;

	CString str = GetDrawName();
	ps->SetFont(pdc, GetnDot(ps->GetLevel(), m_nDot), GetFont(), SYMBOL_CHARSET /*m_nCharSet*/, m_nItalic);
	CSize s = pdc->GetTextExtent(str, lstrlen(str));
	char buf[10]="";
	if(ps->GetInt()>1) sprintf(buf,"%d", ps->GetInt());
	CString str2(buf);

	CPoint p = shift;
	POSITION pos = ps->GetHeadPosition();
	CViecFC * nume = ps->GetNext(pos);
	CViecFC * deno = ps->GetNext(pos);

	nume->OnDraw(pdc, p);
	deno->OnDraw(pdc, p);
	if(ps->GetFocus())
		ps->SetPen(pdc, PS_SOLID, ww, RGB(0,0,255));
	else
		ps->SetPen(pdc, PS_SOLID, ww, RGB(0,0,0));

	CRect nuRct = nume->GetExtent();
	if(nuRct.Height() < s.cy*3/2) {
		pdc->MoveTo(p);
		pdc->LineTo(p.x + ps->GetExtent().right, p.y);
	} else {
		CRect r0,r1;
		CPoint p1,p2, pu,pd;

		r0 = deno->GetExtent();
		pdc->MoveTo(p);
		pdc->LineTo(p.x+s.cx+r0.Width()*2, p.y);

		r0 = nume->GetExtent();
		r0.OffsetRect(shift);
		r0.OffsetRect(nume->GetOrg());

		int wd = (nuRct.Width() < nuRct.Height())? nuRct.Width() : nuRct.Height();
		int rr = (int)(wd*2.5);
		wd = (int) ((float) wd * 0.2 + 0.5);

		pu = CPoint(r0.left +1, r0.top+2);
		pd = CPoint(r0.left +1, r0.bottom-3);
		p2 = CPoint(r0.left - wd + rr, (r0.top+r0.bottom)/2);
		r1 = CRect(-rr,-rr, rr,rr);
		r1.OffsetRect(p2);
		pdc->Arc(&r1, pu, pd);

		pu = CPoint(r0.right-1, r0.top+2);
		pd = CPoint(r0.right-1, r0.bottom-3);
		p2 = CPoint(r0.right+wd- rr, (r0.top+r0.bottom)/2);
		r1 = CRect(-rr,-rr, rr,rr);
		r1.OffsetRect(p2);
		pdc->Arc(&r1, pd, pu);
	}

	SetFont(pdc, GetnDot(ps->GetLevel(), m_nDot), GetFont(), SYMBOL_CHARSET, m_nItalic);
	if(ps->m_bFocus) pdc->SetTextColor(RGB(0,0,255));
	else pdc->SetTextColor(RGB(0,0,0));

//	pdc->TextOut(p.x, p.y-s.cy-2, str);
//	pdc->TextOut(p.x, p.y+2, str);

	pdc->TextOut(p.x, p.y-deno->GetOrg().y-s.cy/2, str);
	pdc->TextOut(p.x, p.y+deno->GetOrg().y-s.cy/2, str);
	pdc->SetTextColor(RGB(0,0,0));

	SetFont(pdc, GetnDot(ps->GetLevel()-7, m_nDot), GetFont(), m_nCharSet, m_nItalic);
	pdc->TextOut(p.x+s.cx, p.y-s.cy+deno->GetExtent().top, str2);
	pdc->TextOut(p.x+s.cx+1+deno->GetExtent().Width(), shift.y, str2);
}

PETCHAR CMSODiff::GetDrawName()
{
	static unsigned char txt[2] = { 182, 0 };
	return (const char*) txt;
/*
	char *txt = "x";
	*txt = (BYTE) 182;
	return txt; */
}

CRect CMSInt::ToCalcExt(CSymbInst *ps, dirMode dir)
{
	char buf[20];
	sprintf(buf, "%d", ps->GetInt());
	CSize s(0,0);
	CDC *pdc = GetDC();
	if(pdc) {
		SetFont(pdc, GetnDot(ps->GetLevel(), m_nDot), GetFont(), m_nCharSet, m_nItalic);
		s = pdc->GetTextExtent(buf, lstrlen(buf));
		ReleaseDC(pdc);
	}
	CRect r(0, -s.cy/2, s.cx, s.cy-s.cy/2);
	ps->SetExtent(r);
	return r;
}

void CMSInt::ToDraw(CSymbInst *ps, CDC *pdc, const CPoint& shift)
{
	char buf[20];
	sprintf(buf, "%d", ps->GetInt());
	if(ps->m_bFocus) pdc->SetTextColor(RGB(0,0,255));
	else pdc->SetTextColor(RGB(0,0,0));
	ps->SetFont(pdc, GetnDot(ps->GetLevel(), m_nDot), GetFont(), m_nCharSet, m_nItalic);
	CSize s = pdc->GetTextExtent(buf, lstrlen(buf));
	pdc->TextOut(shift.x, shift.y-s.cy/2, buf);
}

void COperatorFolder::OnDraw(CDC *pdc, const CPoint& p)
{
//CViecFC::OnDraw(pdc, p);
}

int COperatorFolder::CalcExt(dirMode dir)
{
//	CElemCtn::CalcExt(dir);
	SetOrg(CPoint(0,0));
	SetExtent(CRect(0,0,0,0));
	return FALSE;
}

void COperatorFolder::Serialize(CArchive& ar)
{
	CString head = CString(GetRuntimeClass()->m_lpszClassName);
	if (ar.IsStoring()) ar << head;
	SerializeBody(ar);
	WORD no,i;
	CViecFC *pelm;
	BYTE b;
	if (ar.IsStoring()) {
		no = m_child.GetCount();
		ar << (BYTE) m_bEncap;
		ar << no;
		POSITION pos = GetHeadPosition();
		for(i=0; i<no&&pos; i++) {
			pelm = (CViecFC*) GetNext(pos);
			pelm->Serialize(ar);
		}
	} else {
		CString head;
		ar >> b; m_bEncap = b;
		ar >> no;
		for(i=0;i<no;i++) {
			ar >> head;
			if((pelm = GetUnknownElem(ar, head))) {
//				pelm->SetParent(this);
//				m_child.AddTail(pelm);
				delete pelm;
			}
		}
	}
}

/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
//
// CEquInst
//
/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////

CEquInst::CEquInst()
{
	m_bEncap = TRUE;
	SetDragAllow(TRUE);
}

int CEquInst::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	CSize sz;
	CDC *pdc = GetDC();
	if(!pdc) {
		m_extent = CRect(0, -15, 40, 15);
		return 0;
	}
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	sz = pdc->GetTextExtent(GetName(), GetNameLen());
	ReleaseDC(pdc);
	m_extent.left = 0;
	m_extent.right = sz.cx;
	m_extent.top = -(sz.cy-1)/2;
	m_extent.bottom = sz.cy/2;
	
	m_extent.right += 2;
	m_extent.top -= 1;
	m_extent.bottom += 1;
	if(dir==dirUp && GetParent())
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return 1;
}

void CEquInst::OnDraw(CDC *pdc, const CPoint& p)
{
	CRect rct = GetExtent();
	rct.OffsetRect(p);
	rct.OffsetRect(GetOrg());
	if(m_bFocus) {
		pdc->SetTextColor(RGB(0,0,255));
	} else {
		pdc->SetTextColor(RGB(0,0,0));
	}
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	pdc->DrawText(GetName(), GetNameLen(), &rct, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
}

CRect CMSOAbs::ToCalcExt(CSymbInst *ps, dirMode dir)
{
	CViecFC *peq;
	POSITION pos;
	pos = ps->GetHeadPosition();
	while(pos) {
		peq = (CViecFC*) ps->GetNext(pos);
		if(dir==dirDown) peq->CalcExt(dir);
	}

	CRect rt(0,0,0,0);
	pos = ps->GetHeadPosition();
	if(pos) {
		peq = (CViecFC*) ps->GetNext(pos);
		CRect r0 = peq->GetRect();
		peq->SetOrg(CPoint(0,0));
		if(r0.left<rt.left) rt.left = r0.left;
		if(r0.right>rt.right) rt.right = r0.right;
		if(r0.top<rt.top) rt.top = r0.top;
		if(r0.bottom>rt.bottom) rt.bottom = r0.bottom;
	}

//	int nBrckWd = (int) ((float) rt.Height() * 0.2 + 0.5);
	int nBrckWd = rt.Height()/10;
	if(nBrckWd<4)	nBrckWd = 4;
	if(nBrckWd>15) nBrckWd = 15;
	rt.right += nBrckWd;
	pos = ps->GetHeadPosition();
	if(pos) {
		peq = (CViecFC*) ps->GetNext(pos);
		CPoint org = peq->GetOrg();
		org.x += nBrckWd;
		peq->SetOrg(org);
	}
	ps->SetExtent(rt);
	return rt;
}

void CMSOAbs::ToDraw(CSymbInst *ps, CDC *pdc, const CPoint& shift)
{
	int right0 = 0;
	CViecFC *peq;

	int nWd = ps->GetExtent().Height();
	int nBrckWd = nWd/10;
	if(nBrckWd<4)	nBrckWd = 4;
	if(nBrckWd>15) nBrckWd = 15;
//	int nBrckWd = (int) ((float) nWd * 0.2 + 0.5);

	CRect r0,r1;
	CPoint p1,p2, pu,pd;
	SetPen(pdc, PS_SOLID, 1, RGB(0,0,0));

	r0 = ps->GetExtent();
	r0.OffsetRect(shift);

	pu = CPoint(r0.left + nBrckWd/2, r0.top+2);
	pd = CPoint(pu.x, r0.bottom-3);
	pdc->MoveTo(pu);
	pdc->LineTo(pd);

	pu = CPoint(r0.right - nBrckWd/2, r0.top+2);
	pd = CPoint(pu.x, r0.bottom-3);
	pdc->MoveTo(pu);
	pdc->LineTo(pd);

	p1 = shift;
	POSITION pos;
	pos = ps->GetHeadPosition();
	while(pos) {
		peq = (CViecFC*) ps->GetNext(pos);
		peq->OnDraw(pdc, p1);
	}
}

//////CMSOAdrs///////////////////////////////////////
//AhXL
// 99/01/21 create
BOOL CMSOAdrs::IsBrcRq(CSymbInst* pe)
{
	CSymbInst *pp = (CSymbInst*) pe->GetParent();
	if(!pp || !pp->IsKindOf(RUNTIME_CLASS(CSymbInst))) return TRUE;
	CViecFC *pss = pp->GetSymbBody();
	if(!pss || !pss->IsKindOf(RUNTIME_CLASS(CMSOPlus)) ) return TRUE;
	POSITION pos = pss->GetHeadPosition();
	if(!pos) return FALSE;
	if(pss->GetNext(pos)==this) return FALSE;
	return TRUE;
}

CRect CMSOAdrs::ToCalcExt(CSymbInst *ps, dirMode dir)
{
	CDC *pdc;
	POSITION pos;
	CRect rt(0,0,0,0);
	CSize s;
	CViecFC *peq;
	int nSpc;
	CSymbInst *pP;
	BOOL okFg;

	if(ps->GetCount()==0) {
		return CRect(-1,-1,-1,-1);
	}
	okFg = TRUE;
	pP = (CSymbInst *) ps->GetParent();
	if(pP->IsKindOf(RUNTIME_CLASS(CSymbInst)))
		if(pP->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus)))
			okFg = FALSE;
	nSpc = GetSpc(ps->GetLevel());
	pdc = GetDC();
	PETCHAR str = GetDrawName();
	SetFont(pdc, GetnDot(ps->GetLevel(), m_nDot), GetFont(), m_nCharSet, m_nItalic);
	s = pdc->GetTextExtent(str, lstrlen(str));
	ReleaseDC(pdc);
	pos = ps->GetHeadPosition();
	peq = (CViecFC*) ps->GetNext(pos);
	if(dir==dirDown) peq->CalcExt(dir);
	rt = peq->GetExtent();
	if(okFg) {
		rt.right += s.cx; // + GetSpc(ps->GetLevel());
		rt.right += nSpc;
		peq->SetOrg(CPoint(s.cx + nSpc, 0));
	} else {
		peq->SetOrg(CPoint(0, 0));
	}
	/*
	if(IsBrcRq(ps)) {
		int nBrckWd = rt.Height()/14;
		if(nBrckWd<4)	nBrckWd = 4;
		if(nBrckWd>15) nBrckWd = 15;
		CPoint org = peq->GetOrg();
		org.x += nBrckWd;
		peq->SetOrg(org);
		rt.right += 2*nBrckWd;
	}
	*/
	ps->SetExtent(rt);
	return rt;
}

void CMSOAdrs::ToDraw(CSymbInst *ps, CDC *pdc, const CPoint& shift)
{
	CPoint p0 = shift;
	p0.Offset(-ps->GetOrg());
	CSize s;
	CSymbInst *pP;
	BOOL okFg;

	okFg = TRUE;
	pP = (CSymbInst *) ps->GetParent();
	if(pP->IsKindOf(RUNTIME_CLASS(CSymbInst)))
		if(pP->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus)))
			okFg = FALSE;

	if(ps->GetCount()==0) {
		CRect r;
		pdc->SelectStockObject(BLACK_PEN);
		pdc->SelectStockObject(NULL_BRUSH);
		r = ps->GetExtent();
		r.OffsetRect(shift);
		pdc->Rectangle(&r);
		return;
	}
	int Spc = GetSpc(ps->GetLevel());
	CString str = GetDrawName();
	ps->SetFont(pdc, GetnDot(ps->GetLevel(), m_nDot), GetFont(), m_nCharSet, m_nItalic);
	s = pdc->GetTextExtent(str, lstrlen(str));
	int right0 = 0;
	/*
	if(IsBrcRq(ps)) {
		DrawBrck(pdc, ps, shift);
		int nWd = ps->GetExtent().Height();
		int nBrckWd = nWd/10;
		if(nBrckWd<4)	nBrckWd = 4;
		if(nBrckWd>15) nBrckWd = 15;
		right0 += nBrckWd;
	}
	*/
	if(okFg) {
		SetFont(pdc, GetnDot(ps->GetLevel(), m_nDot), GetFont(), m_nCharSet, m_nItalic);
		if(ps->m_bFocus) pdc->SetTextColor(RGB(0,0,255));
		else pdc->SetTextColor(RGB(0,0,0));
		pdc->TextOut(shift.x + right0, shift.y-s.cy/2, str);
	}
	POSITION pos;
	pos = ps->GetHeadPosition();
	ps->GetNext(pos)->OnDraw(pdc, shift);
}
//
//////////////////////////////////////////////////

//////CMSOPoint///////////////////////////////////////
//|C^[L
// 99/01/21 create
BOOL CMSOPoint::IsBrcRq(CSymbInst* pe)
{
	CSymbInst *pp = (CSymbInst*) pe->GetParent();
	if(!pp || !pp->IsKindOf(RUNTIME_CLASS(CSymbInst))) return TRUE;
	CViecFC *pss = pp->GetSymbBody();
	if(!pss || !pss->IsKindOf(RUNTIME_CLASS(CMSOPlus)) ) return TRUE;
	POSITION pos = pss->GetHeadPosition();
	if(!pos) return FALSE;
	if(pss->GetNext(pos)==this) return FALSE;
	return TRUE;
}

CRect CMSOPoint::ToCalcExt(CSymbInst *ps, dirMode dir)
{
	CDC *pdc;
	POSITION pos;
	CRect rt(0,0,0,0);
	CSize s;
	CViecFC *peq;
	int nSpc;
	CSymbInst *pP;
	BOOL okFg;

	if(ps->GetCount()==0) {
		return CRect(-1,-1,-1,-1);
	}
	okFg = TRUE;
	pP = (CSymbInst *) ps->GetParent();
	if(pP->IsKindOf(RUNTIME_CLASS(CSymbInst)))
		if(pP->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus)))
			okFg = FALSE;
	nSpc = GetSpc(ps->GetLevel());
	pdc = GetDC();
	PETCHAR str = GetDrawName();
	SetFont(pdc, GetnDot(ps->GetLevel(), m_nDot), GetFont(), m_nCharSet, m_nItalic);
	s = pdc->GetTextExtent(str, lstrlen(str));
	ReleaseDC(pdc);
	pos = ps->GetHeadPosition();
	peq = (CViecFC*) ps->GetNext(pos);
	if(dir==dirDown) peq->CalcExt(dir);
	rt = peq->GetExtent();
	if(okFg) {
		rt.right += s.cx; // + GetSpc(ps->GetLevel());
		rt.right += nSpc;
		peq->SetOrg(CPoint(s.cx + nSpc, 0));
	} else {
		peq->SetOrg(CPoint(0, 0));
	}
	/*
	if(IsBrcRq(ps)) {
		int nBrckWd = rt.Height()/14;
		if(nBrckWd<4)	nBrckWd = 4;
		if(nBrckWd>15) nBrckWd = 15;
		CPoint org = peq->GetOrg();
		org.x += nBrckWd;
		peq->SetOrg(org);
		rt.right += 2*nBrckWd;
	}
	*/
	ps->SetExtent(rt);
	return rt;
}

void CMSOPoint::ToDraw(CSymbInst *ps, CDC *pdc, const CPoint& shift)
{
	CPoint p0 = shift;
	p0.Offset(-ps->GetOrg());
	CSize s;
	CSymbInst *pP;
	BOOL okFg;

	okFg = TRUE;
	pP = (CSymbInst *) ps->GetParent();
	if(pP->IsKindOf(RUNTIME_CLASS(CSymbInst)))
		if(pP->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus)))
			okFg = FALSE;

	if(ps->GetCount()==0) {
		CRect r;
		pdc->SelectStockObject(BLACK_PEN);
		pdc->SelectStockObject(NULL_BRUSH);
		r = ps->GetExtent();
		r.OffsetRect(shift);
		pdc->Rectangle(&r);
		return;
	}
	int Spc = GetSpc(ps->GetLevel());
	CString str = GetDrawName();
	ps->SetFont(pdc, GetnDot(ps->GetLevel(), m_nDot), GetFont(), m_nCharSet, m_nItalic);
	s = pdc->GetTextExtent(str, lstrlen(str));
	int right0 = 0;
	/*
	if(IsBrcRq(ps)) {
		DrawBrck(pdc, ps, shift);
		int nWd = ps->GetExtent().Height();
		int nBrckWd = nWd/10;
		if(nBrckWd<4)	nBrckWd = 4;
		if(nBrckWd>15) nBrckWd = 15;
		right0 += nBrckWd;
	}
	*/
	if(okFg) {
		SetFont(pdc, GetnDot(ps->GetLevel(), m_nDot), GetFont(), m_nCharSet, m_nItalic);
		if(ps->m_bFocus) pdc->SetTextColor(RGB(0,0,255));
		else pdc->SetTextColor(RGB(0,0,0));
		pdc->TextOut(shift.x + right0, shift.y-s.cy/2, str);
	}
	POSITION pos;
	pos = ps->GetHeadPosition();
	ps->GetNext(pos)->OnDraw(pdc, shift);
}
//
//////////////////////////////////////////////////




