
#ifndef __JD_PRG_H__
#define __JD_PRG_H__

#ifndef __JD_UTL_H__
#	include "jd_utl.h"
#endif

#ifndef __PDE_ADV_H__
#	include "pde_adv.h"
#endif

class CJDGatherProc : public CJDAlgManip {
public:
	CPDProc *m_procLst[40];
	int m_procNo;
	CJDGatherProc();
	virtual BOOL Do(CObject *);
};

class CJDGatherDepVar : public CJDAlgManip {
public:
	CTargetDep targetVar[40];
	int targetNo;
	CJDGatherDepVar();
	virtual BOOL Do(CObject *);
};

class CJDGatherVar : public CJDAlgManip {
public:
	CMapStringToOb m_depVar;
	CMapStringToOb m_indepVar;
	CMapStringToOb m_matrix;
	CMapStringToOb m_para;
	CMapStringToOb m_const;
	CMapStringToOb m_const2;
	CMapStringToOb m_brkObj;
	CMapStringToOb m_file;
	CMapStringToOb m_file2;
	CJDGatherVar();
	virtual BOOL Do(CObject *);
};

class AFX_EXT_CLASS CJDCreateProgInC : public CJDAlgManip {
	DECLARE_ELEM(CJDCreateProgInC)
public:
	CString m_fileName;
	CPDEObjPrg *m_mainProg;
	CPDEInfo *m_pdeInfo;
	CJDGatherProc findProc;
	CJDGatherVar findVar;
	CJDGatherDepVar findDep;
	HANDLE m_hFile, m_hFileMap;
	LPVOID m_lpvFile;
	char *m_nextPnt, *m_firstPnt;
	int m_maxWd, m_startCol, m_lineNo, m_tabWd, m_indentNo, m_curCol;
	char m_lineFeed[3];
	BOOL m_bArraySubsc;
	BOOL m_bUseAry0;
	CPDEIndexFold *pIndexFold;
	CMapPtrToWord timeIndexTable;
	CMSIndex *pIndex;
	CPDESpaceVars *pSpaceVars;
	CPDESpaceVar *pSpaceVar;
	CPDETimeVar *pTimeVar;
	BOOL m_bDebug;

	CJDCreateProgInC();
	virtual BOOL AddTailFile(const char *buf);
	virtual BOOL LineFeed();
	virtual BOOL FillIndent();
	virtual void SortDep();
	virtual void ProgGen();
	virtual void ProgGenDebug();
	virtual void InitDebugGen();
	virtual void DetailGen(CObject *);
	virtual BOOL Do(CObject *);
};

class AFX_EXT_CLASS CJDFract2Real : public CJobDoer {
public:
	BOOL m_isUnderDepVar;
	BOOL m_isEqtDepVar;
	CJDFract2Real();
	virtual BOOL Do(CObject *);
};


#endif //__PDE_ADV_H__
