#include "stdafx.h"

#include "pde_prg.h"
#include "jd_prg.h"

IMPLEMENT_ELEM(CJDCreateProgInC,  CJDAlgManip, 222)
//fujita 98/12/08

//////////////////////  CJDGatherProc  //////////////////////
//////////////////////  CJDGatherProc  //////////////////////
CJDGatherProc::CJDGatherProc()
{
	m_procNo = 0;
}

BOOL CJDGatherProc::Do(CObject *g)
{
	if(g->IsKindOf(RUNTIME_CLASS(CPDProc))) {
		m_procLst[m_procNo] = (CPDProc *) g;
		m_procNo++;
		return TRUE;
	}
	return FALSE;
}

//////////////////////  CJDGatherDepVar  //////////////////////
//////////////////////  CJDGatherDepVar  //////////////////////

CJDGatherDepVar::CJDGatherDepVar()
{
	targetNo = 0;
}

BOOL CJDGatherDepVar::Do(CObject *g)
{
	if(g->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
		int i;
		CSymbInst *pInst, *pInst2, *pInst3;
		CMSFract *pfrct;

		pInst = (CSymbInst *) g;
		if(!pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSDepVar))) return FALSE;
		if(pInst->GetCount()==0) return TRUE;

		pInst2 = (CSymbInst *) pInst->GetChild(0);
		if(!pInst2->IsKindOf(RUNTIME_CLASS(CSymbInst))) return TRUE;
		if(pInst2->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSIndex))) {
			m_target.m_theDep = (CMSPhys *) pInst->GetSymbBody();
			m_target.m_timeIndex = (CMSIndex *) pInst2->GetSymbBody();
			m_target.m_timeShift.m_value = 0;
			m_target.m_timeShift.m_deno = 1;
		} else if(pInst2->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus)) && pInst2->GetCount()==2) {
			pInst3 = (CSymbInst *) pInst2->GetChild(0);
			pfrct = (CMSFract *) pInst2->GetChild(1);
			if(!pInst3->IsKindOf(RUNTIME_CLASS(CSymbInst))) return TRUE;
			if(!pfrct->IsKindOf(RUNTIME_CLASS(CMSFract))) return TRUE;
			if(!pInst3->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSIndex))) return TRUE;
			m_target.m_theDep = (CMSPhys *) pInst->GetSymbBody();
			m_target.m_timeIndex = (CMSIndex *) pInst3->GetSymbBody();
			m_target.m_timeShift.m_value = pfrct->m_value;
			m_target.m_timeShift.m_deno = pfrct->m_deno;
		} else {
			return TRUE;
		}
		for(i=0;i<targetNo;i++) {
			if(m_target.m_theDep==targetVar[i].m_theDep
			&& m_target.m_timeIndex==targetVar[i].m_timeIndex
			&& m_target.m_timeShift.m_value==targetVar[i].m_timeShift.m_value
			&& m_target.m_timeShift.m_value==targetVar[i].m_timeShift.m_value)
				break;
		}
		if(i<targetNo)
			return TRUE;
		targetVar[i].m_theDep = m_target.m_theDep;
		targetVar[i].m_timeIndex = m_target.m_timeIndex;
		targetVar[i].m_timeShift.m_value = m_target.m_timeShift.m_value;
		targetVar[i].m_timeShift.m_deno = m_target.m_timeShift.m_deno;
		targetNo++;
	}
	return FALSE;
}

//////////////////////  CJDGatherVar  //////////////////////
//////////////////////  CJDGatherVar  //////////////////////

CJDGatherVar::CJDGatherVar()
{
}

BOOL CJDGatherVar::Do(CObject *g)
{
	if(g->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
		CSymbInst *pInst = (CSymbInst*) g;
		if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CPDEBrkObj))) {
			m_brkObj[pInst->GetSymbBody()->GetName()] = pInst->GetSymbBody();
			return TRUE;
		}
		if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSDepVar))) {
			m_depVar[pInst->GetSymbBody()->GetName()] = pInst->GetSymbBody();
			return TRUE;
		}
		if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSIndep))) {
			m_indepVar[pInst->GetSymbBody()->GetName()] = pInst->GetSymbBody();
			return TRUE;
		}
		if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSPDEMtx))) {
			m_matrix[pInst->GetSymbBody()->GetName()] = pInst->GetSymbBody();
			return TRUE;
		}
		if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSMeshSize))) {
			m_const[pInst->GetSymbBody()->GetName()] = pInst->GetSymbBody();
			return TRUE;
		}
		if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSCReal))) {
			m_para[pInst->GetSymbBody()->GetName()] = pInst->GetSymbBody();
			return TRUE;
		}
		if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CPDEConstDef))) {
			m_const2[pInst->GetSymbBody()->GetName()] = pInst->GetSymbBody();
			return TRUE;
		}
		if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CEFile))) {
			m_file[pInst->GetSymbBody()->GetName()] = pInst->GetSymbBody();
			return TRUE;
		}
		if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CEFileFrom))) {
			m_file2[pInst->GetSymbBody()->GetName()] = pInst->GetSymbBody();
			return TRUE;
		}
	}
	return FALSE;
}

//////////////////////  CJDCreateProgInC  //////////////////////
//////////////////////  CJDCreateProgInC  //////////////////////

CJDCreateProgInC::CJDCreateProgInC()
{
	m_maxWd = 80;
	m_startCol = 0;
	m_curCol = 0;
	m_tabWd = 4;
	m_bArraySubsc = FALSE;
	m_indentNo = 0;
	lstrcpy(m_lineFeed, "\r\n");
	m_bUseAry0 = FALSE;
	m_bDebug = TRUE;
}

BOOL CJDCreateProgInC::Do(CObject *g)
{
	if(!m_bStartFg) {
		// the lowest level
		CPDEObjPrg *pObjPrg;
		CString key;
		CMSFract num;
		int i;

		//--- checks and preparations
		if(!g->IsKindOf(RUNTIME_CLASS(CPDEObjPrg))) return TRUE;
		pObjPrg = (CPDEObjPrg *) g;
		m_mainProg->SendMsg(MSG_DO_JOB, &findProc);
		m_pdeInfo->SendMsg(MSG_DO_JOB, &findProc);
		if(findProc.m_procNo==0) return TRUE;
		m_bStartFg = TRUE;
		m_mainProg->SendMsg(MSG_DO_JOB, &findVar);
		for(i=0;i<findProc.m_procNo; i++)
			findProc.m_procLst[i]->SendMsg(MSG_DO_JOB, &findDep);

		pTimeVar = (CPDETimeVar *) m_pdeInfo->GetChildElem(RUNTIME_CLASS(CPDETimeVar));
		if(pTimeVar==NULL) return TRUE;

		pSpaceVars = m_pdeInfo->m_meshInfo->m_spaceVars;
		if(!pSpaceVars || !pSpaceVars->IsKindOf(RUNTIME_CLASS(CPDESpaceVars))) return TRUE;
		if(pSpaceVars->GetCount()==0) return TRUE;

		pIndexFold = (CPDEIndexFold *) pTimeVar->m_indexFold;
		if(!pIndexFold || !pIndexFold->IsKindOf(RUNTIME_CLASS(CPDEIndexFold))) return TRUE;

		//--- open a program file to write into
		m_hFile = ::CreateFile(m_fileName, GENERIC_WRITE | GENERIC_READ,
			0, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		if(m_hFile==INVALID_HANDLE_VALUE) return TRUE;
		m_hFileMap = ::CreateFileMapping(m_hFile, NULL, PAGE_READWRITE,
			0, 1024*1024, NULL);
		if(m_hFileMap==NULL) {
			::CloseHandle(m_hFile);
			return TRUE;
		}
		m_lpvFile = ::MapViewOfFile(m_hFileMap, FILE_MAP_WRITE, 0,0,0);
		if(m_lpvFile==NULL) {
			::CloseHandle(m_hFileMap);
			::CloseHandle(m_hFile);
			return TRUE;
		}
		m_nextPnt = m_firstPnt = (char *) m_lpvFile;

		//--- sorting the dep var and generate the program
		SortDep();

		// generate the header
		if(!m_bDebug)
			ProgGen();//
		else
			ProgGenDebug();

		//--- program generation
		for(i=0;i<findProc.m_procNo; i++) {
			findProc.m_procLst[i]->SendMsg(MSG_DO_JOB, this);
			LineFeed();
			LineFeed();
		}

		//--- close the program file
		::UnmapViewOfFile(m_lpvFile);
		::CloseHandle(m_hFileMap);
		::SetFilePointer(m_hFile, m_nextPnt-m_firstPnt, NULL, FILE_BEGIN);
		::SetEndOfFile(m_hFile);
		::CloseHandle(m_hFile);
		return TRUE;
	} else {
		DetailGen(g);  // after the first stop
		return TRUE;
	}
	return FALSE;
}

void CJDCreateProgInC::SortDep()
{
	int i, j, k;
	CMSDepVar *pDep;
	BOOL changedFg;
	POSITION pos;
	CString key;
	CTargetDep tmp;

	for(i=0;i<pIndexFold->GetCount();i++) {
		pIndex = (CMSIndex *) pIndexFold->GetChild(i);
		timeIndexTable[pIndex] = i;
	}

	i = 0;
	pos = findVar.m_depVar.GetStartPosition();
	while(pos && i<findDep.targetNo) {
		findVar.m_depVar.GetNextAssoc(pos, key, (CObject*&) pDep);
		k = i;
		while(i<findDep.targetNo && findDep.targetVar[i].m_theDep==pDep) i++;
		if(i<findDep.targetNo && findDep.targetVar[i].m_theDep!=pDep) {
			do {
				changedFg = FALSE;
				for(j=i+1;j<findDep.targetNo;j++) {
					if(findDep.targetVar[j].m_theDep==pDep) {
						tmp.Copy(&findDep.targetVar[i]);
						findDep.targetVar[i].Copy(&findDep.targetVar[j]);
						findDep.targetVar[j].Copy(&tmp);
						changedFg = TRUE;
						i++;
						break;
					}
				}
			} while(changedFg && i<findDep.targetNo && findDep.targetVar[i].m_theDep!=pDep);
		}
		do {
			WORD no1,no2;
			changedFg = FALSE;
			for(j=k;j<(i-1);j++) {
				if(!timeIndexTable.Lookup(findDep.targetVar[j].m_timeIndex, no1)) continue;
				if(!timeIndexTable.Lookup(findDep.targetVar[j+1].m_timeIndex, no2)) continue;
				if(no2<no1) {
					tmp.Copy(&findDep.targetVar[j]);
					findDep.targetVar[j].Copy(&findDep.targetVar[j+1]);
					findDep.targetVar[j+1].Copy(&tmp);
					changedFg = TRUE;
				}
			}
		} while(changedFg);
	}
	for(i=0;i<findDep.targetNo;i++)
		findDep.targetVar[i].m_number = -1;
	for(i=0;i<findDep.targetNo;i++) {
		if(findDep.targetVar[i].m_number>=0) continue;
		findDep.targetVar[i].m_number = 0;
		k = 1;
		for(j=i+1;j<findDep.targetNo;j++) {
			if(findDep.targetVar[i].m_theDep==findDep.targetVar[j].m_theDep)
				findDep.targetVar[j].m_number = k++;
		}
	}
}

void CJDCreateProgInC::ProgGen()
{
	int i;
	POSITION pos;
	CString key;
	char buf[100];
	CMSCReal *pPm;
	CMSIndep *pIndep;
	CMSPDEMtx *pMatrix;

	//--- program generation
	LineFeed();
	AddTailFile("#include <stdio.h>");
	LineFeed();
	AddTailFile("#include <math.h>");
	LineFeed();
	LineFeed();

	CMSMeshSize *pMs;
	AddTailFile("/* Definition of constants */");
	LineFeed();
	pos = findVar.m_const.GetStartPosition();
	while(pos) {
		findVar.m_const.GetNextAssoc(pos, key, (CObject*&) pMs);
		sprintf(buf, "#define %s %d", (const char*) pMs->GetName(), (int) pMs->m_value);
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	//--- definition of constant
	CPDEConstDef *pCst;
	pos = findVar.m_const2.GetStartPosition();
	while(pos) {
		findVar.m_const2.GetNextAssoc(pos, key, (CObject*&) pCst);
		if(pCst->GetCount()==0) continue;
		AddTailFile("#define ");
		AddTailFile(pCst->GetName());
		AddTailFile(" (");
		pCst->GetChild(0)->SendMsg(MSG_DO_JOB, this);
		AddTailFile(" )");
		LineFeed();
	}
	LineFeed();

	//--- prototype of all functions in the program
	const char *cmmt1 = "/* prototypes definition of all functions in this program */";
	AddTailFile(cmmt1);
	LineFeed();
	for(i=0; i<findProc.m_procNo; i++) {
		sprintf(buf, "void %s();", findProc.m_procLst[i]->GetName());
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();
	LineFeed();

	/////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////
	//--- para var declaration
	//--- time step variable
	AddTailFile("/* time step variable */");	LineFeed();
	sprintf(buf, "int %s;", (const char *) pTimeVar->m_pIndex->GetName());
	AddTailFile(buf);
	LineFeed();	LineFeed();

	AddTailFile("/* Declaration of parameters */");
	LineFeed();
	pos = findVar.m_para.GetStartPosition();
	while(pos) {
		findVar.m_para.GetNextAssoc(pos, key, (CObject*&) pPm);
		sprintf(buf, "double %s = %lf;", (const char*) pPm->GetName(), pPm->m_value);
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	AddTailFile("/* Declaration of independent variables */");
	LineFeed();
	pos = findVar.m_indepVar.GetStartPosition();
	while(pos) {
		findVar.m_indepVar.GetNextAssoc(pos, key, (CObject*&) pIndep);
		if(pIndep->IsKindOf(RUNTIME_CLASS(CMSIndepConst))) {
			sprintf(buf, "double %s = %lf;", pIndep->GetName(), ((CMSIndepConst*)pIndep)->GetValue());
		} else {
			sprintf(buf, "double %s;", (const char*) pIndep->GetName());
		}
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();


	AddTailFile("/* Declaration of dependent variables */");
	LineFeed();
	for(i=0;i<findDep.targetNo;i++) {
		if(!findDep.targetVar[i].m_theDep->IsKindOf(RUNTIME_CLASS(CMSDepVar)))
			continue;
		if(!findDep.targetVar[i].m_timeIndex->IsKindOf(RUNTIME_CLASS(CMSIndex)))
			continue;
		if(findDep.targetVar[i].m_number==0)
			sprintf(buf, "double %s[", (const char*) findDep.targetVar[i].m_theDep->GetName());
		else
			sprintf(buf, "double %s%d[", (const char*) findDep.targetVar[i].m_theDep->GetName()
			, findDep.targetVar[i].m_number);
		AddTailFile(buf);
		pos = pSpaceVars->GetHeadPosition();
		while(pos) {
			pSpaceVar = (CPDESpaceVar *) pSpaceVars->GetNext(pos);
			AddTailFile(pSpaceVar->m_division->GetName());
			if(pos) AddTailFile(m_bUseAry0? "][" : "+1][");
		}
		AddTailFile(m_bUseAry0? "];" : "+1];");
		sprintf(buf, "/* %s %s %d */", (const char*) findDep.targetVar[i].m_theDep->GetName()
		, (const char*) findDep.targetVar[i].m_timeIndex->GetName()
		, findDep.targetVar[i].m_timeShift.m_value
		, findDep.targetVar[i].m_number);
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	CSymbInst *pSb;
//	AddTailFile("/* Declaration of matrix and vector */"); //Kawa <- original
	AddTailFile("/*  --- ---  */");
	LineFeed();
	pos = findVar.m_matrix.GetStartPosition();
	while(pos) {
		findVar.m_matrix.GetNextAssoc(pos, key, (CObject*&) pMatrix);
//		if(pMatrix->GetCount()!=1) continue;
		pSb = (CSymbInst*) pMatrix->GetChild(0);
		if(!pSb->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
			int ddd = 2;
		sprintf(buf, "double %s", pMatrix->GetName());
		AddTailFile(buf);
		if(pMatrix->IsKindOf(RUNTIME_CLASS(CMSPDEVct)))	ddd = 1;
		for(i=0;i<ddd;i++) {
			AddTailFile("[");
			AddTailFile(pSb->GetSymbBody()->GetName());
			AddTailFile("+1]");
		}
		AddTailFile(";");
		LineFeed();
	}
	LineFeed();
			
}

void CJDCreateProgInC::ProgGenDebug()
{
	int i;
	POSITION pos;
	CString key;
	char buf[100];
	CMSCReal *pPm;
	CMSIndep *pIndep;
	CMSPDEMtx *pMatrix;

	//--- program generation
	LineFeed();
	AddTailFile("#include <stdio.h>");
	LineFeed();
	AddTailFile("#include <math.h>");
	LineFeed();
	LineFeed();

	AddTailFile("#define ___DEBUG___"); LineFeed(); LineFeed();

	CMSMeshSize *pMs;
	AddTailFile("/* Definition of constants */");
	LineFeed();
	pos = findVar.m_const.GetStartPosition();
	while(pos) {
		findVar.m_const.GetNextAssoc(pos, key, (CObject*&) pMs);
		sprintf(buf, "#define %s %d", (const char*) pMs->GetName(), (int) pMs->m_value);
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	//--- definition of constant
	CPDEConstDef *pCst;
	pos = findVar.m_const2.GetStartPosition();
	while(pos) {
		findVar.m_const2.GetNextAssoc(pos, key, (CObject*&) pCst);
		if(pCst->GetCount()==0) continue;
		AddTailFile("#define ");
		AddTailFile(pCst->GetName());
		AddTailFile(" ");
		AddTailFile(" (");
		pCst->GetChild(0)->SendMsg(MSG_DO_JOB, this);
		AddTailFile(" )");
		LineFeed();
	}
	LineFeed();

	//--- definition of file pointer
	CEFile *pF;
	pos = findVar.m_file.GetStartPosition();
	for(i=1; pos; i++) {
		findVar.m_file.GetNextAssoc(pos, key, (CObject*&) pF);
		sprintf(buf, "FILE *filePnt%d;", i);
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	//--- prototype of all functions in the program
	const char *cmmt1 = "/* prototypes definition of all functions in this program */";
	AddTailFile(cmmt1);
	LineFeed();
	for(i=0; i<findProc.m_procNo; i++) {
		sprintf(buf, "void %s();", findProc.m_procLst[i]->GetName());
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();
	LineFeed();

	/////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////
	AddTailFile("#ifndef ___DEBUG___"); LineFeed(); LineFeed();

	//--- time step variable
	AddTailFile("/* time step variable */");	LineFeed();
	sprintf(buf, "int %s;", (const char *) pTimeVar->m_pIndex->GetName());
	AddTailFile(buf);
	LineFeed();	LineFeed();

	AddTailFile("/* Declaration of parameters */");	LineFeed();
	pos = findVar.m_para.GetStartPosition();
	while(pos) {
		findVar.m_para.GetNextAssoc(pos, key, (CObject*&) pPm);
		sprintf(buf, "double %s = %lf;", (const char*) pPm->GetName(), pPm->m_value);
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	pos = findVar.m_indepVar.GetStartPosition();
	while(pos) {
		findVar.m_indepVar.GetNextAssoc(pos, key, (CObject*&) pIndep);
		if(pIndep->IsKindOf(RUNTIME_CLASS(CMSIndepConst))) {
			sprintf(buf, "double %s = %lf;", pIndep->GetName(), ((CMSIndepConst*)pIndep)->GetValue());
		} else {
			sprintf(buf, "double %s;", (const char*) pIndep->GetName());
		}
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	for(i=0;i<findDep.targetNo;i++) {
		if(!findDep.targetVar[i].m_theDep->IsKindOf(RUNTIME_CLASS(CMSDepVar)))
			continue;
		if(!findDep.targetVar[i].m_timeIndex->IsKindOf(RUNTIME_CLASS(CMSIndex)))
			continue;
		if(findDep.targetVar[i].m_number==0)
			sprintf(buf, "double %s[", (const char*) findDep.targetVar[i].m_theDep->GetName());
		else
			sprintf(buf, "double %s%d[", (const char*) findDep.targetVar[i].m_theDep->GetName()
			, findDep.targetVar[i].m_number);
		AddTailFile(buf);
		pos = pSpaceVars->GetHeadPosition();
		while(pos) {
			pSpaceVar = (CPDESpaceVar *) pSpaceVars->GetNext(pos);
			AddTailFile(pSpaceVar->m_division->GetName());
			if(pos) AddTailFile(m_bUseAry0? "][" : "+1][");
		}
		AddTailFile(m_bUseAry0? "];" : "+1];");
		sprintf(buf, "/* %s %s %d */", (const char*) findDep.targetVar[i].m_theDep->GetName()
		, (const char*) findDep.targetVar[i].m_timeIndex->GetName()
		, findDep.targetVar[i].m_timeShift.m_value
		, findDep.targetVar[i].m_number);
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	CSymbInst *pSb;
	POSITION pos2;	
	AddTailFile("/* Declaration of matrix and vector */");	
	LineFeed();
	pos = findVar.m_matrix.GetStartPosition();
	while(pos) {
		findVar.m_matrix.GetNextAssoc(pos, key, (CObject*&) pMatrix);
		sprintf(buf, "double %s", pMatrix->GetName());
		AddTailFile(buf);
		pos2 = pMatrix->GetHeadPosition();
		while(pos2) {
			pSb = (CSymbInst *) pMatrix->GetNext(pos2);
			if(pSb->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
				AddTailFile("[");
				AddTailFile(pSb->GetSymbBody()->GetName());
				AddTailFile("+1]");
			}
		}
		AddTailFile(";");
		LineFeed();
	}
	LineFeed();

	/////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////
	AddTailFile("#else"); LineFeed(); LineFeed();
	/////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////

	int VarNo = 1;
	//int VctNo = 0;
	//--- count the number of matrix and dependent var
	pos = findVar.m_para.GetStartPosition();
	while(pos) {
		findVar.m_para.GetNextAssoc(pos, key, (CObject*&) pPm);
		VarNo++;
	}
	pos = findVar.m_indepVar.GetStartPosition();
	while(pos) {
		findVar.m_indepVar.GetNextAssoc(pos, key, (CObject*&) pIndep);
		VarNo++;
	}
	pos = findVar.m_matrix.GetStartPosition();
	while(pos) {
		findVar.m_matrix.GetNextAssoc(pos, key, (CObject*&) pMatrix);
//		if(pMatrix->GetCount()!=1) continue;
		pSb = (CSymbInst*) pMatrix->GetChild(0);
		if(!pSb->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
		VarNo++;
	}
	for(i=0;i<findDep.targetNo;i++) {
		if(!findDep.targetVar[i].m_theDep->IsKindOf(RUNTIME_CLASS(CMSDepVar)))	continue;
		if(!findDep.targetVar[i].m_timeIndex->IsKindOf(RUNTIME_CLASS(CMSIndex))) continue;
		VarNo++;
	}

	AddTailFile("#include <windows.h>"); LineFeed(); LineFeed();

	//***************************************************************************
	//***************************************************************************
	//--- variable declaration 
	//--- define body structure
	AddTailFile("struct SYSTEM_VARS {"); LineFeed();
	m_indentNo++;
	FillIndent(); AddTailFile("short int VarNo;"); LineFeed();
	FillIndent(); AddTailFile("char pszStatus[22];"); LineFeed();
	FillIndent(); AddTailFile("struct {"); LineFeed();
	m_indentNo++;
	FillIndent(); AddTailFile("char varName[16];"); LineFeed();
	FillIndent(); AddTailFile("short int type;"); LineFeed();
	FillIndent(); AddTailFile("short int size[3];"); LineFeed();
	FillIndent(); AddTailFile("long pBody;"); LineFeed();
	m_indentNo--;
	sprintf(buf, "} varList[%d];", VarNo);
	FillIndent(); AddTailFile(buf); LineFeed();
	LineFeed();

	//--- 1. matrices
	pos = findVar.m_matrix.GetStartPosition();
	while(pos) {
		findVar.m_matrix.GetNextAssoc(pos, key, (CObject*&) pMatrix);
//		if(pMatrix->GetCount()!=1) continue;
		FillIndent();
		sprintf(buf, "double %s", pMatrix->GetName());
		AddTailFile(buf);
		pos2 = pMatrix->GetHeadPosition();
		while(pos2) {
			pSb = (CSymbInst *) pMatrix->GetNext(pos2);
			if(pSb->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
				AddTailFile("[");
				AddTailFile(pSb->GetSymbBody()->GetName());
				AddTailFile("+1]");
			}
		}
		AddTailFile(";");
		LineFeed();
	}
	LineFeed();

	//--- 2. dependant variables
	for(i=0;i<findDep.targetNo;i++) {
		if(!findDep.targetVar[i].m_theDep->IsKindOf(RUNTIME_CLASS(CMSDepVar)))	continue;
		if(!findDep.targetVar[i].m_timeIndex->IsKindOf(RUNTIME_CLASS(CMSIndex)))	continue;
		if(findDep.targetVar[i].m_number==0)
			sprintf(buf, "double %s[", (const char*) findDep.targetVar[i].m_theDep->GetName());
		else
			sprintf(buf, "double %s%d[", (const char*) findDep.targetVar[i].m_theDep->GetName()
			, findDep.targetVar[i].m_number);
		FillIndent();
		AddTailFile(buf);
		pos = pSpaceVars->GetHeadPosition();
		while(pos) {
			pSpaceVar = (CPDESpaceVar *) pSpaceVars->GetNext(pos);
			AddTailFile(pSpaceVar->m_division->GetName());
			if(pos) AddTailFile(m_bUseAry0? "][" : "+1][");
		}
		AddTailFile(m_bUseAry0? "];" : "+1];");
		sprintf(buf, "/* %s(%s%+d) */", (const char*) findDep.targetVar[i].m_theDep->GetName()
		, (const char*) findDep.targetVar[i].m_timeIndex->GetName()
		, findDep.targetVar[i].m_timeShift.m_value
		, findDep.targetVar[i].m_number);
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	//--- 3. parameters
	pos = findVar.m_para.GetStartPosition();
	while(pos) {
		findVar.m_para.GetNextAssoc(pos, key, (CObject*&) pPm);
		sprintf(buf, "double %s;", (const char*) pPm->GetName());
		FillIndent();
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	//--- 4.independant variables
	pos = findVar.m_indepVar.GetStartPosition();
	while(pos) {
		findVar.m_indepVar.GetNextAssoc(pos, key, (CObject*&) pIndep);
		sprintf(buf, "double %s;", (const char*) pIndep->GetName());
		FillIndent();
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	//--- time step variable
	sprintf(buf, "int %s;", (const char *) pTimeVar->m_pIndex->GetName());
	FillIndent();	AddTailFile(buf);	LineFeed();
	LineFeed();

	m_indentNo--;
	AddTailFile("} *system_vars;"); LineFeed();
	LineFeed();
	//***************************************************************************
	//***************************************************************************


	//***************************************************************************
	//***************************************************************************
	//--- define how to use the variables
	LineFeed();
	pos = findVar.m_matrix.GetStartPosition();
	while(pos) {
		findVar.m_matrix.GetNextAssoc(pos, key, (CObject*&) pMatrix);
//		if(pMatrix->GetCount()!=1) continue;
		sprintf(buf, "#define %s system_vars->%s"
		, (const char *) pMatrix->GetName(), (const char *) pMatrix->GetName());
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	char buf2[100];
	for(i=0;i<findDep.targetNo;i++) {
		if(!findDep.targetVar[i].m_theDep->IsKindOf(RUNTIME_CLASS(CMSDepVar)))	continue;
		if(!findDep.targetVar[i].m_timeIndex->IsKindOf(RUNTIME_CLASS(CMSIndex)))	continue;
		if(findDep.targetVar[i].m_number==0)
			sprintf(buf2, "%s", (const char*) findDep.targetVar[i].m_theDep->GetName());
		else
			sprintf(buf2, "%s%d", (const char*) findDep.targetVar[i].m_theDep->GetName()
			, findDep.targetVar[i].m_number);
		sprintf(buf, "#define %s system_vars->%s", buf2, buf2);
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	pos = findVar.m_para.GetStartPosition();
	while(pos) {
		findVar.m_para.GetNextAssoc(pos, key, (CObject*&) pPm);
		sprintf(buf, "#define %s system_vars->%s"
		, (const char*) pPm->GetName(), (const char*) pPm->GetName());
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	pos = findVar.m_indepVar.GetStartPosition();
	while(pos) {
		findVar.m_indepVar.GetNextAssoc(pos, key, (CObject*&) pIndep);
		sprintf(buf, "#define %s system_vars->%s"
		, (const char*) pIndep->GetName(), (const char*) pIndep->GetName());
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	sprintf(buf, "#define %s system_vars->%s"
		, (const char *) pTimeVar->m_pIndex->GetName(), (const char *) pTimeVar->m_pIndex->GetName());
	AddTailFile(buf);	LineFeed();
	LineFeed();

	//***************************************************************************
	//***************************************************************************

	CPDEBrkObj *pBrkObj;
	pos = findVar.m_brkObj.GetStartPosition();
	while(pos) {
		findVar.m_brkObj.GetNextAssoc(pos, key, (CObject*&) pBrkObj);
		sprintf(buf, "HANDLE h%s;", (const char *) pBrkObj->GetName());
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	AddTailFile("HANDLE hSignal, hFM;");	LineFeed();	LineFeed();

	AddTailFile("#define VAR_TYPE_2_DIM_REAL 1");	LineFeed();
	AddTailFile("#define VAR_TYPE_1_DIM_REAL 2");	LineFeed();
	AddTailFile("#define VAR_TYPE_REAL 3");	LineFeed();
	AddTailFile("#define VAR_TYPE_INTEGER 4");	LineFeed();
	LineFeed();

	InitDebugGen();
	//---

	AddTailFile("#endif"); LineFeed(); LineFeed();
			
}

//////////////////////////////////////////////////////
//////////////////////////////////////////////////////

void CJDCreateProgInC::InitDebugGen()
{
	char buf[200], nm[40];
	POSITION pos;
	CString key;
	CMSCReal *pPm;
	CMSIndep *pIndep;
	CMSPDEMtx *pMatrix;
	CSymbInst *pSb;

	AddTailFile("void InitDebug()"); LineFeed();
	AddTailFile("{"); LineFeed();
	m_indentNo++;

	CPDEBrkObj *pBrkObj;
	pos = findVar.m_brkObj.GetStartPosition();
	while(pos) {
		findVar.m_brkObj.GetNextAssoc(pos, key, (CObject*&) pBrkObj);
		sprintf(buf, "h%s = CreateEvent(NULL, FALSE, FALSE, \"%s_BRK%s\");"
			, (const char *) pBrkObj->GetName()
			, (const char *) m_mainProg->GetName()
			, (const char *) pBrkObj->GetName());
		FillIndent();	AddTailFile(buf);	LineFeed();
	}

	sprintf(buf, "hSignal = CreateEvent(NULL, FALSE, FALSE, \"%s_SIGNAL\");"
		,(const char *) m_mainProg->GetName());
	FillIndent();	AddTailFile(buf);	LineFeed();

	sprintf(buf
	, "hFM = CreateFileMapping((HANDLE)-1, NULL, PAGE_READWRITE, 0, sizeof(struct SYSTEM_VARS), \"%s_VARS\");"
	, (const char *) m_mainProg->GetName());
	FillIndent();	AddTailFile(buf);	LineFeed();
	sprintf(buf, "system_vars = (struct SYSTEM_VARS *) MapViewOfFile(hFM, FILE_MAP_WRITE, 0,0,0);");
	FillIndent();	AddTailFile(buf);	LineFeed();
	LineFeed();

	int i, j;
	POSITION pos2;
	int curVarNo = 0;

	//--- 1. matrices
	pos = findVar.m_matrix.GetStartPosition();
	while(pos) {
		findVar.m_matrix.GetNextAssoc(pos, key, (CObject*&) pMatrix);
		int ddd = pMatrix->GetCount();

		sprintf(buf, "lstrcpy(system_vars->varList[%d].varName, \"%s\");"
			, curVarNo, (const char *) pMatrix->GetName());
		FillIndent();	AddTailFile(buf);	LineFeed();
		if(ddd==2)
			sprintf(buf, "system_vars->varList[%d].type = VAR_TYPE_2_DIM_REAL;", curVarNo);
		else
			sprintf(buf, "system_vars->varList[%d].type = VAR_TYPE_1_DIM_REAL;", curVarNo);
		FillIndent();	AddTailFile(buf);	LineFeed();
		pos2 = pMatrix->GetHeadPosition();
		for(i=0; pos2 && i<3; i++) {
			pSb = (CSymbInst *) pMatrix->GetNext(pos2);
			if(pSb->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
				sprintf(buf, "system_vars->varList[%d].size[%d] = %s+1;"
					, curVarNo, i, (const char *) pSb->GetSymbBody()->GetName());
				FillIndent();	AddTailFile(buf);	LineFeed();
			}
		}
		sprintf(buf, "system_vars->varList[%d].pBody = (BYTE*)%s-(BYTE*)system_vars;"
			, curVarNo, (const char *) pMatrix->GetName());
		FillIndent();	AddTailFile(buf);	LineFeed();
		LineFeed();

		curVarNo++;
	}

	//--- 2. dependant variables
	for(i=0;i<findDep.targetNo;i++) {
		if(!findDep.targetVar[i].m_theDep->IsKindOf(RUNTIME_CLASS(CMSDepVar)))	continue;
		if(!findDep.targetVar[i].m_timeIndex->IsKindOf(RUNTIME_CLASS(CMSIndex)))	continue;
		if( findDep.targetVar[i].m_timeShift.m_value==0)
			sprintf(nm, "%s(%s)", (const char*) findDep.targetVar[i].m_theDep->GetName()
			, (const char*) findDep.targetVar[i].m_timeIndex->GetName());
		else
			sprintf(nm, "%s(%s%+d)", (const char*) findDep.targetVar[i].m_theDep->GetName()
			, (const char*) findDep.targetVar[i].m_timeIndex->GetName()
			, findDep.targetVar[i].m_timeShift.m_value);

		sprintf(buf, "lstrcpy(system_vars->varList[%d].varName, \"%s\");", curVarNo, nm);
		FillIndent();	AddTailFile(buf);	LineFeed();

		if(findDep.targetVar[i].m_number==0)
			sprintf(nm, "%s", (const char*) findDep.targetVar[i].m_theDep->GetName());
		else
			sprintf(nm, "%s%d", (const char*) findDep.targetVar[i].m_theDep->GetName()
			, findDep.targetVar[i].m_number);
		sprintf(buf, "system_vars->varList[%d].type = VAR_TYPE_2_DIM_REAL;", curVarNo);
		FillIndent();	AddTailFile(buf);	LineFeed();
		pos = pSpaceVars->GetHeadPosition();
		for(j=0; pos ; j++) {
			pSpaceVar = (CPDESpaceVar *) pSpaceVars->GetNext(pos);
			sprintf(buf, "system_vars->varList[%d].size[%d] = %s+1;"
			, curVarNo, j, (const char *) pSpaceVar->m_division->GetName());
			FillIndent();	AddTailFile(buf);	LineFeed();
		}
		sprintf(buf, "system_vars->varList[%d].pBody = (BYTE*)%s-(BYTE*)system_vars;", curVarNo, nm);
		FillIndent();	AddTailFile(buf);	LineFeed();
		LineFeed();

		curVarNo++;
	}
	LineFeed();

	//--- 3. parameters
	pos = findVar.m_para.GetStartPosition();
	while(pos) {
		findVar.m_para.GetNextAssoc(pos, key, (CObject*&) pPm);
		sprintf(buf, "lstrcpy(system_vars->varList[%d].varName, \"%s\");"
			, curVarNo, (const char*) pPm->GetName());
		FillIndent();	AddTailFile(buf);	LineFeed();
		sprintf(buf, "system_vars->varList[%d].type = VAR_TYPE_REAL;", curVarNo);
		FillIndent();	AddTailFile(buf);	LineFeed();
		sprintf(buf, "system_vars->varList[%d].pBody = (BYTE*)&%s-(BYTE*)system_vars;"
			, curVarNo, (const char *) pPm->GetName());
		FillIndent();	AddTailFile(buf);	LineFeed();
		sprintf(buf, "%s = %lf;", (const char*) pPm->GetName(), pPm->m_value);
		FillIndent();	AddTailFile(buf);	LineFeed();
		LineFeed();

		curVarNo++;
	}
	LineFeed();

	//--- 4.independant variables
	LineFeed();
	pos = findVar.m_indepVar.GetStartPosition();
	while(pos) {
		findVar.m_indepVar.GetNextAssoc(pos, key, (CObject*&) pIndep);
		sprintf(buf, "lstrcpy(system_vars->varList[%d].varName, \"%s\");"
			, curVarNo, (const char*) pIndep->GetName());
		FillIndent();	AddTailFile(buf);	LineFeed();
		sprintf(buf, "system_vars->varList[%d].type = VAR_TYPE_REAL;", curVarNo);
		FillIndent();	AddTailFile(buf);	LineFeed();
		sprintf(buf, "system_vars->varList[%d].pBody = (BYTE*)&%s-(BYTE*)system_vars;"
			, curVarNo, (const char *) pIndep->GetName());
		FillIndent();	AddTailFile(buf);	LineFeed();
		if(pIndep->IsKindOf(RUNTIME_CLASS(CMSIndepConst))) {
			sprintf(buf, "%s = %lf;", pIndep->GetName(), ((CMSIndepConst*) pIndep)->GetValue());
			FillIndent();	AddTailFile(buf);	LineFeed();
		}
		LineFeed();

		curVarNo++;
	}
	LineFeed();

	//--- time step variable
	sprintf(buf, "lstrcpy(system_vars->varList[%d].varName, \"%s\");"
		, curVarNo, (const char *) pTimeVar->m_pIndex->GetName());
	FillIndent();	AddTailFile(buf);	LineFeed();
	sprintf(buf, "system_vars->varList[%d].type = VAR_TYPE_INTEGER;", curVarNo);
	FillIndent();	AddTailFile(buf);	LineFeed();
	sprintf(buf, "system_vars->varList[%d].pBody = (BYTE*)&%s-(BYTE*)system_vars;"
		, curVarNo, (const char *) pTimeVar->m_pIndex->GetName());
	FillIndent();	AddTailFile(buf);	LineFeed();
	LineFeed();

	curVarNo++;

	sprintf(buf, "system_vars->VarNo = %d;", curVarNo);
	FillIndent();	AddTailFile(buf);	LineFeed();

	FillIndent();	AddTailFile("SetEvent(hSignal);");	LineFeed();
	/////////////////////////////////////////////////////////////////////////
	m_indentNo--;
	AddTailFile("}"); LineFeed(); LineFeed();
}

void CJDCreateProgInC::DetailGen(CObject *g)
{
		char buf[100];
		POSITION pos;
		int i;

		m_lineNo = 0;
		// this is to create program
		if(g->IsKindOf(RUNTIME_CLASS(CPDProc))) {
			CPDProc *pPrc = (CPDProc *) g;
			sprintf(buf, "void %s()", pPrc->GetName());
			AddTailFile(buf);
			LineFeed();

			AddTailFile("{");	LineFeed();
			m_indentNo++;
			if(CString("main")==pPrc->GetName()) {
				if(m_bDebug) {
					AddTailFile("#ifdef ___DEBUG___"); LineFeed();
					FillIndent(); AddTailFile("InitDebug();"); LineFeed();
					AddTailFile("#endif"); LineFeed();
				}
				CEFile *pF;
				CString key;
				pos = findVar.m_file.GetStartPosition();
				for(i=1; pos; i++) {
					findVar.m_file.GetNextAssoc(pos, key, (CObject*&) pF);
					sprintf(buf, "filePnt%d = fopen(\"%s\", \"w\");", i, pF->GetName());
					FillIndent(); AddTailFile(buf); LineFeed();
				}
				CEFileFrom *pFrom;
				CString key2;
				pos = findVar.m_file2.GetStartPosition();
				for(i=1; pos; i++) {
					findVar.m_file2.GetNextAssoc(pos, key2, (CObject*&) pFrom);
					sprintf(buf, "filePnt_R%d = fopen(\"%s\", \"r\");", i, pFrom->GetName());
					FillIndent(); AddTailFile(buf); LineFeed();
				}
				LineFeed();
			}
			pos = pPrc->GetHeadPosition();
			pPrc->GetNext(pos);
			while(pos) {
				pPrc->GetNext(pos)->SendMsg(MSG_DO_JOB, this);
			}
			if(CString("main")==pPrc->GetName()) {
				CEFile *pF;
				CString key;
				pos = findVar.m_file.GetStartPosition();
				for(i=1; pos; i++) {
					findVar.m_file.GetNextAssoc(pos, key, (CObject*&) pF);
					sprintf(buf, "fclose(filePnt%d);", i, pF->GetName());
					FillIndent(); AddTailFile(buf); LineFeed();
				}
				CEFileFrom *pFrom;
				CString key2;
				pos = findVar.m_file2.GetStartPosition();
				for(i=1; pos; i++) {
					findVar.m_file2.GetNextAssoc(pos, key2, (CObject*&) pFrom);
					sprintf(buf, "fclose(filePnt_R%d);", i, pFrom->GetName());
					FillIndent(); AddTailFile(buf); LineFeed();
				}
				LineFeed();
			}
			m_indentNo--;
			AddTailFile("}");	LineFeed();
		} else if(g->IsKindOf(RUNTIME_CLASS(CPDBrkPnt))) {
			CPDBrkPnt *pBrkPnt = (CPDBrkPnt *) g;
			if(pBrkPnt->GetCount()!=1) return;
			CSymbInst *pObjI = (CSymbInst *) pBrkPnt->GetChild(0);
			if(!pObjI->IsKindOf(RUNTIME_CLASS(CSymbInst))) return;
			if(!pObjI->GetSymbBody()) return;
			CPDEBrkObj *pObj = (CPDEBrkObj *) pObjI->GetSymbBody();
			if(!pObj->IsKindOf(RUNTIME_CLASS(CPDEBrkObj))) return;
			if(!m_bDebug) return;
			AddTailFile("#ifdef ___DEBUG___"); LineFeed();
			sprintf(buf, "lstrcpy(system_vars->pszStatus, \"%s,%s\");"
				, (const char *) pBrkPnt->GetName(), (const char *) pObj->GetName());
			FillIndent();	AddTailFile(buf);	LineFeed();
			FillIndent();	AddTailFile("SetEvent(hSignal);"); LineFeed();
//			FillIndent();	AddTailFile("PulseEvent(hSignal);"); LineFeed();
			sprintf(buf, "WaitForSingleObject(h%s, INFINITE);"
				, (const char *) pObj->GetName());
			FillIndent();	AddTailFile(buf);	LineFeed();
//			FillIndent();	AddTailFile("system_vars->pszStatus[0]=0;"); LineFeed();
			AddTailFile("#endif"); LineFeed();
		} else if(g->IsKindOf(RUNTIME_CLASS(CPDOutput))) {
			CSymbInst *pI;
			CPDOutput *pPrt = (CPDOutput *) g;
			if(pPrt->GetCount()!=1) return;
			CPDArgs *pArg = (CPDArgs *) pPrt->GetChild(0);
			if(!pArg->IsKindOf(RUNTIME_CLASS(CPDArgs))) return;
			FillIndent();	AddTailFile("printf(\"");
			pos = pArg->GetHeadPosition();
			while(pos) {
				pI = (CSymbInst *) pArg->GetNext(pos);
				if(!pI->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
					//if(pI->IsKindOf(RUNTIME_CLASS(CMSArg))) break; //NXCMSArgȂΏo͉Zq͂QƂB
					continue;
				}
				if(pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSIndex))
				|| pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSCInteger))) {
					AddTailFile("%d ");
				} else {
					AddTailFile("%e ");
				}
			}
			AddTailFile("\\n\"");
			pos = pArg->GetHeadPosition();
			while(pos) {
				pI = (CSymbInst *) pArg->GetNext(pos);
				if(!pI->IsKindOf(RUNTIME_CLASS(CSymbInst))){
					//if(pI->IsKindOf(RUNTIME_CLASS(CMSArg))) pI->SendMsg(MSG_DO_JOB, this);
					continue;
				}
				AddTailFile(",");
				pI->SendMsg(MSG_DO_JOB, this);
			}
			AddTailFile(");"); LineFeed();
		} else if(g->IsKindOf(RUNTIME_CLASS(CPDFile))) {
			/*
			CSymbInst *pI;
			CEFile *pF;
			CString key;
			int i,j;
			j = -1;
			CPDOutput *pPrt = (CPDOutput *) g;
			if(pPrt->GetCount()!=2) return;
			pI = (CSymbInst *) pPrt->GetChild(0);
			pos = findVar.m_file.GetStartPosition();
			for(i=1; pos; i++) {
				findVar.m_file.GetNextAssoc(pos, key, (CObject*&) pF);
				if(key==CString(pI->GetSymbBody()->GetName())) {
					sprintf(buf, "FILE *filePnt%d;", i);
					j = i;
					break;
				}
			}
			if(j<1) return;
			CPDArgs *pArg = (CPDArgs *) pPrt->GetChild(1);
			if(!pArg->IsKindOf(RUNTIME_CLASS(CPDArgs))) return;
			sprintf(buf, "fprintf(filePnt%d, \"", j);
			FillIndent();	AddTailFile(buf);
			pos = pArg->GetHeadPosition();
			while(pos) {
				pI = (CSymbInst *) pArg->GetNext(pos);
				if(!pI->IsKindOf(RUNTIME_CLASS(CSymbInst))){ 
					if(pI->IsKindOf(RUNTIME_CLASS(CMSArg))) break;
					continue;
				}

				if(pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSIndex))
				|| pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSCInteger))) {
					AddTailFile("%d ");
				} else {
					AddTailFile("%e ");
				}
			}
			//AddTailFile("\\n\"");
			pos = pArg->GetHeadPosition();
			while(pos) {
				pI = (CSymbInst *) pArg->GetNext(pos);
				if(!pI->IsKindOf(RUNTIME_CLASS(CSymbInst))){ 
					if(pI->IsKindOf(RUNTIME_CLASS(CMSArg))) {
						pI->SendMsg(MSG_DO_JOB, this);
						AddTailFile("\"");
						continue;
					}
					AddTailFile(",");
					pI->SendMsg(MSG_DO_JOB, this);
				}
			}
			AddTailFile(");"); 
			LineFeed();
			*/
			CSymbInst *pI;
			CEFile *pF;
			CString key;
			int i,j;
			j = -1;
			CPDOutput *pPrt = (CPDOutput *) g;
			if(pPrt->GetCount()!=2) return;
			pI = (CSymbInst *) pPrt->GetChild(0);
			pos = findVar.m_file.GetStartPosition();
			for(i=1; pos; i++) {
				findVar.m_file.GetNextAssoc(pos, key, (CObject*&) pF);
				if(key==CString(pI->GetSymbBody()->GetName())) {
					sprintf(buf, "FILE *filePnt%d;", i);
					j = i;
					break;
				}
			}
			if(j<1) return;
			CPDArgs *pArg = (CPDArgs *) pPrt->GetChild(1);
			if(!pArg->IsKindOf(RUNTIME_CLASS(CPDArgs))) return;
			sprintf(buf, "fprintf(filePnt%d, \"", j);
			FillIndent();	AddTailFile(buf);
			pos = pArg->GetHeadPosition();
			while(pos) {
				pI = (CSymbInst *) pArg->GetNext(pos);
				if(!pI->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
				if(pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSIndex))
				|| pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSCInteger))) {
					AddTailFile("%d ");
				} else {
					AddTailFile("%e ");
				}
			}
			AddTailFile("\\n\"");
			pos = pArg->GetHeadPosition();
			while(pos) {
				pI = (CSymbInst *) pArg->GetNext(pos);
				if(!pI->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
				AddTailFile(",");
				pI->SendMsg(MSG_DO_JOB, this);
			}
			AddTailFile(");"); LineFeed();
		//add fujita 990618 CPDFileFrom"r"[h̃t@C
		} else if(g->IsKindOf(RUNTIME_CLASS(CPDFileFrom))) {
			CSymbInst *pI;
			CEFileFrom *pF;
			CString key;
			int i,j;
			j = -1;
			CPDOutput *pPrt = (CPDOutput *) g;
			if(pPrt->GetCount()!=2) return;
			pI = (CSymbInst *) pPrt->GetChild(0);
			//pos = findVar.m_file.GetStartPosition();
			pos = findVar.m_file2.GetStartPosition();
			for(i=1; pos; i++) {
				findVar.m_file2.GetNextAssoc(pos, key, (CObject*&) pF);
				if(key==CString(pI->GetSymbBody()->GetName())) {
					sprintf(buf, "FILE *filePnt_R%d;", i);
					j = i;
					break;
				}
			}
			if(j<1) return;
			CPDArgs *pArg = (CPDArgs *) pPrt->GetChild(1);
			if(!pArg->IsKindOf(RUNTIME_CLASS(CPDArgs))) return;
			//sprintf(buf, "fprintf(filePnt%d, \"", j);
			sprintf(buf, "fgets(");
			FillIndent();	AddTailFile(buf);
			/*
			pos = pArg->GetHeadPosition();
			while(pos) {
				pI = (CSymbInst *) pArg->GetNext(pos);
				if(!pI->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
				if(pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSIndex))
				|| pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSCInteger))) {
					AddTailFile("%d ");
				} else {
					AddTailFile("%e ");
				}
			}
			AddTailFile("\\n\"");
			*/
			if(!pArg->GetCount() == 1) throw; //fgets̎q͕KPłB
			pos = pArg->GetHeadPosition();
			while(pos) {
				pI = (CSymbInst *) pArg->GetNext(pos);
				if(!pI->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
				//AddTailFile(",");
				pI->SendMsg(MSG_DO_JOB, this);
				AddTailFile(",sizeof(");
				pI->SendMsg(MSG_DO_JOB, this);
				AddTailFile("),");
				sprintf(buf,"filePnt_R%d );",j);
				AddTailFile(buf);
			}
			//AddTailFile(");"); 
			LineFeed();
		} else if(g->IsKindOf(RUNTIME_CLASS(CPDVar))) {
			CPDVar *pVar = (CPDVar *) g;
			BOOL fstFg ;
			if(pVar->GetCount()==0) return;

			//--- int variable
			fstFg = TRUE;
			pos = pVar->GetHeadPosition();
			while(pos) {
				CMSIndex *pIdx;
				pIdx = (CMSIndex*) pVar->GetNext(pos);
				if(pIdx->IsKindOf(RUNTIME_CLASS(CMSIndex))) {
					if(fstFg) {
						FillIndent();
						AddTailFile("int ");
					} else {
						AddTailFile(", ");
					}
					sprintf(buf, "%s", pIdx->GetName());
					AddTailFile(buf);
					fstFg = FALSE;
				}
			}
			if(!fstFg) {
				AddTailFile(";");
				LineFeed();
			}

			//--- double variable
			fstFg = TRUE;
			pos = pVar->GetHeadPosition();
			while(pos) {
				CMSConst *pCnst;
				pCnst = (CMSConst *) pVar->GetNext(pos);
				if(pCnst->IsKindOf(RUNTIME_CLASS(CMSConst))) {
					if(fstFg) {
						FillIndent();
						AddTailFile("double ");
					} else {
						AddTailFile(", ");
					}
					sprintf(buf, "%s", pCnst->GetName());
					AddTailFile(buf);
					fstFg = FALSE;
				}
			}
			if(!fstFg) {
				AddTailFile(";");
				LineFeed();
			}
		} else if(g->IsKindOf(RUNTIME_CLASS(CPDComm))) {
			CPDComm *pCmm = (CPDComm *) g;
			sprintf(buf, "/* %s */", pCmm->GetName());
			FillIndent();
			AddTailFile(buf);
			LineFeed();
		} else if(g->IsKindOf(RUNTIME_CLASS(CPDBlock))) {
			CPDBlock *pBlk = (CPDBlock *) g;
			sprintf(buf, "/* %s */", pBlk->GetName());
			FillIndent();
			AddTailFile(buf);
			LineFeed();

			FillIndent();
			AddTailFile("{");	LineFeed();
			m_indentNo++;
			pos = pBlk->GetHeadPosition();
			while(pos)
				pBlk->GetNext(pos)->SendMsg(MSG_DO_JOB, this);
			m_indentNo--;
			FillIndent();
			AddTailFile("}");	LineFeed();
		} else if(g->IsKindOf(RUNTIME_CLASS(CPDFor))) {
			CPDFor *pFor = (CPDFor *) g;
			if(pFor->GetCount()<1) return;
			pos = pFor->GetHeadPosition();
			CPDForSub *pForSub = (CPDForSub *) pFor->GetNext(pos);
			if(pForSub->GetCount()<3) return;
			int skip = 0;
			CMSFract *pF;
			if(pForSub->GetCount()==4) {
				pF = (CMSFract *) pForSub->GetChild(3);
				if(pF->IsKindOf(RUNTIME_CLASS(CMSFract)))
					if(pF->m_value!=0 && pF->m_value!=1)
						skip = pF->m_value;
			}
			FillIndent();
			AddTailFile("for(");
			pForSub->GetChild(0)->SendMsg(MSG_DO_JOB, this);
			AddTailFile("=");
			pForSub->GetChild(1)->SendMsg(MSG_DO_JOB, this);
			AddTailFile("; ");
			pForSub->GetChild(0)->SendMsg(MSG_DO_JOB, this);
			if(skip>=0) {
				AddTailFile("<=");
			} else if(skip<0) {
				AddTailFile(">=");
			}
			pForSub->GetChild(2)->SendMsg(MSG_DO_JOB, this);
			AddTailFile("; ");
			pForSub->GetChild(0)->SendMsg(MSG_DO_JOB, this);
			if(skip==0) {
				AddTailFile("++) {");
			} else if(skip>1) {
				sprintf(buf, "+= %d) {", skip);
				AddTailFile(buf);
			} else if(skip<0) {
				sprintf(buf, "-= %d) {", -skip);
				AddTailFile(buf);
			}
			LineFeed();

			m_indentNo++;
			while(pos)
				pFor->GetNext(pos)->SendMsg(MSG_DO_JOB, this);
			m_indentNo--;
			FillIndent();
			AddTailFile("}");	LineFeed();
		} else if(g->IsKindOf(RUNTIME_CLASS(CPDIf))) {
			CPDIf *pIf = (CPDIf *) g;
			if(pIf->GetCount()==3) {
				CPad *pCond = (CPad *) pIf->GetChild(0);
				CPad *pThen = (CPad *) pIf->GetChild(1);
				CPad *pElse = (CPad *) pIf->GetChild(2);

				FillIndent();
				AddTailFile("if(");
				pCond->SendMsg(MSG_DO_JOB, this);
				AddTailFile(") {");
				LineFeed();

				m_indentNo++;
				pos = pThen->GetHeadPosition();
				while(pos)
					pThen->GetNext(pos)->SendMsg(MSG_DO_JOB, this);
				m_indentNo--;
				if(pElse->GetCount()>0) {
					FillIndent();
					AddTailFile("} else {");
					LineFeed();
					m_indentNo++;
					pos = pElse->GetHeadPosition();
					while(pos)
						pElse->GetNext(pos)->SendMsg(MSG_DO_JOB, this);
					m_indentNo--;
				}
				FillIndent();
				AddTailFile("}");
				LineFeed();
			}
		} else if(g->IsKindOf(RUNTIME_CLASS(CPDCall))) {
			CPDCall *pCall = (CPDCall *) g;
			FillIndent();
			sprintf(buf, "%s();", pCall->GetName());
			AddTailFile(buf);
			LineFeed();
		} else if(g->IsKindOf(RUNTIME_CLASS(CPDSubst))) {
			CPad *pad = (CPad *) g;
			pos = pad->GetHeadPosition();
			while(pos)
				pad->GetNext(pos)->SendMsg(MSG_DO_JOB, this);
		} else if(g->IsKindOf(RUNTIME_CLASS(CMSArg))){
			/*
			CMSArg *pA = (CMSArg*) g;
			sprintf(buf,pA->GetName());
			AddTailFile(buf);
			*/
			// modify fujita 99/10/30 
			CMSArg *pA = (CMSArg*) g;
			CString str,str2;
			str = pA->GetName();

			int i,j;
			i = 0;
			int ch;
			j = str.GetLength(); //̒擾

			while(j > i){
				if(str[i] != '"') { //'"'ȊOȂ炻̂܂ܑ
					ch = str[i];
					str2 += ch;
					//str2.SetAt(j,ch);
				}else {//"""ȂA̕֐iށB
					i++;
					continue;
				}
				i++;
			}
			
			strcpy(buf,str2);
			AddTailFile(buf);
		} else if(g->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
			CSymbInst *pInst = (CSymbInst *) g;
			if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOEqual))) {
				if(pInst->GetCount()==2) {
					FillIndent();
					pInst->GetChild(0)->SendMsg(MSG_DO_JOB, this);
					AddTailFile(" = ");
					pInst->GetChild(1)->SendMsg(MSG_DO_JOB, this);
					AddTailFile(";");
					LineFeed();
				}
			} else if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOAbs))) {
				AddTailFile("fabs(");
				pInst->GetChild(0)->SendMsg(MSG_DO_JOB, this);
				AddTailFile(")");
				if(m_lineNo>0) {
					BOOL b = pInst->IsKindOf(RUNTIME_CLASS(CSymbInst));
				}
			} else if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSONeg))) {
				CMSONeg *pNeg = (CMSONeg *) pInst->GetSymbBody();
				if(pInst->GetCount()==0) return;
				if(pInst->GetParent()->IsKindOf(RUNTIME_CLASS(CSymbInst))
				&& ((CSymbInst*)pInst->GetParent())->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
					pInst->GetChild(0)->SendMsg(MSG_DO_JOB, this);
				} else {
					if(pNeg->IsBrcRq(pInst))	AddTailFile("(");
					AddTailFile("-");
					pInst->GetChild(0)->SendMsg(MSG_DO_JOB, this);
					if(pNeg->IsBrcRq(pInst))	AddTailFile(")");
				}
			/*************************************************/
			// if g-pointer indicate CMSOAdrs,
			// CMSOAdrs denote 'symbol &? structure. 
			// codeing by fujita. 99/02/15.
			} else if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOAdrs))) {
				CMSOAdrs *pAdrs = (CMSOAdrs *) pInst->GetSymbBody();
				if(pInst->GetCount()==0) return; //Ȃ炸qB
				AddTailFile("&"); //AhXL
				pInst->GetChild(0)->SendMsg(MSG_DO_JOB, this); //q̋Lq AhXϐ
			} else if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
				CMSOPlus *pPls = (CMSOPlus*) pInst->GetSymbBody();
				CViecFC *pelm;
				BOOL bArraySubs = m_bArraySubsc;
				BOOL bBrc = pPls->IsBrcRq(pInst);

				if(pInst->GetParent()->IsKindOf(RUNTIME_CLASS(CSymbInst))
					&& ((CSymbInst*)pInst->GetParent())->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSODiv)))
					bBrc = TRUE;

				m_bArraySubsc = FALSE;
				if(bBrc)	AddTailFile("(");
				int lineNo = 0;
				int startCol = m_startCol;
				m_startCol = m_curCol;
				pos = pInst->GetHeadPosition();
				pelm = pInst->GetNext(pos);
				if(pelm->IsKindOf(RUNTIME_CLASS(CSymbInst))
				&& ((CSymbInst*)pelm)->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSONeg)))
					AddTailFile("-");
//				pelm->SendMsg(MSG_DO_JOB, this);
				m_lineNo = 0;
				pelm->SendMsg(MSG_DO_JOB, this);
				lineNo += m_lineNo;
				while(pos) {
					pelm = pInst->GetNext(pos);
					char *pmk = "+";
					char *nextPnt = m_nextPnt;
					int curCol = m_curCol;
					if(pelm->IsKindOf(RUNTIME_CLASS(CSymbInst))
					&& ((CSymbInst*)pelm)->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSONeg))) {
						pmk = "-";
					} else if(pelm->IsKindOf(RUNTIME_CLASS(CMSNumber))
					&& ((CMSNumber*)pelm)->IsNeg()) {
						pmk = "-";
					}
					m_lineNo = 0;
					AddTailFile(pmk);
					pelm->SendMsg(MSG_DO_JOB, this);
					lineNo += m_lineNo;
					if(m_lineNo>0 || m_curCol>=m_maxWd) {
						lineNo -= m_lineNo;
						m_nextPnt = nextPnt;
						m_curCol = curCol;
						LineFeed();
						FillIndent();  //insert TAB 
						AddTailFile(pmk);
						pelm->SendMsg(MSG_DO_JOB, this);
						lineNo += m_lineNo;
						lineNo++;
					}
				}
				if(bArraySubs && m_bUseAry0)	AddTailFile("-1");
				if(bBrc)	AddTailFile(")");
				m_lineNo = lineNo;
				m_startCol = startCol;
			} else if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSODiv))) {
				if(pInst->GetCount()==2) {
					pInst->GetChild(0)->SendMsg(MSG_DO_JOB, this);	//??
					AddTailFile("/");
					AddTailFile("(");
					pInst->GetChild(1)->SendMsg(MSG_DO_JOB, this);
					AddTailFile(")");
				}
			} else if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOperator))) {
				CViecFC *pelm;					  // for *, mod???
				CMSOperator *pOp = (CMSOperator *) pInst->GetSymbBody();
				if(pOp->IsBrcRq(pInst))	AddTailFile("(");
				int lineNo = 0;
				int startCol = m_startCol;
				m_startCol = m_curCol;
				pos = pInst->GetHeadPosition();
				pelm = pInst->GetNext(pos);
				m_lineNo = 0;
				pelm->SendMsg(MSG_DO_JOB, this);
				lineNo += m_lineNo;
				while(pos) {
					pelm = pInst->GetNext(pos);
					char *nextPnt = m_nextPnt;
					int curCol = m_curCol;
					AddTailFile(pOp->GetName());
					m_lineNo = 0;
					pelm->SendMsg(MSG_DO_JOB, this);
					lineNo += m_lineNo;
					if(m_lineNo>0 || m_curCol>=m_maxWd) {
						lineNo -= m_lineNo;
						m_nextPnt = nextPnt;
						m_curCol = curCol;
						LineFeed();
						FillIndent();
						AddTailFile(pOp->GetName());
						pelm->SendMsg(MSG_DO_JOB, this);
						lineNo += m_lineNo;
						lineNo++;
					}
				}
				if(pOp->IsBrcRq(pInst))	AddTailFile(")");
				m_lineNo = lineNo;
				m_startCol = startCol;
			} else if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSDepVar))) {
				int i;						 // put indexes for n, i,j,k
				if(pInst->GetCount()<2) return;
				pos = pInst->GetHeadPosition();
				pInst->GetNext(pos);
				for(i=0;i<findDep.targetNo;i++)
					if(findDep.targetVar[i].IsThis(pInst))
						break;
				if(i>=findDep.targetNo) return;
				if(findDep.targetVar[i].m_number==0)
					sprintf(buf, "%s", (const char*) pInst->GetSymbBody()->GetName());
				else
					sprintf(buf, "%s%d", (const char*) pInst->GetSymbBody()->GetName()
					, findDep.targetVar[i].m_number);
				AddTailFile(buf);
				while(pos) {
					AddTailFile("[");
					m_bArraySubsc = TRUE;
					pInst->GetNext(pos)->SendMsg(MSG_DO_JOB, this);
					m_bArraySubsc = FALSE;
					AddTailFile("]");
				}
			} else if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMathSymb))) {
				BOOL bArraySubsc = m_bArraySubsc;
				m_bArraySubsc = FALSE;
				AddTailFile(pInst->GetSymbBody()->GetName());
				pos = pInst->GetHeadPosition();
				while(pos) {
					AddTailFile("[");
					m_bArraySubsc = TRUE;
					pInst->GetNext(pos)->SendMsg(MSG_DO_JOB, this);
					m_bArraySubsc = FALSE;
					AddTailFile("]");
				}
				if(bArraySubsc && m_bUseAry0) AddTailFile("-1");
			}
		} else if(g->IsKindOf(RUNTIME_CLASS(CMSRealEx))) {
			CMSRealEx *pR = (CMSRealEx *) g;
			double val = pR->m_value;
			BOOL kakko = FALSE;

			if(pR->GetParent()->IsKindOf(RUNTIME_CLASS(CSymbInst))
			&& ((CSymbInst*)pR->GetParent())->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
				if(val<0)
					val = -val;
			} else if(pR->GetParent()->IsKindOf(RUNTIME_CLASS(CSymbInst))
			&& ((CSymbInst*)pR->GetParent())->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOperator))) {
				kakko = TRUE;
			}
			if(kakko && val<0)
				sprintf(buf, "(%lf)", val);
			else
				sprintf(buf, "%lf", val);
				// fujita check 98/7/26
			AddTailFile(buf);
		} else if(g->IsKindOf(RUNTIME_CLASS(CMSFract))) {
			CMSFract *pF = (CMSFract *) g;
			int val = pF->m_value;
			BOOL kakko = FALSE;

			if(pF->GetParent()->IsKindOf(RUNTIME_CLASS(CSymbInst))
			&& ((CSymbInst*)pF->GetParent())->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
				if(val<0)
					val = -val;
			} else if(pF->GetParent()->IsKindOf(RUNTIME_CLASS(CSymbInst))
			&& ((CSymbInst*)pF->GetParent())->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOperator))) {
				kakko = TRUE;
			}
			if(pF->m_deno==1)
				if(kakko && val<0)
					sprintf(buf, "(%d)", val);	// for var
				else
					sprintf(buf, "%d", val);
					
			else
				if(kakko && val<0)
					sprintf(buf, "(%d/%u)", val, pF->m_deno);
				else
					sprintf(buf, "%d/%u", val, pF->m_deno);
			AddTailFile(buf);
		} else if(g->IsKindOf(RUNTIME_CLASS(CPDCallBy))) {
			/*
			CPDCallBy *pCall = (CPDCallBy *) g;
			
			FillIndent();
			sprintf(buf, "%s(", pCall->GetName());
			AddTailFile(buf);
			pos = pCall->GetHeadPosition(); //̐擪W擾
			CPDArgs *pArg = (CPDArgs *) pCall->GetNext(pos); //̃NXɂ͕Kʂ̎qNXB
			if(pArg->IsKindOf(RUNTIME_CLASS(CPDArgs))) {
				POSITION pos2;
				CPElem *pMsArg; 
				pos2 = pArg->GetHeadPosition();  //ʂ̎qNX̐擪Wl
				while(pos2) { //qȂȂ܂ł̃[vJԂB
					pMsArg = (CPElem *) pArg->GetNext(pos2);
					pMsArg->SendMsg(MSG_DO_JOB, this);
					if(pos2) AddTailFile(","); //ɎqȂEE
				}
			}
			AddTailFile(");"); LineFeed(); //ʂ̒̎qȂȂEE

			//̎qɈڂB
			while(pos) {
				pCall->GetNext(pos)->SendMsg(MSG_DO_JOB, this);
			}
			*/

			/*
			CPDCallBy *pCall = (CPDCallBy *) g;
			
			FillIndent();
			sprintf(buf, "%s(", pCall->GetName());
			AddTailFile(buf);
			pos = pCall->GetHeadPosition(); //̐擪W擾
			CPDArgs *pArg = (CPDArgs *) pCall->GetNext(pos); //̃NXɂ͕Kʂ̎qNXB
			if(pArg->IsKindOf(RUNTIME_CLASS(CPDArgs))) {
				POSITION pos2;
				CPElem *pMsArg; 
				pos2 = pArg->GetHeadPosition();  //ʂ̎qNX̐擪Wl
				while(pos2) { //qȂȂ܂ł̃[vJԂB
					pMsArg = (CPElem *) pArg->GetNext(pos2);
					pMsArg->SendMsg(MSG_DO_JOB, this);
					if(pos2) AddTailFile(","); //ɎqȂEE
				}
			}
			AddTailFile(");"); LineFeed(); //ʂ̒̎qȂȂEE

			//̎qɈڂB
			while(pos) {
				pCall->GetNext(pos)->SendMsg(MSG_DO_JOB, this);
			}
			*/

			// modify fujita 99/10/30 
			CPDCallBy *pCall = (CPDCallBy *) g;
			/******************************************/
			FillIndent();
			sprintf(buf, "%s(", pCall->GetName());
			AddTailFile(buf);
			pos = pCall->GetHeadPosition(); //̐擪W擾
			CPDArgs *pArg = (CPDArgs *) pCall->GetNext(pos); //̃NXɂ͕Kʂ̎qNXB
			if(pArg->IsKindOf(RUNTIME_CLASS(CPDArgs))) {
				POSITION pos2;
				CPElem *pMsArg; 
				pos2 = pArg->GetHeadPosition();  //ʂ̎qNX̐擪Wl
				while(pos2) { //qȂȂ܂ł̃[vJԂB
					pMsArg = (CPElem *) pArg->GetNext(pos2);
					if(!pMsArg->IsKindOf(RUNTIME_CLASS(CMSArg))){
						pMsArg->SendMsg(MSG_DO_JOB, this);
					}else{
						AddTailFile("\"");
						pMsArg->SendMsg(MSG_DO_JOB, this);
						AddTailFile("\"");
					}
					if(pos2) AddTailFile(","); //ɎqȂEE	
				}
			}
			AddTailFile(");"); LineFeed(); //ʂ̒̎qȂȂEE

			//̎qɈڂB
			while(pos) {
				pCall->GetNext(pos)->SendMsg(MSG_DO_JOB, this);
			}


		} else if(g->IsKindOf(RUNTIME_CLASS(CMSCRealSub))) {
			CMSCRealSub *pRS = (CMSCRealSub *) g;
			//sprintf(buf, "%lf", pRS->m_value); // fujita 98/7/30
			sprintf(buf, "%6.3f", pRS->m_value);
			AddTailFile(buf);
		}
}

BOOL CJDCreateProgInC::FillIndent()
{
	int i;
	if(m_curCol>0) return FALSE;
	for(i=0; m_curCol<m_indentNo*m_tabWd; i++) {
		AddTailFile("\t");
		m_curCol += m_tabWd-1;
	}
	while(m_curCol<m_startCol) {
		AddTailFile(" ");
	}
	return TRUE;
}

BOOL CJDCreateProgInC::LineFeed()
{
	AddTailFile(m_lineFeed);
	m_curCol = 0;
	return TRUE;
}

BOOL CJDCreateProgInC::AddTailFile(const char* buf)
{
	lstrcpy(m_nextPnt, buf);
	m_nextPnt += lstrlen(buf);
	m_curCol += lstrlen(buf);
	return TRUE;
}

