#ifndef __PDE_MSG_H__
#define __PDE_MSG_H__

#define CMD_PROC	0x1100
#define MSG_PDE	0xA000

#define MSG_PDE_GET_MESH_NO		MSG_PDE | 0x0001
#define MSG_PDE_GET_AXIS_NO		MSG_PDE | 0x0002
#define MSG_PDE_GET_BOUND_INFO	MSG_PDE | 0x0003
#define MSG_PDE_MESH_CHANGED	MSG_PDE | 0x0004

#define CMD_FIND_THE_DEP_VAR	MSG_PDE | 0x0005
#define CMD_FIND_THE_IND_VAR	MSG_PDE | 0x0006
#define CMD_FIND_THE_IND_VAR2	MSG_PDE | 0x0007
#define CMD_FIND_THE_IND_VAR3	MSG_PDE | 0x0008
#define CMD_FIND_THE_IND_VAR4	MSG_PDE | 0x0009
#define CMD_FIND_TIME_INDEX		MSG_PDE | 0x000A
#define CMD_FIND_THE_PARAM		MSG_PDE | 0x000B
#define CMD_FIND_THE_MATRIX		MSG_PDE | 0x000C

#define CMD_DEP_DISCRETE	MSG_PDE | 0x000D
#define CMD_DEP_UNDISCRETE	MSG_PDE | 0x000E
#define CMD_DEP_DISCRETE2	MSG_PDE | 0x000F

#define CMD_DEP_ADD_BC	MSG_PDE | 0x0010
#define CMD_DEP_ADD_EQUATION	MSG_PDE | 0x0012

#define CMD_BND_ADD_BOUND	MSG_PDE | 0x0011
#define CMD_NEW_DEP_VAR		MSG_PDE | 0x0013
#define CMD_NEW_PARAM		MSG_PDE | 0x0014
#define CMD_INPUT_VALUE		MSG_PDE | 0x0015
#define CMD_SET_2D_INFO		MSG_PDE | 0x0016
#define CMD_NEW_PARAM_FOLD	MSG_PDE | 0x0017
#define CMD_LOAD_PDE_INFO	MSG_PDE | 0x0018
#define CMD_NEW_PROCEDURE	MSG_PDE | 0x0019
#define CMD_PDE_RUN_SPREAD	MSG_PDE | 0x001A
#define CMD_NEW_OBTAINED_VARS	MSG_PDE | 0x001B
#define CMD_NEW_INVOKED_PROCS	MSG_PDE | 0x001C
#define CMD_NEW_TARGET_VAR	MSG_PDE | 0x001D

#define CMD_SUBST_PROBLEM	MSG_PDE | 0x001E
#define CMD_RUN_CREATE_PROG	MSG_PDE | 0x001F
#define CMD_RUN_CREATE_C	MSG_PDE | 0x0020
#define CMD_RUN_CREATE_C_DEBUG	MSG_PDE | 0x0021
#define CMD_RUN_CREATE_FORT	MSG_PDE | 0x0022

#define CMD_BRK_ADD_OBJ	MSG_PDE | 0x0023
#define MSG_BTTN_PRESSED	MSG_PDE | 0x0024
#define MSG_CONST_CHANGED	MSG_PDE | 0x0025
#define CMD_ADD_2DIM_VAR_WATCH	MSG_PDE | 0x0026

#define CMD_RUN_THE_PROG	MSG_PDE | 0x0027
#define CMD_COMPILE_RUN_THE_PROG	MSG_PDE | 0x0029
#define MSG_PROG_START_RUNNIG	MSG_PDE | 0x002A
#define MSG_PROG_STOP_RUNNIG	MSG_PDE | 0x002B

#define CMD_NEW_FILE_FOLD	MSG_PDE | 0x002C
#define CMD_NEW_FILE	MSG_PDE | 0x002D

#define CMD_NEW_FILE_INST	MSG_PDE | 0x002E
#define CMD_CHG_SYMB_INST_TO_REAL	MSG_PDE | 0x002F
#define CMD_PROC_SHOW_VARS	MSG_PDE | 0x0030
#define CMD_RUN_AUTOMATIC	MSG_PDE | 0x0031

#define CMD_SET_1D_INFO		MSG_PDE | 0x0032
#define CMD_SET_3D_INFO		MSG_PDE | 0x0033

#define CMD_ADD_3DIM_VAR_WATCH	MSG_PDE | 0x0034
//add fujita 990615
#define CMD_NEW_FILE_FROM	MSG_PDE | 0x0035

#define CMD_FIND_DEP_RESULT		0xB000
#define CMD_FIND_RESULT_WITH2	0xC000
#define CMD_SELECT_FROM_GROUP_FOR_CHILD	0xD000

#define CMD_PROC_ELEM_COPY	CMD_PROC | 0x0001
#define CMD_PROC_FORM_STRCT	CMD_PROC | 0x0002
#define CMD_PROC_ADD_MANIP	CMD_PROC | 0x0003

#define CMD_PROC_MANIP_1	CMD_PROC | 0x0004
#define CMD_PROC_MANIP_2	CMD_PROC | 0x0005
#define CMD_PROC_MANIP_3	CMD_PROC | 0x0006
#define CMD_PROC_MANIP_4	CMD_PROC | 0x0007
#define CMD_PROC_MANIP_5	CMD_PROC | 0x0008
#define CMD_PROC_MANIP_6	CMD_PROC | 0x0009
#define CMD_PROC_MANIP_7	CMD_PROC | 0x000A
#define CMD_PROC_MANIP_8	CMD_PROC | 0x000B
#define CMD_PROC_MANIP_9	CMD_PROC | 0x000C
#define CMD_PROC_MANIP_10	CMD_PROC | 0x000D
#define CMD_PROC_MANIP_11	CMD_PROC | 0x000E
#define CMD_PROC_MANIP_12	CMD_PROC | 0x000F
#define CMD_PROC_MANIP_13	CMD_PROC | 0x0010
#define CMD_PROC_MANIP_14	CMD_PROC | 0x0011

#define CMD_PROC_PASS_EQT	CMD_PROC | 0x0012
#define CMD_PROC_GEN_SOLVER	CMD_PROC | 0x0013
#define CMD_PROC_DEL_ALL	CMD_PROC | 0x0014

#define CMD_NEW_PDE_SET		CMD_PROC | 0x0015
#define CMD_INT_SET_VALUE	CMD_PROC | 0x0016

#define CMD_WAIT_FOR_CONNECTION	CMD_PROC | 0x0017

#endif __PDE_MSG_H__
