
#ifndef __JD_PRCPara_H__
#define __JD_PRCPara_H__


#ifndef __JD_PRC_H__
#	include "../pad/jd_prc.h"
#endif

#ifndef __ParaELEM_H__
#	include "Paraelem.h"
#endif

#ifndef __ParaPAD_H__
#	include "Parapad.h"
#endif

/////////// fujiaki 98/12/02 ///////////////////////
////////// CPDEParaDefs class //////////////////////
class AFX_EXT_CLASS CPDELocalDefs : public CPDEBase {
	DECLARE_ELEM(CPDELocalDefs)
public:
	CPDELocalDefs();
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
};

/////////// fujiaki 98/12/02 ///////////////////////
////////// CPDEParaDefs class //////////////////////
class AFX_EXT_CLASS CPDEParaDefs : public CPDEBase {
	DECLARE_ELEM(CPDEParaDefs)
public:
	CPDEParaDefs();
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
};


class AFX_EXT_CLASS CJDCreateProcPara : public CJDCreateProc {

	DECLARE_ELEM(CJDCreateProcPara)

public:
	
	virtual BOOL Do(CObject *);

	//BOOL FindStartCond(CSymbInst* pInst);

};

class AFX_EXT_CLASS CJDCreateMainProcPara : public CJDCreateMainProc {
	 
	DECLARE_ELEM(CJDCreateMainProcPara)
protected:
	int dim;
	int m_Max_CPU;
	int m_xdiv,m_ydiv,m_zdiv;
	CPDEParaDefs *m_pCons;

public: 
	//CMSMeshSize *p_Max_Cpu;
	CMSInteger *p_Max_Cpu;
	CMSInteger *p_x_div;
	CMSInteger *p_y_div;
	CMSInteger *p_z_div;

	CPDEParaDefs *pParameter;//pp[^̃|C^[MAX_CPU,x_div,y_div,z_div

	CPDProc *pMPIinit,*pSetparameter,*pSetgather,*pDatashift,*pDatagather;
	CPDProc *pOutput,*pSubst,*pMPIfini,*pSetrange,*pPararange;
	CPDProc *pParatype;//ő͂
	
	CPDProc *pInitPara;
	CPDEParaDefs *pParaVarDefs;	 //As a temporal class we used Mtx (matrix )class.
								 //CPDEParaDefs equivalence CPDEMtxDefs. 
	//p̕ϐ֐ŁAfɂďقȂB
	virtual void Cons_Variable_Make(CViecFC *);  //Cons type
	virtual void MPI_Variable_Make(CViecFC *);  //MPI type
	virtual void Int_Variable_Make(CViecFC *);  //Int type
	virtual void Double_Variable_Make(CViecFC *); //Double type


	virtual void Local_Main_Make(CViecFC *); //mainŗpϐB
	virtual void Local_MPIinit_Make(CViecFC *); //MPIinitŗpϐB
	virtual void Local_Datashift_Make(CViecFC *); //Data_ShiftŗpϐB
	virtual void Local_Datagather_Make(CViecFC *); //Data_GatherŗpϐB
	virtual void Local_Pararange_Make(CViecFC *); //Para_RangeŗpϐB
	virtual void Local_Setrange_Make(CViecFC *); //Set_RangeŗpϐB
	virtual void Local_Paratypeblock1d_Make(CViecFC *); //Para_Type_Block1dŗpϐB
	virtual void Local_Paratypeblock2d_Make(CViecFC *); //Para_Type_Block2dŗpϐB
	virtual void Local_Paratypeblock3d_Make(CViecFC *); //Para_Type_Block3dŗpϐB


	virtual void Make_MPIinit_ParaProc(CViecFC *); //MPIInit function B
	virtual void Make_Setparameter_ParaProc(CViecFC *); //Set_Parameter() create
	virtual void Make_Setgather_ParaProc(CViecFC *); //Set_Gather() create
	virtual void Make_Init_ParaProc(CViecFC *); //Init() create
	virtual void Make_Datashift_ParaProc(CViecFC *); //Data_Shift() create
	virtual void Make_Datagather_ParaProc(CViecFC *); //Data_gather() create
	virtual void Make_Output_ParaProc(CViecFC *); //output() create
	virtual void Make_Subst_ParaProc(CViecFC *); //subst() create
	virtual void Make_MPIfinish_ParaProc(CViecFC *); //MPIfinish create
	virtual void Make_Setrange_ParaProc(CViecFC *); //Para_Range() create
	virtual void Make_Pararange_ParaProc(CViecFC *); //Para_Range() create
	virtual void Make_Paratypeblock1d_ParaProc(CViecFC *); //Para_Type_Block1d() create
	virtual void Make_Paratypeblock2d_ParaProc(CViecFC *); //Para_Type_Block2d() create
	virtual void Make_Paratypeblock3d_ParaProc(CViecFC *); //Para_Type_Block3d() create

	virtual BOOL Do(CObject *);
	virtual BOOL DoCreateSolver(const char*);

};


#endif //__JD_PRCPara_H__
