
#include "stdafx.h"

#include "resource.h"
#include "DivNoDlg.h"

#include "parapde.h"

//#include "..\pad\Pde_msg.h"
#include "parapde_ADV.h"
#include "paraJD_PRG.h"

#undef AFX_EXT_CLASS
#define AFX_EXT_CLASS AFX_CLASS_IMPORT
#include "..\pad\msg_adv.h"
#include "..\pad\msg_prg.h"
#include "../pad/pde_prg.h"
#undef AFX_EXT_CLASS
#define AFX_EXT_CLASS AFX_CLASS_EXPORT


IMPLEMENT_ELEM(CPDEPrbPara, CPDEProblem, 571)
IMPLEMENT_ELEM(CPDEInfoPara, CPDEInfo, 572)

// 98.10.26
//IMPLEMENT_ELEM(CPDEDepInfoPara,CPDEDepInfo,  503)

IMPLEMENT_ELEM(CDomainDivPara, CPDEBase, 574)
// fujita June 1998
IMPLEMENT_ELEM(CMSCParaInt, CMSCInteger, 575)
IMPLEMENT_ELEM(CDomMeshInfo, CPElem, 576)
// 98.11.11
IMPLEMENT_ELEM(CDomCommInfo, CPElem, 577)
//

BOOL CPDEPrbPara::OnCreated(EnumOnCreated bSkp)
{
	POSITION pos;
	CViecFC *pelm;
	pos = GetHeadPosition();
	while(pos) {
		pelm = GetNext(pos);
		if(pelm->IsKindOf(RUNTIME_CLASS(CPDEInfoPara))) {
			m_pdeInfo = (CPDEInfoPara *) pelm;
			break;
		}
	}
	if(m_pdeInfo && m_pdeInfo->IsKindOf(RUNTIME_CLASS(CIElem)))
		m_pdeInfo = (CPDEInfoPara *) ((CIElem *)m_pdeInfo)->GetInstBody();
	return CPDEBase::OnCreated(bSkp);//CPDEBaseɂOnCreate()ȂBȂ̂ɂȂHH
}

int CPDEPrbPara::OnCommand(UINT id)
{
	switch(id) {
//Kawa		April 1998
case CMD_PDE_RUN_SPREAD:   // For program design
		{
			CPDERunSpread *pRun;
			POSITION pos, pos2;
			CPDEDepInfo *pDep;
			CPDESolvSet *pSet;
			CString head;
			CViecFC *pelm;

			pRun = new CPDERunSpreadPara;
			SetMode(modeOpen);// mpdeInfo:  
			pos = m_pdeInfo->GetHeadPosition();	 // get head position directly connected child
			// pos: head pointer of list, each node has a pointer & link pointer 
			// link pointer points the real objetc of the child.
			while(pos) {
				pDep = (CPDEDepInfo *) m_pdeInfo->GetNext(pos);
				if(pDep->IsKindOf(RUNTIME_CLASS(CIElem)))	
					pDep = (CPDEDepInfo *) ((CIElem*)pDep)->GetBody();
 				           //if it is an object splitted
                           // from its body.
				           // "I" of C"I"Elem means   its is splitted from its body
				           // GetBody:  search the body
				if(!pDep->IsKindOf(RUNTIME_CLASS(CPDEDepInfo)))
					continue;	  // check if it is CPDEDepInfo
				pos2 = pDep->GetHeadPosition();
				while(pos2) {
					pSet = (CPDESolvSet *) pDep->GetNext(pos2);
					if(pSet->IsKindOf(RUNTIME_CLASS(CIElem)))	  //check if it is splitted
						pSet = (CPDESolvSet *) ((CIElem*) pSet)->GetBody();
					if(!pSet->IsKindOf(RUNTIME_CLASS(CPDESolvSet)))
						continue;				   // find Solverset
					pelm = (CViecFC *) pSet->Copy(); // copy the solverset object except its name
					pelm->SetName(pSet->GetName(), m_nDot, ANSI_CHARSET); //set the name to its original name
					pRun->CreateNewTemplate(pelm);  // doing other jobs.
					  // creating 3 containers, realizing the Compute-Store Model
					  //  (ObjC: Inut)-> (ProcD: ProcessDescripter)-> (ObjC: output)
					  // After &run command, you see 1 process containing 3 subproceses
					  //  The 3 boxes for 3 subprocesses are realized.  The contents are NULL. 
				}
			}
			pRun->SetName(m_pdeInfo->GetName()+CString(".Run"), m_nDot, m_nCharSet);
			AddTail(pRun);	   //Add .Run to its name (see running GUI). (ObjC)

			// CHM 1998.04.23 CPDEObjPrg *pPrg = new CPDEObjPrg;	   // for program container (ProcD) 
			CPDEObjPrgPara *pPrg = new CPDEObjPrgPara;	   // for program container (ProcD) 
			AddTail(pPrg);
			pPrg->SetName(m_pdeInfo->GetName()+CString(".Prog"), m_nDot, m_nCharSet);

			pRun->AddInputPoint(m_pdeInfo);	  // add input with arrow; from m_pdeInfo
			pRun->AddOutputPoint(pPrg);		  // add output with arrow; to pPrg

			pPrg->OnCreated(); 
			pRun->OnCreated();//Kawa
			// Above two line codes are emptiness.

			//OnCreated();//Kawa
			                // at this point PDEBprb has 3 children 
			                //maybe better to do pPrg->OnCreated(); pRun->OnCreated();
			CalcExt(dirDown);	 //PDEPrb->CalcExt;  dirDown: to downward
			pRun->SendMsg(MSG_RECALC_ALL_VIEW, NULL); // re-calcExt & InvalidateRect for safe.
			CalcExt();		// again for safe.
		}
		return TRUE;
//Kawa
	case CMD_SET_1D_INFO:
		{
			while(GetCount())
				delete m_child.RemoveTail();
			CPDEInfo *pPdeInfo = new CPDEInfoPara;

			CPDEMeshInfo *pMshInfo = new CPDEMeshInfo;
			CPDETimeVar *pTmV = new CPDETimeVar;
			pPdeInfo->AddTail(pMshInfo);
			pPdeInfo->AddTail(pTmV);

			pTmV->SetName("Time Var");
			pTmV->CreateTimeVar("t", "dt", "n", "NMAX", 1000);
			pTmV->SetMode(modeClose);

			pMshInfo->SetName("Mesh Info.");
			pMshInfo->CreateMeshInfo1D();
			pMshInfo->SetMode(modeClose);

			AddTail(pPdeInfo);
			OnCreated();	// Initialize
			CalcExt(dirDown);	// size calculation
			CalcExt();
//			pPdeInfo->ToDblBody();
		}
		return TRUE;
	case CMD_SET_2D_INFO:
		{
			while(GetCount())
				delete m_child.RemoveTail();
			CPDEInfo *pPdeInfo = new CPDEInfoPara;
			CPDEMeshInfo *pMshInfo = new CPDEMeshInfo;
			CPDETimeVar *pTmV = new CPDETimeVar;
			pPdeInfo->AddTail(pMshInfo);
			pPdeInfo->AddTail(pTmV);

			pTmV->SetName("Time Var");
			pTmV->CreateTimeVar("t", "dt", "n", "NMAX", 1000);
			pTmV->SetMode(modeClose);

			pMshInfo->SetName("Mesh Info.");
			pMshInfo->CreateMeshInfo2();
			pMshInfo->SetMode(modeClose);

			AddTail(pPdeInfo);
			OnCreated();
			CalcExt(dirDown);
			CalcExt();
//			pPdeInfo->ToDblBody();
		}
		return TRUE;
	case CMD_SET_3D_INFO:
		{
			while(GetCount())
				delete m_child.RemoveTail();
			CPDEInfo *pPdeInfo = new CPDEInfoPara;
			CPDEMeshInfo *pMshInfo = new CPDEMeshInfo;
			CPDETimeVar *pTmV = new CPDETimeVar;
			pPdeInfo->AddTail(pMshInfo);
			pPdeInfo->AddTail(pTmV);

			pTmV->SetName("Time Var");
			pTmV->CreateTimeVar("t", "dt", "n", "NMAX", 1000);
			pTmV->SetMode(modeClose);

			pMshInfo->SetName("Mesh Info.");
			pMshInfo->CreateMeshInfo3D();
			pMshInfo->SetMode(modeClose);

			AddTail(pPdeInfo);
			OnCreated();
			CalcExt(dirDown);
			CalcExt();
//			pPdeInfo->ToDblBody();
		}
		return TRUE;
	default:
		return CPDEProblem::OnCommand(id);
	}
}

//////////////////////////////////////////
IMPLEMENT_DYNCREATE(CParaDoc, CGMainDoc)

BOOL CParaDoc::OnNewDocument()
{
	int n = CViecFC::s_nDot;
	CViecFC::s_nDot = 20;
	if(!CGMainDoc::OnNewDocument())
		return FALSE;
	CPDEPrbPara *elem = new CPDEPrbPara;
	elem->SetDragAllow(FALSE);
	m_pElemView->AddTail(elem);
	m_pElemView->SetFocus(TRUE);
	m_pElemView->SetFocusChild(elem);
	elem->SetFocus(TRUE);
	return TRUE;
}


//////////////////////////////////////////
///////// CPDEInfoPara class /////////////


int CPDEInfoPara::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
	AppendDefaultMenu(psub);

	
	pMenu->AppendMenu(MF_STRING, CMD_DOM_DIV_PARA, "Domain Division for Parallel");
	pMenu->AppendMenu(MF_SEPARATOR);

	pMenu->AppendMenu(MF_STRING, CMD_NEW_DEP_VAR, "new dependent &variable");
	pMenu->AppendMenu(MF_STRING, CMD_NEW_PARAM_FOLD, "new &parameter folder");
	pMenu->AppendMenu(MF_STRING, CMD_NEW_PROCEDURE, "new &procedure");
	pMenu->AppendMenu(MF_STRING, CMD_NEW_FILE_FOLD, "new &file folder");

	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CPDEInfoPara::OnCommand(UINT id)
{
	switch(id) {
	case CMD_DOM_DIV_PARA:
		{
			CDomainDivPara *pDom = new CDomainDivPara;
			AddTail(pDom);
			int ret; // The ret store the value from pDom->OnCreated();
			//if(!pDom->m_bCreated){
				ret = pDom->OnCreated();
				// if ret equal FALSE,CPDEDepInfo class still make or Pushing 'CANCEL' button
				// on Dialog.
			//}
			if (ret == FALSE){
				RemoveTail(); //delete pDom;
				return TRUE;
			}
			CalcExt(dirDown);
			CalcExt(dirUp);
			InvalidateRect(NULL);
		};
		//break;
		return TRUE;
	default:
		return CPDEInfo::OnCommand(id);
	
	}
}


////////////////98 10 26 /////////////////////////////////
/////// CPDEDepInfoPara  begin ///////////////////////////
/////// Dependent variale Information Parallel class /////
//////////////////////////////////////////////////////////
/* modified by A.Fujita.Because Previous Veresion not had  portability
int CPDEDepInfoPara::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
	AppendDefaultMenu(psub);

	pMenu->AppendMenu(MF_STRING, CMD_NEW_PDE_SET, "a new PDE &set");

	///// 98.10.26               //////////
	///// New Menu(for Parallel) //////////
	pMenu->AppendMenu(MF_STRING, CMD_DOM_DIV_PARA, "domain division for //");
	pMenu->AppendMenu(MF_SEPARATOR);
	///////////////////////////////////////

	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CPDEDepInfoPara::OnCommand(UINT id)
{
	switch(id) {
	case CMD_NEW_PDE_SET:
		{
//			CPDESet *pSet = new CPDESet;
			CPDESolvSet *pSet = new CPDESolvSet;
			AddTail(pSet);
			OnCreated();
			CalcExt(dirDown);
			CalcExt(dirUp);
		}
		return TRUE;
	}
	return CPDEBase::OnCommand(id);
}
/////////////// CPDEDepInfoPara end ///////////////////////////////////////////////
*/

//////////////////////////////////////////////////////////
////////////////98 10 28 /////////////////////////////////
/////// CDomainDivPara  begin  ///////////////////////////
/////// Parallel dependent domain division display class /////
//////////////////////////////////////////////////////////
////// CDomainDivPara :: CalcExt ////////////////////////
////// This function calculation Extention of this class.///
//////////////////////////////////////////////////////////

int CDomainDivPara::CalcExt(dirMode dir)
{
	// ****** 98.10.28 ****************************
	//CPDEDepInfoPara* pDep_Inf = (CPDEDepInfoPara*) this->GetParent();
	//CPDEInfoPara* pInf_para = (CPDEInfoPara*) pDep_Inf->GetParent();

	if(dir==dirDown) {
		//POSITION pos = pDep_Inf->GetHeadPosition();
		POSITION pos = GetHeadPosition();
		while(pos) {
			GetNext(pos)->CalcExt(dirDown);
		}
	}
	//*********************************************
	// give Original Position to Child Class //
	GetChild(0)->SetOrg(CPoint(110,3)); // Dependent variable
	GetChild(1)->SetOrg(CPoint(20,20)); // xdiv
	GetChild(2)->SetOrg(CPoint(50,240+70)); //current domain no

	for(int i=3; i<8; i+=2) {
		GetChild(i)->SetOrg(CPoint(5, 315+(i-2)*10));
		GetChild(i+1)->SetOrg(CPoint(130, 315+(i-2)*10));
	}
	GetChild(7+2)->SetOrg(CPoint(20, 315+ 7 * 10)); //CDomMeshInfo
	GetChild(7+3)->SetOrg(CPoint(20, 315+ 7 * 10 + 60 + 10)); //CDomCommInfo

	int x = 200 + 24/*left text*/ + 24 /*right text*/ 
		+ 6*2 /*mergin*/;
	int y = 200 + 70 + 6*2/*mergin*/ + 300;
	CRect rct(0, 0, x, y);
	SetExtent(rct);
	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	return 1;
}

//////////////////////////////////////////////////////////
////// CDomainDivPara::Ondraw ////////////////////////////
//////////////////////////////////////////////////////////
void CDomainDivPara::OnDraw(CDC *pdc, const CPoint& p)
{
	
	CPoint p0 = p;
	p0.Offset(GetOrg());
	pOrg = p0;


	/****************************************************************************
	CPoint p0 = p;
	CRect depinfo_rect;
	
	depinfo_rect = GetParent()->GetExtent();
	p0.Offset(depinfo_rect.right-depinfo_rect.left,-(depinfo_rect.bottom-depinfo_rect.top));
	pOrg = p0;
	*******************************************************************************/

	DrawFold3D(pdc, p, m_bFocus? 0:1);//CDomainDivPara visualize 3-Dimention.
	pdc->SelectStockObject(BLACK_PEN);
	pdc->SelectStockObject(NULL_BRUSH);
	
	CRect rct = GetExtent(); //Get m_extent.This rct value caluculation on CalcExt() function.
	rct.OffsetRect(p0);  
	pdc->Rectangle(&rct); // Extention Ondraw!

	//*******************************************************************************
	//**********98.11.04 ************************************************************
	CPoint pLT = p0; // pLT = Oringin Point in CDomainDivPara Class.
	pLT.Offset(30, 70); // ̈̕`̌_ʒu
						// RectPoint(Left,Top) = (pLT.Left+30,pLT.Top+30)
	CPoint pRB = pLT;
	pRB.Offset(200, 200); // RectPoint(Right,Bottom) = (pLT.Left+200,pLT.Top+200).

	pdc->SelectStockObject(WHITE_BRUSH);
	pdc->Rectangle(pLT.x, pLT.y, pRB.x, pRB.y);  // Draw division domain rect.
	//*******************************************************************************

	pdc->SelectStockObject(BLACK_PEN);
	pdc->SelectStockObject(NULL_BRUSH);
	///   4 corners calculation
	int lefttop, righttop, rightbottom, leftbottom;
	leftbottom = div_no_x * div_no_y * (zlevel-1) + 1;
	rightbottom = leftbottom + div_no_x - 1;
	righttop = div_no_x * div_no_y * zlevel;
	lefttop = righttop - div_no_x + 1;
	
	SetFont(pdc, 12/*height*/, GetFont(), m_nCharSet, m_nItalic, 6/*width*/);
	char buf[100];
	sprintf(buf, "%5d", leftbottom);
	pdc->TextOut(p0.x+6, p0.y+70+200-12, buf);
	sprintf(buf, "%5d", rightbottom);
	pdc->TextOut(p0.x+6+24+200, p0.y+70+200-12, buf);

	sprintf(buf, "%5d", lefttop);
	pdc->TextOut(p0.x+6, p0.y+70, buf);
	sprintf(buf, "%5d", righttop);
	pdc->TextOut(p0.x+6+24+200, p0.y+70, buf);

	pdc->TextOut(p0.x+6, p0.y+70+100-6, "   Y");
	pdc->TextOut(p0.x+6+24+100-3, p0.y+6+70+200, "X");
	//sprintf(buf, "Z    %d ~ %d   [ present Z layer: %d]", 1, div_no_z, zlevel);

	SetFont(pdc, 14/*height*/, GetFont()/*Font name*/, m_nCharSet/*Char Type*/, m_nItalic/*Italic or not*/,8/*width*/);
	sprintf(buf, "[ Z = %d]",zlevel);
	pdc->TextOut(p0.x+30+70, p0.y+6+70+200+12, buf);


	// print division line 
	int i, dx, xx, y1, y2;
	COLORREF div_line_clr;
	CPen newpen;
	div_line_clr = RGB(150,150,150);
	newpen.CreatePen(PS_SOLID,1,div_line_clr); 
	pdc->SelectObject(&newpen);
	dx = 200 / div_no_x;
	y1 = 70;
	y2 = 70 + 200;
	for(i=0; i<div_no_x; i++) {
		xx = 30 + i * dx;
		pdc->MoveTo(p0.x + xx, p0.y + y1);
		pdc->LineTo(p0.x + xx, p0.y + y2);
	}
	int j, dy, yy, x1, x2;
	dy = 200 / div_no_y;
	x1 = 30;
	x2 = 30 + 200;
	for(j=0; j<div_no_y; j++) {
		yy = 70 + 200 - j * dy;
		pdc->MoveTo(p0.x + x1, p0.y + yy);
		pdc->LineTo(p0.x + x2, p0.y + yy);
	}
	
	OnDrawChild(pdc, p);

	// paint current domain
	CPoint pDLT = p0;
	pDLT.Offset(30 + (cur_x - 1)* dx,70 + 200 - cur_y * dy);
	CPoint pDRB = pDLT;
	pDRB.Offset(dx,dy);
	
	pdc->SelectStockObject(GRAY_BRUSH);
	pdc->Rectangle(pDLT.x, pDLT.y, pDRB.x, pDRB.y);

}

//////////////////////////////////////////////////////////
////// CDomainDivPara::OnCreated  ////////////////////////
//////////////////////////////////////////////////////////

BOOL CDomainDivPara::OnCreated(EnumOnCreated bSkp)
{
	if(m_bCreated) return TRUE; 
	CJDFindClass findClass; // This Object(Class Cobject) is to find RUNTIME_CLASS.
	findClass.m_pTarget = RUNTIME_CLASS(CPDESpaceVars);  //set findClass.m_pTarget = CPDESpaceVars name.
	findClass.m_pResult = NULL; // m_pResult is CView class.
	GetParent()->SendMsg(MSG_DO_JOB, &findClass); //Check findclass(Object) job.
	/*Getparent = CPDEInfoPara*/ 

	if(findClass.m_pResult==NULL) return 0;
	CPDESpaceVars *pVars = (CPDESpaceVars*) findClass.m_pResult;
	RemoveAll(); //Remove all children..
	SetMode(modeOpen);
	int i, size[3];
	POSITION pos = pVars->GetHeadPosition(); //Take position on child class.
	for(i=0; pos && i<3; i++) {
		CPDESpaceVar *pVar;
		pVar = (CPDESpaceVar*) pVars->GetNext(pos);
		if(pVar->GetCount()!=4) return 0;
		CMSMeshSize *pMS;
		pMS = (CMSMeshSize*) pVar->GetChild(3);
		size[i] = pMS->m_value;  //store x,y,z mesh number
	}
	dim_no = i; // the number of dimention
	zlevel = 1; // default zlevel
    
	//*******************************************************************
	//******* 98.11.20 ************************************************
	//CJDFindClass findClass; // This Object(Class Cobject) is to find RUNTIME_CLASS.
	findClass.m_pTarget = RUNTIME_CLASS(CPDEDepInfo);  //set findClass.m_pTarget = CPDEDepInfo name.
	findClass.m_pResult = NULL; // m_pResult is CView class.
	GetParent()->SendMsg(MSG_DO_JOB, &findClass); //Check findclass(Object) job.
	if(findClass.m_pResult==NULL) return FALSE;
	CPDEDepInfo* pPDEInfo;
	pPDEInfo = (CPDEDepInfo*) findClass.m_pResult;

	CMathSymb* pMsyb = new CMathSymb;
	//pMsyb = (CMathSymb*) pPDEInfo->GetChild(0);
	//The first child on CPDEDepInfo is MathSymbol class.
	
	pMsyb->SetName(pPDEInfo->GetChild(0)->GetName()); 
					// CDomainDivPara Title name Set.
					//Use of above describe,This class's pointer is taken.

	AddTail(pMsyb); // child(0)  parent:CDomainDivPara
	//*******************************************************************

	////////////////////////////////////////////////////////////////
	//p̃p[^BOX̖OƊe萔o^B//
	//e̕ƁAő啪`B//
	//Œ`萔PADȂǂŎgpB//
	CPDEParaDefs *pParaDefs = new CPDEParaDefs; //p̃p[^BOXpӂB
	AddTail(pParaDefs); //CComainDivPara -- child(1);
	pParaDefs->SetName("Parameter for Parallel");
	pParaDefs->SetMode(modeOpen);

	//CMSCInteger* pMax_Cpu = new CMSCInteger;  //ő吔 Max_CPU
	CMSCInteger *pMax_Cpu = new CMSCInteger;  //ő吔 Max_CPU
	pMax_Cpu->SetName("Max_CPU");

	pMax_Cpu->m_value = 10; //ő啪̃ftHglAiKł10ƂB
	m_Max_CPU = pMax_Cpu->m_value; //oϐɕۑĂB 

	pParaDefs->AddTail(pMax_Cpu); // child(0)  parent:CPDEParaDefs
	pParaDefs->AddTail(new CPDELineTerm); // s chile(1)

	CMSCInteger* pXDiv = new CMSCInteger;  //Xdiv number object
	pXDiv->SetName("X_div");
	pParaDefs->AddTail(pXDiv); // child(2)  parent:CPDEParaDefs
	m_xdiv = pXDiv->m_value; //oϐɕۑĂB 
	
	CMSCInteger* pYDiv = new CMSCInteger;  //Ydiv number object
	pYDiv->SetName("Y_div");
	pParaDefs->AddTail(pYDiv); // child(3)  parent:CPDEParaDefs
	m_ydiv = pYDiv->m_value; //oϐɕۑĂB 

	CMSCInteger* pZDiv = new CMSCInteger;  //Zdiv number object
	pZDiv->SetName("Z_div");
	pParaDefs->AddTail(pZDiv); // child(4)  parent:CPDEParaDefs
	m_zdiv = pZDiv->m_value; //oϐɕۑĂB 
	////////////////////////////////////////////////////////////////
	
	/*
	CMSCInteger* pXDiv = new CMSCInteger;  //Xdiv number object
	pXDiv->SetName("X div ");
	AddTail(pXDiv); // child(1)  parent:CDomainDivPara
	pYDiv = new CMSCInteger;  //Ydiv number object
	pYDiv->SetName("Y div ");
	AddTail(pYDiv); // child(2)  parent:CDomainDivPara
	pZDiv = new CMSCInteger;  //Zdiv number object
	pZDiv->SetName("Z div ");
	AddTail(pZDiv); // child(3)  parent:CDomainDivPara
	*/

	// initialize current domain number
	CMSCInteger *pCurDom = new CMSCInteger;
	pCurDom->SetName("current domain no:");
	pCurDom->m_value = 1;
	AddTail(pCurDom); // child(2)  parent:CDomainDivPara

	// facing domain
	CMSCParaInt *pFace;

	pFace = new CMSCParaInt;
	pFace->SetName("left Dom No:");
	AddTail(pFace);	// child(3)  parent:CDomainDivPara
	pFace = new CMSCParaInt;
	pFace->SetName("right Dom No:");
	AddTail(pFace);	// child(4)  parent:CDomainDivPara
	pFace = new CMSCParaInt;
	pFace->SetName("top Dom No:");
	AddTail(pFace);	// child(5)  parent:CDomainDivPara
	pFace = new CMSCParaInt;
	pFace->SetName("bottom Dom No:");
	AddTail(pFace);	// child(6)  parent:CDomainDivPara
	pFace = new CMSCParaInt;
	pFace->SetName("front Dom No:");
	AddTail(pFace);	// child(7)  parent:CDomainDivPara
	pFace = new CMSCParaInt;
	pFace->SetName("rear Dom No:");
	AddTail(pFace);	// child(8)  parent:CDomainDivPara

	//*********************************************************
	//******** 98.11.05 ***************************************
	// dialog box(Input x,y,z division number)
	int ret,wd_x=2, wd_y=2, wd_z=2; // x,y,z domain division number.
								//initial value set. Each var = 2.
	CDivNoInputDlg dlg;		// CDivNoInputDlg class pointer Get!.
	dlg.m_dim_no = dim_no;  // set Dialog member function;
	dlg.m_div_no_x = wd_x;
	dlg.m_div_no_y = wd_y;
	dlg.m_div_no_z = wd_z;

	ret = dlg.DoModal();
	if(ret == IDOK) {  //DoModal() == Dialog calling function.
								//if OK Button push,return IDOK.if Cancel Button push,return IDCANCEL.
		//Store Input Data(Dialog Data).
		wd_x = dlg.m_div_no_x; // x division number
		wd_y = dlg.m_div_no_y; // y division number
		wd_z = dlg.m_div_no_z; // z division number
	}
	else if(ret == IDCANCEL){ //Push Cancel Button
			//dlg.EndDialog(IDCANCEL);
			RemoveAll();
			return FALSE;
	}
	//*********************************************************

	// allocate Memory size
	Msize_x = new int[wd_x]; 
	Msize_y = new int[wd_y];
	Msize_z = new int[wd_z];
	
	// mesh number no amarisu no keisan
	Asize_x = (size[0] - 1) % wd_x;  
	Asize_y = (size[1] - 1) % wd_y;
	Asize_z = (size[2] - 1) % wd_z;

	int cntx = Asize_x;
	int cnty = Asize_y;
	int cntz = Asize_z; 

	for (i = 0; i < wd_x; i++)
	{
		if (cntx >0){
		Msize_x[i] = (size[0] - 1) / wd_x + 1; //the number of mesh(x) at each division domain 
		cntx--;
		}
		else{
			Msize_x[i] = (size[0] - 1) / wd_x;
		}
	}

	for (i = 0; i < wd_y; i++)
	{
		if (cnty >0){
		Msize_y[i] = (size[0] - 1) / wd_y + 1; //the number of mesh(y) at each division domain 
		cnty--;
		}
		else{
			Msize_y[i] = (size[0] - 1) / wd_y;
		}
	}

	for (i = 0; i < wd_z; i++)
	{
		if (cntz >0){
		Msize_z[i] = (size[0] - 1) / wd_z + 1; //the number of mesh(z) at each division domain 
		cntz--;
		}
		else{
			Msize_z[i] = (size[0] - 1) / wd_z;
		}
	}
	
	div_no_x = wd_x;
	if (dim_no == 1){
		wd_y = 1;
		wd_z = 1;
	}else if(dim_no == 2){
		wd_z = 1;
	}
	div_no_y = wd_y;
	div_no_z = wd_z;
	cur_dom_no = 1;
	
	FacingCalc(); // Calcultion Division Domain Info
	
	//******************************************************
	//***********: 98.11.05 ********************************
	// set division number
	if (dim_no == 2) wd_z = -1;
	else if (dim_no == 1) {
			wd_z = -1;
			wd_y = -1;
	}
	///////////////////////////////////////////////////////////////
	///p(CPDEParaDef)̃p[^BOX֒萔ݒ肷B
	///e̕ݒ肷B///

	CMSCInteger* pDiv_num = new CMSCInteger; 
	pDiv_num = (CMSCInteger *)pParaDefs->GetChild(2);
	pDiv_num->m_value = wd_x;
	m_xdiv = wd_x; //oϐɕۑĂB

	pDiv_num = new CMSCInteger; 
	pDiv_num = (CMSCInteger *)pParaDefs->GetChild(3);
	pDiv_num->m_value = wd_y;
	m_ydiv = wd_y; //oϐɕۑĂB

	pDiv_num = new CMSCInteger; 
	pDiv_num = (CMSCInteger *)pParaDefs->GetChild(4);
	pDiv_num->m_value = wd_z;
	m_zdiv = wd_z; //oϐɕۑĂB
	//////////////////////////////////////////////

	/*
	CMSCInteger* pDiv; 
	pDiv = (CMSCInteger*) GetChild(1);
	pDiv->m_value = wd_x;

	pDiv = (CMSCInteger*) GetChild(2);
	pDiv->m_value = wd_y;

	pDiv = (CMSCInteger*) GetChild(3);
	pDiv->m_value = wd_z;
	*/
	//******************************************************
	// adding the description of domain Mesh Information.
	CDomMeshInfo *pDMeshI = new CDomMeshInfo;
	AddTail(pDMeshI); // child(9)  parent:CDomainDivPara
	pDMeshI->OnCreated();
	//CalcExt(dirDown);
	//CalcExt(dirUp);

	// adding the description of domain Communication Information.
	CDomCommInfo *pDCommI = new CDomCommInfo;
	AddTail(pDCommI); // child(10)  parent:CDomainDivPara
	pDCommI->OnCreated();
	CalcExt(dirDown);
	CalcExt(dirUp);

	m_bCreated = TRUE; // Flag for access.
	return TRUE;
}

//***********************************************
//******** CDomainDivPara::FacingCalc()*********
//********* begin ******************************
void CDomainDivPara::FacingCalc()
{
	// caluculate current domain information
	cur_z = (cur_dom_no-1) / (div_no_x*div_no_y) + 1;
	cur_y = (cur_dom_no-1-(div_no_x*div_no_y)*(cur_z-1))/div_no_x + 1;
	cur_x = (cur_dom_no-1-(div_no_x*div_no_y)*(cur_z-1))%div_no_x + 1;
	int center = cur_x + (cur_y-1) * div_no_x + (cur_z-1) * div_no_x * div_no_y;

	int left   = cur_x - 1 + (cur_y-1) * div_no_x + (cur_z-1) * div_no_x * div_no_y;
	int right  = cur_x + 1 + (cur_y-1) * div_no_x + (cur_z-1) * div_no_x * div_no_y;
	int bottom = cur_x  + (cur_y-1-1) * div_no_x + (cur_z-1) * div_no_x * div_no_y;
	int top    = cur_x  + (cur_y-1+1) * div_no_x + (cur_z-1) * div_no_x * div_no_y;
	int rear   = cur_x + (cur_y-1) * div_no_x + (cur_z-1-1) * div_no_x * div_no_y;
	int front  = cur_x + (cur_y-1) * div_no_x + (cur_z-1+1) * div_no_x * div_no_y;
	
	// check boundary condition
	if (cur_x == 1)        left = -1;
	if (cur_x == div_no_x) right = -1;
	if (cur_y == 1)        bottom = -1;
	if (cur_y == div_no_y) top = -1;
	if (cur_z == 1)        rear = -1;
	if (cur_z == div_no_z) front = -1;

	CMSCParaInt *pFace;
	pFace = (CMSCParaInt*) GetChild(3);
	pFace->m_value = left;
	pFace = (CMSCParaInt*) GetChild(4);
	pFace->m_value = right;
	pFace = (CMSCParaInt*) GetChild(5);
	pFace->m_value = top;
	pFace = (CMSCParaInt*) GetChild(6);
	pFace->m_value = bottom;
	pFace = (CMSCParaInt*) GetChild(7);
	pFace->m_value = front;
	pFace = (CMSCParaInt*) GetChild(8);
	pFace->m_value = rear;
	
	// Caluculation Mesh Number of All Division Domain.  fujita 4/21 //
	int All_dom_no = div_no_x * div_no_y * div_no_z;
	Xs = new int[All_dom_no];
	Xe = new int[All_dom_no];
	XsBound = new int[All_dom_no];
	XeBound = new int[All_dom_no];
	Ys = new int[All_dom_no];
	Ye = new int[All_dom_no];
	YsBound = new int[All_dom_no];
	YeBound = new int[All_dom_no];
	Zs = new int[All_dom_no];
	Ze = new int[All_dom_no];
	ZsBound = new int[All_dom_no];
	ZeBound = new int[All_dom_no]; 

	int xcnt = 0,ycnt = 0,zcnt = 0;
	for (int i = 0; i < All_dom_no; i++){
		int Unit_z = (i) / (div_no_x*div_no_y) + 1; // equal cur_z
		int Unit_y = (i-(div_no_x*div_no_y)*(Unit_z-1))/div_no_x + 1; // equal cur_y
		int Unit_x = (i-(div_no_x*div_no_y)*(Unit_z-1))%div_no_x + 1; // equal cur_x

		int L = Unit_x - 1 + (Unit_y-1) * div_no_x + (Unit_z-1) * div_no_x * div_no_y; //left
		int R = Unit_x + 1 + (Unit_y-1) * div_no_x + (Unit_z-1) * div_no_x * div_no_y; //right
		int B = Unit_x + (Unit_y-1-1) * div_no_x + (Unit_z-1) * div_no_x * div_no_y;   //bottom
		int T = Unit_x + (Unit_y-1+1) * div_no_x + (Unit_z-1) * div_no_x * div_no_y;   //top
		int RE = Unit_x + (Unit_y-1) * div_no_x + (Unit_z-1-1) * div_no_x * div_no_y;  //rear
		int F = Unit_x + (Unit_y-1) * div_no_x + (Unit_z-1+1) * div_no_x * div_no_y;   //front
	
		//check boundary condition of division domain 
		if (Unit_x == 1)        L = -1;
		if (Unit_x == div_no_x) R = -1;
		if (Unit_y == 1)        B = -1;
		if (Unit_y == div_no_y) T = -1;
		if (Unit_z == 1)        RE = -1;
		if (Unit_z == div_no_z) F = -1;

		Xs[i] = 1 + (Unit_x - 1) * Msize_x[Unit_x - 1];  //Starat Mesh Point(X axis) of Domain Division 
		Xe[i] = 1 + Unit_x * Msize_x[Unit_x - 1]; //End Mesh Point(X axis) of Domain Division
		XsBound[i] = Xs[i] - 1; //Boundary Mesh Point(Xstart side)
		XeBound[i] = Xe[i] + 1; //Boundary Mesh Point(Xend side)
		xcnt++;
		if (xcnt >Asize_x){
			Xs[i] = Xs[i] + Asize_x;
			XsBound[i] = Xs[i] - 1;
			Xe[i] = Xe[i] + Asize_x;
			XeBound[i] = Xe[i] + 1;
		}
		if (L == -1){
			XsBound[i] = -1;
			ycnt++;
		}
		if (R == -1){
			XeBound[i] = -1;
			xcnt = 0;
		}

		Ys[i] = 1 + (Unit_y - 1) * Msize_y[Unit_y - 1]; //Starat Mesh Point(Y axis) of Domain Division
		Ye[i] = 1 + Unit_y * Msize_y[Unit_y - 1]; //End Mesh Point(Y axis) of Domain Division
		YsBound[i] = Ys[i] - 1; //Boundary Mesh Point(Ystart side)
		YeBound[i] = 1 + Ye[i]; //Boundary Mesh Point(Yend side)
		if (ycnt >Asize_y){
			Ys[i] = Ys[i] + Asize_y;
			YsBound[i] = Ys[i] - 1;
			Ye[i] = Ye[i] + Asize_y;
			YeBound[i] = 1 + Ye[i];
		}
		if (B == -1){
			YsBound[i] = -1;
		}
		if (T == -1){
			YeBound[i] = -1;
		}

		Zs[i] = 1 + (Unit_z - 1) * Msize_z[Unit_z - 1]; //Starat Mesh Point(Z axis) of Domain Division
		Ze[i] = 1 + Unit_z * Msize_z[Unit_z - 1]; //End Mesh Point(Z axis) of Domain Division
		ZsBound[i] = Zs[i] - 1;//Boundary Mesh Point(Zstart side)
		ZeBound[i] = 1 + Ze[i];//Boundary Mesh Point(Zend side)
		if ((T == -1) && (R == -1)){
			ycnt = 0;
		}
		if ((B == -1) && (L == -1)){
			zcnt++;
		}
		if (zcnt > Asize_z){
			Zs[i] = Zs[i] + Asize_z;
			ZsBound[i] = Zs[i] - 1;
			Ze[i] = Ze[i] + Asize_z;
			ZeBound[i] = 1 + Ze[i];
		}
		if (RE == -1){
			ZsBound[i] = -1;
		}
		if (F == -1){
			ZeBound[i] = -1;
		}
	}
}
//****************Facing Calc end ****************************************
//************************************************************************

//***********************************************************
//******* CDomainDivPara::OnAccess *************************
//********** begin *******************************************
int CDomainDivPara::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
	AppendDefaultMenu(psub);
	if (dim_no >2){
		pMenu->AppendMenu(MF_STRING, CMD_DOM_ZLEVEL_INC, "Z level &increment");
		pMenu->AppendMenu(MF_STRING, CMD_DOM_ZLEVEL_DEC, "Z level &decrement");
	}
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
    return 1;
}
//********OnAccess end***************************************
//***********************************************************

//***********************************************************
//******* CDomainDivPara::OnCommand *************************
//********** begin *******************************************
int CDomainDivPara::OnCommand(UINT id)
{
	switch(id) {
	case CMD_DOM_ZLEVEL_INC: {
			CMSCInteger *pCurDom = (CMSCInteger *) GetChild(0); 
			cur_z++;
			if(cur_z > div_no_z){
				cur_z = div_no_z;
				return TRUE;
			}
			cur_dom_no = cur_x + (cur_y-1) * div_no_x + (cur_z-1) * div_no_x * div_no_y;
			pCurDom->m_value = cur_dom_no;
			zlevel = cur_z;
			this/*CDomainDivPara*/->FacingCalc();
			InvalidateRect(NULL);
		}
		return TRUE;
	case CMD_DOM_ZLEVEL_DEC: {
			CMSCInteger *pCurDom = (CMSCInteger *) GetChild(0); 
			cur_z--;
			if(cur_z < 1){
				cur_z = 1;
				return TRUE;
			}
			cur_dom_no = cur_x + (cur_y-1) * div_no_x + (cur_z-1) * div_no_x * div_no_y;
			pCurDom->m_value = cur_dom_no;
			zlevel = cur_z;
			this/*CDomainDivPara*/->FacingCalc();
			InvalidateRect(NULL);
		}
		return TRUE;
	default:
		return CPDEBase::OnCommand(id);
	}
	return TRUE;
}
//**************** OnCommand end *****************************************
//************************************************************************

BOOL CDomainDivPara::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_CONST_CHANGED: {
			if(el!=GetChild(2)) //currento domain̕ω
				return TRUE;
			CMSCInteger *pCurDom = (CMSCInteger*) GetChild(2);
			// check curent domain No
			if(pCurDom->m_value > (div_no_x*div_no_y*div_no_z/*the total number of all division domain*/)) {
				 pCurDom->m_value = cur_dom_no;
			}
			if(pCurDom->m_value <= 0){
				pCurDom->m_value = cur_dom_no;
			}
			cur_dom_no = pCurDom->m_value;
			int zv = (cur_dom_no-1) / (div_no_x*div_no_y) + 1;
			zlevel = zv;
			FacingCalc();
			InvalidateRect(NULL);
		}
		return TRUE;
	case MSG_PDE_MESH_CHANGED: {
			CJDFindClass findClass;

			findClass.m_pTarget = RUNTIME_CLASS(CPDESpaceVars);
			findClass.m_pResult = NULL;
			GetParent()->SendMsg(MSG_DO_JOB, &findClass);
			if(findClass.m_pResult==NULL) return 0;
			CPDESpaceVars *pVars = (CPDESpaceVars*) findClass.m_pResult;

			RemoveAll();
			int i, size[3];
			POSITION pos = pVars->GetHeadPosition();
			for(i=0; pos && i<3; i++) {
				CPDESpaceVar *pVar;
				pVar = (CPDESpaceVar*) pVars->GetNext(pos);
				if(pVar->GetCount()!=4) return 0;
					CMSMeshSize *pMS;
					pMS = (CMSMeshSize*) pVar->GetChild(3);
					size[i] = pMS->m_value;
			}
			dim_no = i;
			zlevel = 1;

			// current domain number
			CMSCInteger *pCurDom = new CMSCInteger;
			pCurDom->SetName("current domain no:");
			pCurDom->m_value = 1;
			AddTail(pCurDom);

			// facing domain
			CMSCParaInt *pFace;

			pFace = new CMSCParaInt;
			pFace->SetName("left Dom No:");
			AddTail(pFace);	
			pFace = new CMSCParaInt;
			pFace->SetName("right Dom No:");
			AddTail(pFace);	
			pFace = new CMSCParaInt;
			pFace->SetName("top Dom No:");
			AddTail(pFace);	
			pFace = new CMSCParaInt;
			pFace->SetName("bottom Dom No:");
			AddTail(pFace);	
			pFace = new CMSCParaInt;
			pFace->SetName("front Dom No:");
			AddTail(pFace);	
			pFace = new CMSCParaInt;
			pFace->SetName("rear Dom No:");
			AddTail(pFace);	

			Asize_x = (size[0] - 1) % wd_x;   // amari calcu  
			Asize_y = (size[1] - 1) % wd_y;
			Asize_z = (size[2] - 1) % wd_z;

			int cntx = Asize_x;
			int cnty = Asize_y;
			int cntz = Asize_z; 

			for (i = 0; i < wd_x; i++)
			{
				if (cntx >0){
				Msize_x[i] = (size[0] - 1) / wd_x + 1;
				cntx--;
				}
				else{
					Msize_x[i] = (size[0] - 1) / wd_x;
				}
			}

			for (i = 0; i < wd_y; i++)
			{
				if (cnty >0){
				Msize_y[i] = (size[1] - 1) / wd_y + 1;
				cnty--;
				}
				else{
					Msize_y[i] = (size[1] - 1) / wd_y;
				}
			}

			for (i = 0; i < wd_z; i++)
			{
				if (cntz >0){
				Msize_z[i] = (size[2] - 1) / wd_z + 1;
				cntz--;
				}
				else{
					Msize_z[i] = (size[2] - 1) / wd_z;
				}
			}
			
			div_no_x = wd_x;
			if (dim_no == 1){
				wd_y = 1;
				wd_z = 1;
			}else if(dim_no == 2){
				wd_z = 1;
			}
			div_no_y = wd_y;
			div_no_z = wd_z;
			cur_dom_no = 1;
			
			FacingCalc();

			// adding the description of domain
			CDomMeshInfo *pDMI = new CDomMeshInfo;
			AddTail(pDMI);
			pDMI->OnCreated();
			CalcExt(dirDown);
			CalcExt(dirUp);
		 }
		 return TRUE;

	case MSG_SUBSTITUTE_THE_TWO:
		return TRUE;
	case MSG_RECALC_ALL_VIEW:
		if(!GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)))
			break;
		GetParent()->CalcExt(dirDown);
		GetParent()->InvalidateRect(CPoint(0,0));
		break;
	}
	return CPElem::SendMsg(msg, el);
}
///////////CDomainDviPara end///////////////


//////////////////////////////////////////////////////////////////////////
////////// CMSCParaInt  //////////////////////////////////////////////////
int CMSCParaInt::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags){return 0;}; 
//////////////////////////////////////////////////////////////////////////


//******** 98.11.09 ****************************
//**********************************************
//******* CDomMeshInfo::CalcExt  ***************
//******** begin *******************************

int CDomMeshInfo::CalcExt(dirMode dir)
{
	
	if(dir==dirDown) {
		POSITION pos = GetHeadPosition();
		while(pos) {
			GetNext(pos)->CalcExt(dir);
		}
	}

	int x = 200;
	int y = 60
		;
	CRect rct( 0,  0, x, y);
	SetExtent(rct);
	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	return TRUE;
	/*
	CRect ext = m_extent;
	if(GetMode()!=modeOpen)
		return CPDEBase::CalcExt(dir);
	CalcExtVert(dir);
	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	CalcExtPost(dir, ext);
	return TRUE;
	*/


}
//********** CalcExt end ************************

////////// fujita 4/21 //////////////////////////	
//******** 98.11.09 *****************************
//**********************************************
//******* CDomMeshInfo::OnCreated***************
//******** begin *******************************
BOOL CDomMeshInfo::OnCreated(EnumOnCreated)
{
	SetMode(modeOpen);
	// ***** 98.11.04 *******
	//SetMode(modeClose);
	return 1;	
}
//******** end   *******************************
////////////////////////////////////////////////////

//******** 98.11.09 *****************************
//**********************************************
//******* CDomMeshInfo::OnDraw   ***************
//******** begin *******************************
void CDomMeshInfo::OnDraw(CDC *pdc, const CPoint& p)
{
	
	CPoint p0 = p;
	p0.Offset(GetOrg());
	pOrg = p0;

	DrawFold3D(pdc, p, m_bFocus? 0:1);
	pdc->SelectStockObject(BLACK_PEN);
	pdc->SelectStockObject(NULL_BRUSH);

	CRect rct = GetExtent();
	rct.OffsetRect(p0);
	pdc->Rectangle(&rct);
	

	// CHM ɂ CDomainDivPara ̃o[ϐ
	// QƂ̂
	CDomainDivPara *pDomDiv;
	pDomDiv = (CDomainDivPara*) GetParent();
	if(!pDomDiv->IsKindOf(RUNTIME_CLASS(CDomainDivPara))&& pDomDiv->GetCount()>1 ) {
		return;
	}
	CMSCInteger *pCurDom = (CMSCInteger *) pDomDiv->GetChild(2); //current domain nõ|C^[擾
	if(!pCurDom->IsKindOf(RUNTIME_CLASS(CMSCInteger))) {
		return;
	}
	int i,dim;
	i = pCurDom->m_value;  //Current Domian No
	dim = pDomDiv->dim_no;
	//4/17  fujita Output Division Domain Mesh Information//
	SetFont(pdc, 13, GetFont(), m_nCharSet, FALSE, 7);
	char buf[100];
	sprintf(buf,"Current Domain Mesh Information");
	pdc->TextOut(p0.x-3, p0.y-3, buf);
	sprintf(buf," %d  <= X <=  %d",pDomDiv->Xs[i-1],pDomDiv->Xe[i-1]);
	pdc->TextOut(p0.x+50, p0.y+15*1, buf);

	if (dim > 1)
	{
		sprintf(buf," %d  <= Y <=  %d",pDomDiv->Ys[i-1],pDomDiv->Ye[i-1]);
		pdc->TextOut(p0.x+50, p0.y+15*2, buf);
	}
	
	if (dim > 2)
	{
		sprintf(buf," %d  <= Z <=  %d",pDomDiv->Zs[i-1],pDomDiv->Ze[i-1]);
		pdc->TextOut(p0.x+50, p0.y+15*3, buf);
	}
	/*
	sprintf(buf,"Xaxis");
	pdc->TextOut(p0.x+6, p0.y+15, buf);
	sprintf(buf,"Ystart = %d  ->  %d",pDomDiv->Xs[i-1],pDomDiv->XsBound[i-1]);
	pdc->TextOut(p0.x+10, p0.y+15*2, buf);
	sprintf(buf,"Xend   = %d  ->  %d",pDomDiv->Xe[i-1],pDomDiv->XeBound[i-1]);
	pdc->TextOut(p0.x+10, p0.y+15*3, buf);

	if (dim > 1)
	{
		sprintf(buf,"Yaxis:");
		pdc->TextOut(p0.x+6, p0.y+15*4, buf);
		sprintf(buf,"Ystart = %d  ->  %d",pDomDiv->Ys[i-1],pDomDiv->YsBound[i-1]);
		pdc->TextOut(p0.x+10, p0.y+15*5, buf);
		sprintf(buf,"Yend   = %d  ->  %d",pDomDiv->Ye[i-1],pDomDiv->YeBound[i-1]);
		pdc->TextOut(p0.x+10, p0.y+15*6, buf);
	}
	
	if (dim > 2)
	{
		sprintf(buf,"Zaxis:");
		pdc->TextOut(p0.x+6, p0.y+15*7, buf);
		sprintf(buf,"Zstart = %d  ->  %d",pDomDiv->Zs[i-1],pDomDiv->ZsBound[i-1]);
		pdc->TextOut(p0.x+10, p0.y+15*8, buf);
		sprintf(buf,"Zend   = %d  ->  %d",pDomDiv->Ze[i-1],pDomDiv->ZeBound[i-1]);
		pdc->TextOut(p0.x+10, p0.y+15*9, buf);
	}
	*/
}
//******** OnDraw end *******************************

//******** 98.11.09 ****************************
//**********************************************
//******* CDomMeshInfo::OnAccess ***************
//******** begin *******************************
int CDomMeshInfo::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);

	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
	AppendDefaultMenu(psub);
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CDomMeshInfo::OnCommand(UINT id)
{
	return CPDEBase::OnCommand(id);
}
//******** end *******************************
////////////////////////////////////////////

///////////CDomCommInfo/////////////////////////////////////
//******** 98.11.09 ****************************
//**********************************************
//******* CDomCommInfo::CalcExt  ***************
//******** begin *******************************

int CDomCommInfo::CalcExt(dirMode dir)
{
	
	if(dir==dirDown) {
		POSITION pos = GetHeadPosition();
		while(pos) {
			GetNext(pos)->CalcExt(dir);
		}
	}
	CDomainDivPara *pDomDiv;
	pDomDiv = (CDomainDivPara*) GetParent();
	if(!pDomDiv->IsKindOf(RUNTIME_CLASS(CDomainDivPara))&& pDomDiv->GetCount()>1 ) {
		return TRUE;
	}
	int dim;
	dim = pDomDiv->dim_no; // dimention number
	//  Rect size change.
 
	int x = 220;
	int y = 45; /*dim = 1*/

	if (dim == 2) y = 70;
	if (dim == 3) y = 100;

	CRect rct( 0,  0, x, y);
	SetExtent(rct);
	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	return TRUE;
	/*
	CRect ext = m_extent;
	if(GetMode()!=modeOpen)
		return CPDEBase::CalcExt(dir);
	CalcExtVert(dir);
	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	CalcExtPost(dir, ext);
	return TRUE;
	*/


}
//********** CalcExt end ************************


//******** 98.11.11 *****************************
//**********************************************
//******* CDomCommInfo::OnCreated***************
//******** begin *******************************
BOOL CDomCommInfo::OnCreated(EnumOnCreated)
{
	SetMode(modeOpen);
	return 1;	
}
//******** end   *******************************
////////////////////////////////////////////////////

//******** 98.11.11 *****************************
//**********************************************
//******* CDomCommInfo::OnDraw   ***************
//******** begin *******************************
void CDomCommInfo::OnDraw(CDC *pdc, const CPoint& p)
{
	
	CPoint p0 = p;
	p0.Offset(GetOrg());
	pOrg = p0;

	DrawFold3D(pdc, p, m_bFocus? 0:1);
	pdc->SelectStockObject(BLACK_PEN);
	pdc->SelectStockObject(NULL_BRUSH);

	CRect rct = GetExtent();
	rct.OffsetRect(p0);
	pdc->Rectangle(&rct);
	

	// CHM ɂ CDomainDivPara ̃o[ϐ
	// QƂ̂
	CDomainDivPara *pDomDiv;
	pDomDiv = (CDomainDivPara*) GetParent();
	if(!pDomDiv->IsKindOf(RUNTIME_CLASS(CDomainDivPara))&& pDomDiv->GetCount()>1 ) {
		return;
	}
	CMSCInteger *pCurDom = (CMSCInteger *) pDomDiv->GetChild(2);
	if(!pCurDom->IsKindOf(RUNTIME_CLASS(CMSCInteger))) {
		return;
	}
	int i,dim;
	i = pCurDom->m_value;  //Current Domian No
	dim = pDomDiv->dim_no; // dimention number

	SetFont(pdc, 12, GetFont(), m_nCharSet, FALSE, 6);
	char buf[100];
	sprintf(buf,"Current Domain Commnication Information");
	pdc->TextOut(p0.x-3, p0.y-3, buf);

	SetFont(pdc, 13, GetFont(), m_nCharSet, FALSE, 7);
	CMSCInteger *pBundDom; 
	pBundDom = (CMSCInteger *) pDomDiv->GetChild(3); //Pointer of LEFT Boundary.
	if (pBundDom->m_value != -1) 
		sprintf(buf,"LEFT   <--->Domain No %d.RIGHT",pBundDom->m_value);
	else sprintf(buf,"LEFT   <---> Boundary");
	pdc->TextOut(p0.x, p0.y+15*1, buf);

	pBundDom = (CMSCInteger *) pDomDiv->GetChild(4); //Pointer of RIGTH Boundary.
	if (pBundDom->m_value != -1) 
		sprintf(buf,"RIGHT  <--->Domain No %d.LEFT",pBundDom->m_value);
	else sprintf(buf,"RIGHT  <---> Boundary");
	pdc->TextOut(p0.x, p0.y+15*2, buf);

	if (dim > 1){ //if model is 2 dimention.
		pBundDom = (CMSCInteger *) pDomDiv->GetChild(5); //Pointer of TOP Boundary.
		if (pBundDom->m_value != -1) 
			sprintf(buf,"TOP    <--->Domain No %d.BOTTOM",pBundDom->m_value);
		else sprintf(buf,"TOP    <---> Boundary");
		pdc->TextOut(p0.x, p0.y+15*3, buf);

		pBundDom = (CMSCInteger *) pDomDiv->GetChild(6); //Pointer of BOTTOM Boundary.
		if (pBundDom->m_value != -1) 
			sprintf(buf,"BOTTOM <--->Domain No %d.TOP",pBundDom->m_value);
		else sprintf(buf,"BOTTOM <---> Boundary");
		pdc->TextOut(p0.x, p0.y+15*4, buf);
	}

	if (dim >2){ //if model is 3 dimention.
		pBundDom = (CMSCInteger *) pDomDiv->GetChild(7); //Pointer of FRONT Boundary.
		if (pBundDom->m_value != -1) 
			sprintf(buf,"FRONT <--->Domain No %d.REAR",pBundDom->m_value);
		else sprintf(buf,"FRONT  <---> Boundary");
		pdc->TextOut(p0.x, p0.y+15*5, buf);

		pBundDom = (CMSCInteger *) pDomDiv->GetChild(8); //Pointer of REAR Boundary.
		if (pBundDom->m_value != -1) 
			sprintf(buf,"REAR   <--->Domain No %d.FRONT",pBundDom->m_value);
		else sprintf(buf,"REAR   <---> Boundary");
		pdc->TextOut(p0.x, p0.y+15*6, buf);
	}

}
//******** OnDraw end *******************************

//******** 98.11.09 ****************************
//**********************************************
//******* CDomCommInfo::OnAccess ***************
//******** begin *******************************
int CDomCommInfo::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);

	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
	AppendDefaultMenu(psub);
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CDomCommInfo::OnCommand(UINT id)
{
	return CPDEBase::OnCommand(id);
}
//******** end *******************************
////////////////////////////////////////////


////////////////////////////////////////////
IMPLEMENT_DYNCREATE(CJDFindClass, CJobDoer)

BOOL CJDFindClass::Do(CObject *ob) 
{
	if(ob->IsKindOf(m_pTarget)) {
		m_pResult = (CViecFC*) ob;
		return TRUE;
	}
	return FALSE;
}



