#include "stdafx.h"

#include <winsock2.h> // using  socket
#include <string.h>

#include "../elem/elem.h"
#include "../pad/PDE_MSG.h"
#include "../pad/PDE_PRG.h"
#include "../pad/PDE_ADV.H"
#include "../para/parapde.h"
#include "../para/resource.h"

#include "test.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(CTestApp, CWinApp)
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)	   //<-- menu on the base window menu
END_MESSAGE_MAP()

CTestApp::CTestApp()
{
}

CTestApp theApp;  //?????

extern AFX_EXT_DATA CGTemplate *s_pPadTemp;
extern "C" AFX_EXT_API void WINAPI InitLispMon();
extern "C" AFX_EXT_API void WINAPI InitPad();
extern "C" AFX_EXT_API void WINAPI InitElem();

CGTemplate *s_pPadParaTemp;

/// for server
class /*AFX_EXT_CLASS*/ CPadDocWithServer : public CPadDoc 
{
	DECLARE_DYNCREATE(CPadDocWithServer)
public:
	CPDEProblem *m_pProb;
	SOCKET m_waitSocket;
	SOCKET m_connectedSocket;
	struct sockaddr_in inAddr;
	struct sockaddr_in m_sockAddr;
	int m_err;
	HANDLE m_thread;
	DWORD m_tid;

	CPadDocWithServer();
	~CPadDocWithServer();   // 99.7.6 yanagi add
	virtual BOOL OnNewDocument();
	virtual void DeleteContents();
};

DWORD WINAPI WaitForAgent(LPVOID pv)
{
	int sz = sizeof(sockaddr_in);
	static char buf[10000];
	char num[50];
	CPadDocWithServer *pDoc = (CPadDocWithServer*) pv;
	FILE *fp;

	while(1) {
		try {
			listen(pDoc->m_waitSocket, 1);
			pDoc->m_connectedSocket = accept(pDoc->m_waitSocket, (PSOCKADDR) &pDoc->inAddr, &sz);
			//WSAGetLastError ();

			//Ń\Pbg҂stop
			sz = recv(pDoc->m_connectedSocket, buf, 10000, 0);
			if(sz == -1) continue;
			//\Pbgf[^󂯎B
//TRACE("AAAAA   sz=%d\n", sz);
			char *pT;
			pT = strstr(buf, "\r\n\r\n");
			//buf̒̕"  "̃p^[A擪|C^Ԃ֐
			//"\r\n\r\n"SET NX̌ɂ镶p^[
			//pTɂ"\r\n\r\n"̐擪|C^Ԃ
			/*
			if(pT == NULL){
				throw;
			}
			*/

			//fp = fopen("c:\\temp\\_com.tmp", "wb");

			if(strncmp(buf, "EXECUTE", 7)) {
				fp = fopen("..\\temp\\_com.tmp", "wb");  //fujita 990603
				if(!fp) throw;
				fwrite(pT+4, 1, sz - (pT-buf-4), fp);
				fclose(fp);
			}
			closesocket(pDoc->m_connectedSocket);
			pDoc->m_connectedSocket = NULL;
			//pDoc->m_waitSocket = NULL;
			//pDoc->m_thread = NULL;

			CPDEProblem *pProb;
			pProb = (CPDEProblem *) pDoc->m_pElemView->GetChild(0);
			*pT = 0;
			int ind_num;
			//strcpy(buf,"SET CPDEDepInfo");
			//strcpy(buf,"SET CPDEDepInfoDel");
			//strcpy(buf,"SET CPDESolvSet 3");
			//strcpy(buf,"EXECUTE RUN");
			//strcpy(buf,"EXECUTE AUTOMATIC_RUN");
			//strcpy(buf,"EXECUTE CREATE_PROGRAM");
			if(!strncmp(buf, "SET", 3)) {
				if(!strcmp(buf+4, "CPDEInfo")) {
					pProb->PostCmdQ(CMD_LOAD_PDE_PROB_INFO);
				} else if(!strcmp(buf+4, "CPDEMeshInfo")) {
					pProb->PostCmdQ(CMD_LOAD_PDE_MESH_INFO);
				} else if(!strcmp(buf+4, "CPDETimeVar")) {
					pProb->PostCmdQ(CMD_LOAD_PDE_TIME_INFO);
				} else if(!strcmp(buf+4, "CPDEDepInfo")) {
					pProb->PostCmdQ(CMD_LOAD_PDE_DEP_INFO);
				} else if(!strncmp(buf+4, "CPDESolvSet",11)) { //̔r
					strcpy(num,buf+16); //̑
					ind_num = atoi(num); //֕ϊB͉̐ԖڂCPDEDepInfo\킷B

					CPDEInfo *pInf;
					pInf = (CPDEInfo*) pProb->GetChild(0); //CPDEInfoNX̎擾
					if(!pInf->IsKindOf(RUNTIME_CLASS(CPDEInfo))) throw;

					POSITION pos,pos2;
					CViecFC *pOld;
					//CPDEInfo̎q𒲂ׂ
					pos = pInf->GetHeadPosition();
					while(pos){
						pOld = (CViecFC*) pInf->GetNext(pos);
						if(pOld->IsKindOf(RUNTIME_CLASS(CPDEDepInfo))){ 
							ind_num--;
							if(ind_num == 0) { //ind_numԖڂCPDEDepInfoNXSolvSetݒ肷B
								pOld->PostCmdQ(CMD_LOAD_PDE_SLV_SET);
								break;
							}
						}
					}
				} else if(!strcmp(buf+4, "CPDEDepInfoDel")) {
					pProb->PostCmdQ(CMD_LOAD_PDE_DEP_DEL);
				} else if(!strcmp(buf+4, "CPDEParaInfo")) {
					pProb->PostCmdQ(CMD_LOAD_PDE_PARA_INFO);
				}
			}
			//fujita 990603		
			if(!strncmp(buf, "EXECUTE", 7)) {
				if(!strcmp(buf+8, "RUN")) {
					pProb->PostCmdQ(CMD_PDE_RUN_SPREAD);
					Sleep(2000);
				} else if(!strcmp(buf+8, "AUTOMATIC_RUN")) {
					POSITION pos;
					CViecFC *pelm;
					pos = pProb->GetHeadPosition();
					while(pos){
						pelm = (CViecFC*) pProb->GetNext(pos);
						if(pelm->IsKindOf(RUNTIME_CLASS(CPDERunSpread))){
							pelm->PostCmdQ(CMD_RUN_AUTOMATIC);
							break;
						}
					}
				} else if(!strcmp(buf+8, "CREATE_PROGRAM")) {
					POSITION pos;
					CViecFC *pelm;
					pos = pProb->GetHeadPosition();
					while(pos){
						pelm = (CViecFC*) pProb->GetNext(pos);
						if(pelm->IsKindOf(RUNTIME_CLASS(CIElem))){ //check if split
							pelm = (CViecFC*) ((CIElem*) pelm)->GetBody();
						}
						if(pelm->IsKindOf(RUNTIME_CLASS(CPDEObjPrg))){
							pelm->PostCmdQ(CMD_RUN_CREATE_C);
							break;
						}
					}
				}

			}
		} catch(void) {
		}
	}
	return NULL;
}

IMPLEMENT_DYNCREATE(CPadDocWithServer, CPadDoc)

CPadDocWithServer::CPadDocWithServer()
{
	m_waitSocket = NULL;
	m_connectedSocket = NULL;
	m_thread = NULL;
}


CPadDocWithServer::~CPadDocWithServer()   // add 99.7.6 Yanagi
{
    WSACleanup();
	TRACE(" CPadDocWithServer end.");
	// ExitThread(m_thread);
}


BOOL CPadDocWithServer::OnNewDocument()
{
	if(!CPadDoc::OnNewDocument())
		return FALSE;
	m_pProb = (CPDEProblem *) m_pElemView->GetChild(0);
	try {
		m_waitSocket = socket(AF_INET, SOCK_STREAM, 0);
		if(m_waitSocket==NULL) throw;
		memset(&m_sockAddr, 0, sizeof(m_sockAddr));
		m_sockAddr.sin_port = htons(1000);
		m_sockAddr.sin_family = AF_INET;

		m_err = bind(m_waitSocket, (PSOCKADDR) &m_sockAddr, sizeof(m_sockAddr));
		if(m_err ==  SOCKET_ERROR) throw;
		m_err = listen(m_waitSocket, 10);
		if(m_err == SOCKET_ERROR) throw;
		m_thread = ::CreateThread(NULL, 0, WaitForAgent, this, 0, &m_tid);
	} catch(void) {
		MessageBox(NULL, "Can't open socket", "ERR", MB_OK);
		return FALSE;
	}
	return TRUE;
}


void CPadDocWithServer::DeleteContents( )
{
	if(m_thread!=NULL) CloseHandle(m_thread);
	if(m_connectedSocket) closesocket(m_connectedSocket);
	if(m_waitSocket) closesocket(m_waitSocket);
	m_waitSocket = NULL;
	m_connectedSocket = NULL;
	m_thread = NULL;
	CPadDoc::DeleteContents();

}

BOOL CTestApp::InitInstance()
{
	CMDIFrameWnd* pMainFrame = new CMDIFrameWnd;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	WSADATA ws;
	WSAStartup(1, &ws); // setting before using socket
//	InitLispMon();
	InitElem();
	InitPad();  //ev[gݒ肷B

	
	
	s_pPadTemp = new CGTemplate(IDR_PAD,
			//RUNTIME_CLASS(CPadDoc),
			RUNTIME_CLASS(CPadDocWithServer),
			RUNTIME_CLASS(CGFrame),
			RUNTIME_CLASS(CGView));
	AddDocTemplate(s_pPadTemp);  // CHM 1999.01.31
	
	/*
	s_pPadParaTemp = new CGTemplate(IDR_PAD_PARA,
			RUNTIME_CLASS(CParaDoc),
			RUNTIME_CLASS(CGFrame),
			RUNTIME_CLASS(CGView));
	AddDocTemplate(s_pPadParaTemp);
	*/

	//
	//CParaDoc *pDoc = (CParaDoc*) s_pPadParaTemp->OpenDocumentFile(NULL); // CHM 1999.01.31
	//CPadDoc *pDoc = (CPadDoc*) s_pPadTemp->OpenDocumentFile(NULL); //fujita 1999.06.01
	CPadDocWithServer *pDoc = (CPadDocWithServer*) s_pPadTemp->OpenDocumentFile(NULL); //fujita 1999.06.01
	//CPadDocOpenB

	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();


	//
	//CPDEPrbPara *pPara = (CPDEPrbPara *) pDoc->m_pElemView->GetChild(0); // CHM 1999.01.31
	//pPara->PostCmdQ(CMD_LOAD_OBJECT); // CHM 1999.01.31
	//
	return TRUE;
}
