#include "stdafx.h"

#include "pde_adv.h"
#include "jd_utl.h"

//#include "pde_msg.h"
IMPLEMENT_ELEM(CJDAlgManip,  CJobDoer, 222)
//fujita 98/12/08

CJDAlgManip::CJDAlgManip()
{
	m_bStartFg = FALSE;
	m_cManipCnt = 0;
	for(int i=0;i<4;i++) {
		m_shift[i].m_value = 0;
		m_shift[i].m_deno = 1;
	}
	m_target.m_theDep = NULL;
	m_target.m_timeIndex = NULL;
	m_target.m_timeShift.m_value = 0;
}

//////////////////////  CJDCheckIfEqual  /////////////////////////
//////////////////////  CJDCheckIfEqual  /////////////////////////

BOOL CJDCheckIfEqual::Do(CObject *g)
{
	CSymbInst *pInst;
	pInst = (CSymbInst *) g;

	m_bResult=TRUE;
	if(!m_checked)	goto false_label;
	if(pInst->GetRuntimeClass()!=m_checked->GetRuntimeClass()) goto false_label;
	if(pInst->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
		CSymbInst *pIn2;
		CViecFC *pE1, *pE2;
		POSITION pos1, pos2;

		pIn2 = (CSymbInst *) m_checked;
		if(pInst->GetCount()!=pIn2->GetCount()) goto false_label;
		if(pInst->GetSymbBody()!=pIn2->GetSymbBody()) goto false_label;
		pos1 = pInst->GetHeadPosition();
		pos2 = pIn2->GetHeadPosition();
		while(pos1) {
			pE1 = pInst->GetNext(pos1);
			pE2 = pIn2->GetNext(pos2);
			m_checked = pE2;
			pE1->SendMsg(MSG_DO_JOB, this);
			if(!m_bResult) goto false_label;
		}
		m_checked = pIn2;
		return TRUE;
	}
	if(pInst->IsKindOf(RUNTIME_CLASS(CMSFract))) {
		CMSFract *pF1, *pF2;
		pF1 = (CMSFract *) pInst;
		pF2 = (CMSFract *) m_checked;
		if(pF1->m_value!=pF2->m_value) goto false_label;
		if(pF1->m_value)
			if(pF1->m_deno!=pF2->m_deno) goto false_label;
		return TRUE;
	}
false_label:
	m_bResult = FALSE;
	return TRUE;
}

/////////////////////////  CTargetDep  /////////////////////////
/////////////////////////  CTargetDep  /////////////////////////

BOOL CTargetDep::Copy(CTargetDep *pT)
{
	m_theDep = pT->m_theDep;
	m_timeIndex = pT->m_timeIndex;
	m_timeShift.m_value = pT->m_timeShift.m_value;
	m_timeShift.m_deno = pT->m_timeShift.m_deno;
	return TRUE;
}

BOOL CTargetDep::IsThis(CSymbInst *pI1)
{
	CSymbInst *pxI, *pxP;
	CViecFC *pS1, *pxS;
	CMSFract *pxF;
	POSITION pos;

	if(pI1->IsKindOf(RUNTIME_CLASS(CSymbInst)) && pI1->GetCount()>0) {
		pS1 = pI1->GetSymbBody();
		pos = pI1->GetHeadPosition();
		pxI = (CSymbInst *) pI1->GetNext(pos);
		if(pxI->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
			pxS = pxI->GetSymbBody();
			if(m_timeShift.m_value==0) {
				if(pS1==m_theDep && pxS==m_timeIndex)
					return TRUE;
			} else {
				pxP = pxI;
				if(pxP->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus)) &&
					pxP->GetCount()==2) {
					pos = pxP->GetHeadPosition();
					pxI = (CSymbInst *) pxP->GetNext(pos);
					pxF = (CMSFract *) pxP->GetNext(pos);
					if(pxI->IsKindOf(RUNTIME_CLASS(CSymbInst)) &&
						pxF->IsKindOf(RUNTIME_CLASS(CMSFract))) {
						if(pxI->GetSymbBody()==m_timeIndex &&
							pxF->m_value==m_timeShift.m_value &&
							pxF->m_deno==m_timeShift.m_deno)
							return TRUE;
					}
				}
			}
		}
	}
	return FALSE;
}

BOOL CTargetDep::IsIncluded(CSymbInst *pI)
{
	POSITION pos;
	if(!pI->IsKindOf(RUNTIME_CLASS(CSymbInst)))
		return FALSE;
	if(IsThis(pI))
		return TRUE;
	pos = pI->GetHeadPosition();
	while(pos)
		if(IsIncluded((CSymbInst *) pI->GetNext(pos)))
			return TRUE;
	return FALSE;
}

