#include "stdafx.h"
//#include <afxdllx.h>

#include "resource.h"
//#include "../pad/pad.h"
//#include "../pad/pad_msg.h"

#include "Parapad.h"

//fujita create at 98/12/09
//IMPLEMENT_ELEM(CPDCallBy, CPad, 5101)
IMPLEMENT_ELEM(CPDFunction  , CPad, 5102)
IMPLEMENT_ELEM(CPDOutput_txt  , CPad, 5103)
//fujita create at 98/12/25
IMPLEMENT_ELEM(CPDMpi_Isend , CPad, 5104)


///CPDMpi_Isend//////////////////////////////////////////
void CPDMpi_Isend::OnDraw(CDC *pdc, const CPoint& p)
{
	COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
	CRect rct = m_RName;

	rct.left += 1; rct.right -=1;
	rct.bottom -= 1;
	rct.OffsetRect(GetOrg());
	rct.OffsetRect(p);
	SetPen(pdc, PS_SOLID, 2, col);
	pdc->SelectStockObject(NULL_BRUSH);
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	pdc->SetTextColor(col);
	pdc->Rectangle(&rct);

	SetPen(pdc, PS_SOLID, 1, col);
	pdc->MoveTo(rct.left+3, rct.top);
	pdc->LineTo(rct.left+3, rct.bottom);
	pdc->MoveTo(rct.right-5, rct.top);
	pdc->LineTo(rct.right-5, rct.bottom);

	CPoint p0 = p;
	p0.Offset(GetOrg());
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	CSize sz = pdc->GetTextExtent("MPI_Isend", 9);
	p0.x += 8 + s_merginX;
	pdc->TextOut(p0.x, p0.y-sz.cy/2, "MPI_Isend");

	POSITION pos;
	pos = GetHeadPosition();
	CPDArgs *parg = (CPDArgs *) GetNext(pos);
	CPoint pp = p;
	pp.Offset(GetOrg());
	parg->OnDraw(pdc, pp);

	pdc->SetTextColor(col);
}

int CPDMpi_Isend::CalcExt(dirMode dir)
{
	CRect ext = GetExtent();

	CDC *pdc = GetDC();
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	CSize sz = pdc->GetTextExtent("MPI_Isend", 9);
	ReleaseDC(pdc);

	POSITION pos = GetHeadPosition();
	CPDArgs *parg = (CPDArgs *) GetNext(pos);
	if(dir==dirDown)
		parg->CalcExt(dir);
	parg->SetOrg(CPoint(8 + s_merginX + sz.cx, 0));
	m_RName.left = 0;
	m_RName.right = sz.cx;
	m_RName.top = -(sz.cy-1)/2;
	m_RName.bottom = sz.cy/2;
	m_RName.right += s_merginX*2 + 16 + parg->GetExtent().Width();
	if(parg->GetExtent().top<m_RName.top)
		m_RName.top = parg->GetExtent().top;
	if(parg->GetExtent().bottom>m_RName.bottom)
		m_RName.bottom = parg->GetExtent().bottom;
	m_RName.top -= s_merginY + 2;
	m_RName.bottom += s_merginY + 2;
	m_extent = m_RName;
	if(dir==dirUp) GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return 1;
}
/////////////////////////////////////////////////////////////////

///CPDOutput_txt//////////////////////////////////////////
///
void CPDOutput_txt::OnDraw(CDC *pdc, const CPoint& p)
{
	COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
	CRect rct = m_RName;

	rct.left += 1; rct.right -=1;
	rct.bottom -= 1;
	rct.OffsetRect(GetOrg());
	rct.OffsetRect(p);
	SetPen(pdc, PS_SOLID, 2, col);
	pdc->SelectStockObject(NULL_BRUSH);
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	pdc->SetTextColor(col);
	pdc->Rectangle(&rct);

	SetPen(pdc, PS_SOLID, 1, col);
	pdc->MoveTo(rct.left+3, rct.top);
	pdc->LineTo(rct.left+3, rct.bottom);
	pdc->MoveTo(rct.right-5, rct.top);
	pdc->LineTo(rct.right-5, rct.bottom);

	CPoint p0 = p;
	p0.Offset(GetOrg());
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	CSize sz = pdc->GetTextExtent("print", 6);
	p0.x += 8 + s_merginX;
	pdc->TextOut(p0.x, p0.y-sz.cy/2, "print");

	POSITION pos;
	pos = GetHeadPosition();
	CPDArgs *parg = (CPDArgs *) GetNext(pos);
	CPoint pp = p;
	pp.Offset(GetOrg());
	parg->OnDraw(pdc, pp);

	pdc->SetTextColor(col);
}

int CPDOutput_txt::CalcExt(dirMode dir)
{
	CRect ext = GetExtent();

	CDC *pdc = GetDC();
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	CSize sz = pdc->GetTextExtent("print", 6);
	ReleaseDC(pdc);

	POSITION pos = GetHeadPosition();
	CPDArgs *parg = (CPDArgs *) GetNext(pos);
	if(dir==dirDown)
		parg->CalcExt(dir);
	parg->SetOrg(CPoint(8 + s_merginX + sz.cx, 0));
	m_RName.left = 0;
	m_RName.right = sz.cx;
	m_RName.top = -(sz.cy-1)/2;
	m_RName.bottom = sz.cy/2;
	m_RName.right += s_merginX*2 + 16 + parg->GetExtent().Width();
	if(parg->GetExtent().top<m_RName.top)
		m_RName.top = parg->GetExtent().top;
	if(parg->GetExtent().bottom>m_RName.bottom)
		m_RName.bottom = parg->GetExtent().bottom;
	m_RName.top -= s_merginY + 2;
	m_RName.bottom += s_merginY + 2;
	m_extent = m_RName;
	if(dir==dirUp) GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return 1;
}
//////////////////////////////////////////////////////////////////////

/*
// CPDCallBy ////////////////////////////////////////
int CPDCallBy::CalcExt(dirMode dir)
{
	CRect ext = GetExtent();

	CDC *pdc = GetDC();
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	CSize sz = pdc->GetTextExtent(GetName(), lstrlen(GetName()));
	ReleaseDC(pdc);

	POSITION pos = GetHeadPosition();
	CPDArgs *parg = (CPDArgs *) GetNext(pos);
	if(dir==dirDown)
		parg->CalcExt(dir);
	parg->SetOrg(CPoint(8 + s_merginX + sz.cx, 0));
	m_RName.left = 0;
	m_RName.right = sz.cx;
	m_RName.top = -(sz.cy-1)/2;
	m_RName.bottom = sz.cy/2;
	m_RName.right += s_merginX*2 + 16 + parg->GetExtent().Width();
	if(parg->GetExtent().top<m_RName.top)
		m_RName.top = parg->GetExtent().top;
	if(parg->GetExtent().bottom>m_RName.bottom)
		m_RName.bottom = parg->GetExtent().bottom;
	m_RName.top -= s_merginY + 2;
	m_RName.bottom += s_merginY + 2;
	m_extent = m_RName;
	if(dir==dirUp) GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return 1;
}

void CPDCallBy::OnDraw(CDC *pdc, const CPoint& p)
{
	COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
	CRect rct = m_RName;

	rct.left += 1; rct.right -=1;
	rct.bottom -= 1;
	rct.OffsetRect(GetOrg());
	rct.OffsetRect(p);
	SetPen(pdc, PS_SOLID, 2, col);
	pdc->SelectStockObject(NULL_BRUSH);
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	pdc->SetTextColor(col);
	pdc->Rectangle(&rct);

	SetPen(pdc, PS_SOLID, 1, col);
	pdc->MoveTo(rct.left+3, rct.top);
	pdc->LineTo(rct.left+3, rct.bottom);
	pdc->MoveTo(rct.right-5, rct.top);
	pdc->LineTo(rct.right-5, rct.bottom);

	CPoint p0 = p;
	p0.Offset(GetOrg());
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	CSize sz = pdc->GetTextExtent(GetName(), lstrlen(GetName()));
	p0.x += 8 + s_merginX;
	pdc->TextOut(p0.x, p0.y-sz.cy/2, GetName());

	POSITION pos;
	pos = GetHeadPosition();
	CPDArgs *parg = (CPDArgs *) GetNext(pos);
	CPoint pp = p;
	pp.Offset(GetOrg());
	parg->OnDraw(pdc, pp);

	pdc->SetTextColor(col);
}
*/

//CPDFunction //////////////////////////////////////////////
int CPDFunction::CalcExt(dirMode dir)
{
	CRect ext = GetExtent();

	CDC *pdc = GetDC();
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	CSize sz = pdc->GetTextExtent(GetName(), lstrlen(GetName()));
	ReleaseDC(pdc);

	POSITION pos = GetHeadPosition();
	CPDArgs *parg = (CPDArgs *) GetNext(pos);
	if(dir==dirDown)
		parg->CalcExt(dir);
	parg->SetOrg(CPoint(8 + s_merginX + sz.cx, 0));
	m_RName.left = 0;
	m_RName.right = sz.cx;
	m_RName.top = -(sz.cy-1)/2;
	m_RName.bottom = sz.cy/2;
	m_RName.right += s_merginX*2 + 16 + parg->GetExtent().Width();
	if(parg->GetExtent().top<m_RName.top)
		m_RName.top = parg->GetExtent().top;
	if(parg->GetExtent().bottom>m_RName.bottom)
		m_RName.bottom = parg->GetExtent().bottom;
	m_RName.top -= s_merginY + 2;
	m_RName.bottom += s_merginY + 2;
	m_extent = m_RName;
	if(dir==dirUp) GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return 1;
}
/*
	CDC *pdc = GetDC();
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	CSize sz = pdc->GetTextExtent(m_name, lstrlen(m_name));
	ReleaseDC(pdc);

//	POSITION pos = GetHeadPosition();
//	CPDArgs *parg = (CPDArgs *) GetNext(pos);
//	parg->SetOrg(CPoint(8 + s_merginX + sz.cx, 0));
//	int wd = parg->GetExtent().Width();
	int wd = 0;
	m_RName.left = 0;
	m_RName.right = sz.cx;
	m_RName.top = -(sz.cy-1)/2;
	m_RName.bottom = sz.cy/2;
	m_RName.right += s_merginX*2 + 16 + wd;
	m_RName.top -= s_merginY + 2;
	m_RName.bottom += s_merginY + 2;

	m_extent = m_RName;
	return 1;
}
*/

void CPDFunction::OnDraw(CDC *pdc, const CPoint& p)
{
	COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
	CRect rct = m_RName;

	rct.left += 1; rct.right -=1;
	rct.bottom -= 1;
	rct.OffsetRect(GetOrg());
	rct.OffsetRect(p);
	SetPen(pdc, PS_SOLID, 2, col);
	pdc->SelectStockObject(NULL_BRUSH);
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	pdc->SetTextColor(col);
	pdc->Rectangle(&rct);

	SetPen(pdc, PS_SOLID, 1, col);
	pdc->MoveTo(rct.left+3, rct.top);
	pdc->LineTo(rct.left+3, rct.bottom);
	pdc->MoveTo(rct.right-5, rct.top);
	pdc->LineTo(rct.right-5, rct.bottom);

	CPoint p0 = p;
	p0.Offset(GetOrg());
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	CSize sz = pdc->GetTextExtent(GetName(), lstrlen(GetName()));
	p0.x += 8 + s_merginX;
	pdc->TextOut(p0.x, p0.y-sz.cy/2, GetName());

	POSITION pos;
	pos = GetHeadPosition();
	CPDArgs *parg = (CPDArgs *) GetNext(pos);
	CPoint pp = p;
	pp.Offset(GetOrg());
	parg->OnDraw(pdc, pp);

	pdc->SetTextColor(col);
}
//CPDFunction end///////////////////////////////////////////////////////