
#ifndef ___ParaPDE_H___
#define ___ParaPDE_H___

#ifndef __JD_PRCPara_H__
#include "ParaJD_PRC.h"
#endif


#define CMD_PARA		0xB000

#define CMD_DOM_DIV_PARA	CMD_PARA | 0x0001
#define CMD_DOM_CUR_DOMAIN	CMD_PARA | 0x0002
#define CMD_DOM_ZLEVEL_INC  CMD_PARA | 0x0003 
#define CMD_DOM_ZLEVEL_DEC  CMD_PARA | 0x0004

class AFX_EXT_CLASS CPDEPrbPara : public CPDEProblem {
	DECLARE_ELEM(CPDEPrbPara)
public:
	virtual int OnCommand(UINT id);
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
};


// ******* 98.10.26 *********
// Remove the Menu "domain division for // " from CPDEInfoPara class.
// The Menu move to CPDEdepInfoPara class.
class AFX_EXT_CLASS CPDEInfoPara : public CPDEInfo {
	DECLARE_ELEM(CPDEInfoPara)
	virtual int OnAccess(CPoint *pp);
	virtual int OnCommand(UINT id);
};

class AFX_EXT_CLASS CParaDoc : public CGMainDoc
{
	DECLARE_DYNCREATE(CParaDoc)
	virtual BOOL OnNewDocument();
};

class AFX_EXT_CLASS CJDFindClass : public CJobDoer {
	DECLARE_DYNCREATE(CJDFindClass)
public:
	CRuntimeClass *m_pTarget;
	CViecFC *m_pResult;
	virtual BOOL Do(CObject *);
};

// ***** 98.10.26 ***********
// Dempendend Information Parallel class
class AFX_EXT_CLASS CDomainDivPara : public CPDEBase {
	DECLARE_ELEM(CDomainDivPara)
public:
	int m_xdiv,m_ydiv,m_zdiv,m_Max_CPU; //pۂɕۑׂlAŎQƂ邱ƂB
	int cur_x, cur_y, cur_z;
	int dim_no, cur_dom_no;
	int zlevel;
	int *Msize_x, *Msize_y, *Msize_z;
	int Asize_x, Asize_y, Asize_z;
	int div_no_x, div_no_y, div_no_z;
	int wd_x, wd_y, wd_z;
	int div_wd_x[50], div_wd_y[50], div_wd_z[50];
	int *Xs,*Xe,*XsBound,*XeBound;
	int *Ys,*Ye,*YsBound,*YeBound;
	int *Zs,*Ze,*ZsBound,*ZeBound;
	CPoint pOrg;

	void FacingCalc();
	void Cur_Domain_Info_Calc();
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
	virtual int CalcExt(dirMode d=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int OnAccess(CPoint *pp);
	virtual int OnCommand(UINT id);
	virtual BOOL SendMsg(int msg, CObject* el);
};

//////// fujita 98/05/01 //////////////////////
class AFX_EXT_CLASS CMSCParaInt : public CMSCInteger {
	DECLARE_ELEM(CMSCParaInt)
public:
	virtual int OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags); 
		//{return CMSConst::OnKeyDown(nChar, nRepCnt, nFlags);};
};

class AFX_EXT_CLASS CDomMeshInfo : public CDomainDivPara {
	DECLARE_ELEM(CDomMeshInfo)
public:
	//int Xs,Xe,Ys,Ye,Zs,Ze;
	//int XsBound,XeBound,YsBound,YeBound,ZsBound,ZeBound;
	virtual int CalcExt(dirMode d=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int OnAccess(CPoint *pp);
	virtual int OnCommand(UINT id);
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
};

/////////// fujiaki 98/11/11 ///////////////////////
////////// CDomCommInfo class //////////////////////
class AFX_EXT_CLASS CDomCommInfo : public CDomainDivPara {
	DECLARE_ELEM(CDomCommInfo)
public:
	//int Xs,Xe,Ys,Ye,Zs,Ze;
	//int XsBound,XeBound,YsBound,YeBound,ZsBound,ZeBound;
	virtual int CalcExt(dirMode d=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int OnAccess(CPoint *pp);
	virtual int OnCommand(UINT id);
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
};

#endif
